	subroutine initarrays
c+
c       Startvalues for all important arrays.
c
c       Version : 1.0
c       Date    : 02 Oct 96
c
c       Authors : R.B. Neder  (neder@yoda.kri.physik.uni-muenchen.de)
c                 Th. Proffen (proffen@rsc.anu.edu.au)
c-
	implicit  	none
c
	include 	'config.inc'
	include 	'atom_env.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
	include 	'microdis.inc'
	include 	'microsta.inc'
	include 	'output.inc'
	include 	'patters.inc'
	include 	'plot.inc'
	include 	'stack.inc'
	include 	'symm.inc'
	include 	'waves.inc'
	include 	'rmc.inc'
	include 	'chem.inc'
	include 	'diffuse.inc'
c
	integer		i,j,k
        integer         stift(0:4)
c
        data    stift   /5,3,1,2,4/
c
c------ common  /at_env/ 
c
	do i=1,MAX_ATOM_ENV
	  atom_env(i)=0.0
	enddo
c
c------	common
c
	cr_at_lis(0)='VOID'
	as_at_lis(0)='VOID'
	cr_scat_int(0)=.true.
	cr_delf_int(0)=.true.
	do i=1,MAXSCAT
	  cr_at_lis(i)='    '
	  as_at_lis(i)='    '
	  cr_scat_int(i)=.true.
	  cr_delf_int(i)=.true.
	enddo
c
c------	common /errors/
c
	ier_num = 0
	ier_typ = ER_NONE
	ier_sta = ER_S_CONT
	do i=1,3
	  ier_msg(i) = ' '
	enddo
c
c------	common /fourier_cmm/
c
	lxray   =.true.
	ano     =.false.
	ldbw    =.false.
	lambda  ='CUA1'
	rlambda =1.5405
c
	eck(1,1)=-0.5
	eck(2,1)=-0.5
	eck(3,1)= 0.0
	eck(1,2)= 5.5
	eck(2,2)=-0.5
	eck(3,2)= 0.0
	eck(1,3)=-0.5
	eck(2,3)= 5.5
	eck(3,3)= 0.0
c
	inc(1)  = 121
	inc(2)  = 121
c
	vi(1,1) = 0.05
	vi(2,1) = 0.00
	vi(3,1) = 0.00
	vi(1,2) = 0.00
	vi(2,2) = 0.05
	vi(3,2) = 0.00
c
c------	common /microdef/ 
c
	mv_cont   = MD_STRUC
	mv_orient = 1
	mv_rad    = 10.0
	mv_rad_si = 0.0
c
	do i=1,MAX_MD_HKL
	  mvv_rad(i)    = 10.0
	  mvv_rad_si(i) = 0.0
	enddo
	mv_hkl_n = 0
c
	do i=1,MAX_MD_HKL
	  do j=1,3
	    mv_hkl(j,i)=0.0
	  enddo
	enddo
c
	mv_bound = MD_FACE
	mv_unit  = MD_ANG
	mv_file  = ' '
c
c------ common /microdis/
c
	md_num     = 0
	md_num_cre = 0
	md_num_run = 0
	md_distr   = MD_PARA
	md_dens    = 0.1
	md_grid    = MD_G_HOST
c
	do i=1,4
	  do j=0,MAX_MD_TY
	    md_ty_fl(i,j)=0
	  enddo
	enddo
c
	md_hkl_n(0)=0
	do i=1,MAX_MD_TY
	  md_hkl_n(i)=0
	enddo
c
	md_ori_n   = 1
	md_log_pos = .false.
	md_sep_fuz = 0.5
c
	do i=0,MAX_MD_TY
	  do j=0,MAX_MD_TY
	    md_corr(i,j)=0.0
	  enddo
	enddo
c
	do i=1,3
	  md_shift(i)=0.0
	  do j=1,3
	    md_base(i,j)=0.0
	    md_si  (i,j)=0.0
	  enddo
	enddo
c
	do i=1,3
	  do j=1,MAX_MD_HKL
	    do k=0,MAX_MD_TY	
	      md_hkl(i,j,k)=0.0
	    enddo
	  enddo
	enddo
c
	do i=1,4
	  do j=1,4
	    do k=1,MAX_MD_ORI
	      md_orient(i,j,k)=0.0
	      md_or_inv(i,j,k)=0.0
	    enddo
	  enddo
	enddo
c
	do i=0,MAX_MD_HKL
	  do j=0,MAX_MD_TY
	    md_rad(i,j)=0.0
	  enddo
	enddo
c
	do i=1,MAX_MD_HKL
	  do j=0,MAX_MD_TY
	    md_rad_si(i,j)=0.0
	  enddo
	enddo
c
	do i=1,3
	  do j=1,3
	    md_rbase(i,j)=0.0
	  enddo
	enddo
c
	do i=0,MAX_MD_TY
	  md_co_fi(i)=' '
	enddo
c
c------ common /microsta/
c
	cmic_s(0) = 'Microdomains and host structure  '
	cmic_s(1) = 'Only atoms outside microdomains  '
	cmic_s(2) = 'Only atoms inside any microdomain'
	cmic_s(3) = 'Only atoms inside microdomains:  ' 
c
c------ common /microlis/
c
	mc_num     = 0
	mc_num_run = 0
c
	do i=0,MC_MAX_MICRO
	  mc_type(i)=0
	enddo
c
	do j=0,MC_MAX_MICRO
	  mc_rad(j)=0.0
	  do i=1,3
	    mc_orig(i,j)=0.0
	  enddo
	enddo
c
c------ common /output/
c
	outfile    = 'fcalc.dat'
	ityp       = 0
	extr_abs   = 1
	extr_ord   = 2
c
	rho_extr_abs = 1
	rho_extr_ord = 2
c
c------ common /patters/
c
	rho_inc(1) = 51
	rho_inc(2) = 51
c
	rho_eck(1,1) = 0.0
	rho_eck(2,1) = 0.0
	rho_eck(3,1) = 0.0
	rho_eck(1,2) = 1.0
	rho_eck(2,2) = 0.0
	rho_eck(3,2) = 0.0
	rho_eck(1,3) = 0.0
	rho_eck(2,3) = 1.0
	rho_eck(3,3) = 0.0
c
	rho_vi (1,1) = 0.02
	rho_vi (2,1) = 0.00
	rho_vi (3,1) = 0.00
	rho_vi (1,2) = 0.00
	rho_vi (2,2) = 0.02
	rho_vi (3,2) = 0.00
c
	rho_type(1)  = 4
	rho_type(2)  = 5
	rho_file(1)  = ' '
	rho_file(2)  = ' '
c
	patt_scale   = 1.0
	patt_accu    = 0
	patt_sign    = -1
c
c------	common /plotting/ 
c
	pl_col    = 'xyz'
	pl_prog   = 'kupl'
	pl_md_nr  = 0
	pl_md_s   = 0
	pl_out    = 'plot.dat'
	pl_dens   = .false.
c
	do i=0,MAXSCAT
	  pl_latom(i)=.false.
	  pl_color(i)=stift(mod(i,5))
	  pl_typ(i)=3
 	  pl_siz(i)=1.0
	enddo
c
	do i=1,3
	  do j=1,2
	    pl_dim(i,j)=0.0
	  enddo
	enddo
c
c------	common  /qspace/
c
	ps_high   = 1.2
	ps_low    = 0.01
c
c------ common /stack_fault/
c
	st_nlayer = 0
	st_ntypes = 0
	st_nchem  = 0
	st_aver   = 0.0
	st_mod_sta  = .false.
	st_tra_aver = .false.
	st_prob     = 0.0
	st_rot_mode      = .false.
	st_rot_status    = .false.
	st_rot_no_lspace = .true.
	st_rot_m1_lspace = .true.
	st_rot_m2_lspace = .true.
	st_rot_si_no     = 0.0
	st_rot_si_m1     = 0.0
	st_rot_si_m2     = 0.0
c
	do i=1,3
	  do j=1,3
	    st_mod(i,j) = 0.0
	  enddo
	  st_t_aver   (i) = 0.0
	  st_off      (i) = 0.0
	  st_sigma_off(i) = 0.0
	  st_rot_no   (i) = 0.0
	  st_rot_m1   (i) = 0.0
	  st_rot_m2   (i) = 0.0
	enddo
c
	do i=1,ST_MAXTYPE
	  st_layer  (i) = ' '
	  st_layer_c(i) = ' '
	  st_llayer (i) = 0
	  st_number (i) = 0
	  st_ndisp  (i) = 0
	  st_chem   (i) = 0
	  do j=1,ST_MAXTYPE
	    st_corr(i,j) = 0.0
	    do k=1,3
	      st_sigma(i,j,k) = 0.0
	      st_trans(i,j,k) = 0.0
	    enddo
	  enddo
	  do j=1,3
	    st_disp  (j,i) = 0.0
	  enddo
	enddo
c
	do i=1,ST_MAXLAYER
	  st_type      (i) = 0
	  st_rot_ang_no(i) = 0.0
	  st_rot_ang_m1(i) = 0.0
	  st_rot_ang_m2(i) = 0.0
	  do j=1,3
	    st_origin(j,i) = 0.0
	  enddo
	enddo
c
c------ common /symm_par/
c
	sym_md_nr = 0
	sym_md_s  = 0
	sym_start = 0
	sym_end   = 0
	sym_power = 1
c
	do i=0,MAXSCAT
	  sym_latom(i) = .false.
	enddo
c
	sym_mode       = .true.
	sym_power_mult = .true.
	sym_type       = .true.
	sym_angle      = 0.0
c
	do i=1,3
	  sym_hkl(i)   = 0.0
	  sym_orig(i)  = 0.0
	  sym_trans(i) = 0.0
	  sym_uvw(i)   = 0.0
	enddo
c
c------	common /waves_cmm/
c
	wave(1)  = 1.0
	wave(2)  = 0.0
	wave(3)  = 0.0
c
	iwave    = 1
	rlam     = 50.0
	amp      = 0.5
	amp0     = 0.0
	plow     = 0.0
	phigh    = 1.0
c
	wv_md_nr     = 0
	wv_phase_typ = WV_FIX
c
	do i=0,MAXSCAT
	  w_latom(i)=.false.
	  w_repl(i) = 0
	enddo
c
	lacoust   = .true.
	swing(1)  = 0.0
	swing(2)  = 1.0
	swing(3)  = 0.0
	phase     = 0.0
	wv_md_s   = 0
	wv_func   = 'sinu'
c
c------	common	/chem/ 
c
	chem_fname        = 'blen.xy'
	chem_outfile      = 'chem.log'
	chem_io           = 6
	chem_blen_cut(1)  = 2.5
	chem_blen_cut(2)  = 7.5
	chem_freq_sigma   = 0.05
	chem_wink_sigma   = 0.05
	chem_bin          = 250
	chem_quick        = .true.
        chem_cang         = .false.
        chem_csym         = .false.
c
c------	common	/rmbl/
c
	rmc_display  = 500
	rmc_maxcyc   = 5000
	rmc_mode     = RMC_MODE_SHIFT
	rmc_nplane   = 0
	rmc_calc_f   = .TRUE.
	rmc_doskal   = .FALSE.
	rmc_doback   = .FALSE.
	rmc_dosym    = .FALSE.
	rmc_log      = .FALSE.
	rmc_sigma    = 0.01
	rmc_ave      = 0.0
        rmc_qmin     =  9999.0
        rmc_qmax     = -9999.0
	rmc_data     = RMC_DATA_NIPL
	rmc_local    = RMC_LOCAL_ALL
c
	rmc_allowed(0)=.TRUE.
	rmc_maxmove(1,0)=0.0
	rmc_maxmove(2,0)=0.0
	rmc_maxmove(3,0)=0.0
	do i=1,MAXSCAT
	  rmc_allowed(i)=.TRUE.
	  rmc_maxmove(1,i)=0.2
	  rmc_maxmove(2,i)=0.2
	  rmc_maxmove(3,i)=0.2
	  do j=1,MAXSCAT
	    rmc_mindist(i,j)=0.5
	  enddo
	enddo
c
	do i=1,RMC_MAX_PLANES
	  rmc_fname(i)     = ' '
	  rmc_num(1,i)     = 0
	  rmc_num(2,i)     = 0
	  rmc_ldbw(i)      = .FALSE.
	  rmc_ano(i)       = .FALSE.
	  rmc_skal(i)      = 1.0
	  rmc_back(i)      = 0.0
	  rmc_wic_typ(i)   = RMC_WIC_EINS
	  rmc_constrain(i) = i
	enddo
c
c------ common /diffuse/
c
	ffour   = .FALSE.
	lperiod = .TRUE.
	ilots   = LOT_OFF
	nlots   = 1
	fave    = 0.0
c
	do i=1,3
	  ls_xyz(i) = 5
	enddo
c
      	end
c*****7********************************************************************
	subroutine autodef
c-
c	Tries to open a default file for the integer and real variables
c+
	include      'envir.inc'
	include      'errlist.inc'
	include      'param.inc'
c
	integer      idef
c
	data         idef/34/
c
	ier_num = 0
	ier_typ = ER_NONE
	call open_def(idef)
	if(ier_num.eq.0) then
	  ier_num = -3
	  ier_typ = ER_IO
	  read(idef,*,end=998,err=998) inpara
	  read(idef,*,end=998,err=998) rpara
	endif
	ier_num = 0
	ier_typ = ER_NONE
998	continue
	if(ier_num.ne.0) then
	  call errlist
	  ier_num = 0
	  ier_typ = ER_NONE
	endif
	close(idef)
1000	format(a)
	end
