c*****7*****************************************************************
	subroutine do_ins(line,laenge)
c-
c	Inserts a new atom into the structure. The name and position
c	must be given, optionally the temperature factor will be read.
c	If an atom of this type exists the temperature factor will be
c	that of the first type of temperature factor given for this atom
c	type, else the temperature factor will be 0.
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'charact.inc'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=5)
c
	character*(*) line
	character*4   name
	character*200 cpara(maxw),zeile
	integer       lpara(maxw)
	integer       i,j,ianz,laenge,lp
	real          werte(maxw)
	real          berechne
c
c	write(*,'(a)') line
c
	if(cr_natoms.lt.nmax) then
	  call get_params(line,ianz,cpara,lpara,maxw,laenge)
	  if(ier_num.eq.0) then
            i  = ichar(cpara(1)(1:1))
            if((a .le.i .and. i.le.z ).or.
     &         (aa.le.i .and. i.le.zz)     )  then
	      name=cpara(1)
	      j = 2
	    else
	      j = 1
	      name = 'yyyy'
	    endif
	    do i=j,ianz
	      lp=lpara(i)
	      zeile=' '
	      zeile(1:1)='('
	      zeile(2:lp+1)=cpara(i)(1:lp)
	      zeile(lp+2:lp+2)=')'
	      lp              = lp+2
	      werte(i)=0
	      werte(i)=berechne(zeile,lp)
	      if(ier_num.ne.0) return
	    enddo
	    if(ianz.ge.4) then
	      call do_ins_atom(name,werte,ianz)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -10
	  ier_typ = ER_APPL
	endif
	end
c*****7*****************************************************************
	subroutine do_app(line,laenge,lkick)
c-
c	Inserts a new atom into the structure. The name and position
c	must be given, optionally the temperature factor will be read.
c	If an atom of this type exists the temperature factor will be
c	that of the first type of temperature factor given for this atom
c	type, else the temperature factor will be 0.
c
c	Appends a new atom
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'charact.inc'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=10)
c
	character*(*) line
	character*4   name
	character*200 cpara(maxw),zeile
	integer       lpara(maxw)
	integer       i,j,k,ianz,laenge,lp
	logical       lkick,lspace
	real          werte(maxw)
	real          w(3),v(3)
	real          berechne
	real          do_blen
c
	data          lspace/.true./
c
c	write(*,'(a)') line
c
c
c------	If there is still space in the crystal, try to insert the atom
c
	if(cr_natoms.lt.nmax) then
	  call get_params(line,ianz,cpara,lpara,maxw,laenge)
	  if(ier_num.eq.0) then
	    if(ianz.ge.8) then
c
c------	------A minimum of eight parameters is required by 'append' and 'kick'
c
              i  = ichar(cpara(1)(1:1))
              if((a .le.i .and. i.le.z ).or.
     &           (aa.le.i .and. i.le.zz)     )  then
	        name=cpara(1)
	        j = 2
	      else
	        j = 1
	        name = 'yyyy'
	      endif
c
c------	------Evaluate parameters, old form will be replaced by ber_params
c
	      do i=j,ianz
	        lp=lpara(i)
	        zeile=' '
	        zeile(1:1)='('
	        zeile(2:lp+1)=cpara(i)(1:lp)
	        zeile(lp+2:lp+2)=')'
	        lp              = lp + 2	
	        werte(i)=0
	        werte(i)=berechne(zeile,lp)
	        if(ier_num.ne.0) return
	      enddo
	      j = nint(werte(6))
	      k = nint(werte(7))
c
c------	------j,k is the range of atoms to compare with the new atom
c	      is this range within the current crystal ?
c
	      if(0.lt.j .and. j.le.cr_natoms  .and.
     &	         0.lt.k .and. k.le.cr_natoms       ) then
c
c------	--------Apply default values
c
	        if(ianz.lt. 9) werte( 9)=werte( 8)
	        if(ianz.lt.10) werte(10)=werte( 9)
c
	        if(werte(8).lt.0) then
c
c------	----------Interpret parameter 8 as bondlength
c
	          if(lkick) then
c
c------	------------'kick' mode, remove all atoms from crystal that are
c	                         too close
c
	            do i=j,k
	              w(1) = cr_pos(1,i)
	              w(2) = cr_pos(2,i)
	              w(3) = cr_pos(3,i)
	              v(1) = werte(2)
	              v(2) = werte(3)
	              v(3) = werte(4)
	              if(do_blen(lspace,w,v).lt.-werte(8) ) then
	                cr_iscat(i) = 0
	                cr_ndel         =cr_ndel+1
	              endif
	            enddo
	          else
c
c------	------------'append' mode, insert new atom only if no other atom is
c	                           too close. Vacancies are ignored.
c
	            do i=j,k
	              if(cr_at_lis(cr_iscat(i)).ne.'VOID') then
	                w(1) = cr_pos(1,i)
	                w(2) = cr_pos(2,i)
	                w(3) = cr_pos(3,i)
	                v(1) = werte(2)
	                v(2) = werte(3)
	                v(3) = werte(4)
	                if(do_blen(lspace,w,v).lt.-werte(8) ) then
	                  goto 10
	                endif
	              endif
	            enddo
	          endif
	          call do_ins_atom(name,werte,ianz)
	        else
c
c------	----------Interpret parameters 8,9,10 as direct lattice units
c
	          if(lkick) then
c
c------	------------'kick' mode, remove all atoms from crystal that are
c	                         too close
c
	            do i=j,k
	              if(abs(cr_pos(1,i)-werte(2)).lt.werte( 8) .and.
     &	                 abs(cr_pos(2,i)-werte(3)).lt.werte( 9) .and.
     &	                 abs(cr_pos(3,i)-werte(4)).lt.werte(10) ) then
c	              cr_pos (1,i)=0.0
c	              cr_pos (2,i)=0.0
c	              cr_pos (3,i)=0.0
	                cr_iscat(i) =0
	                cr_ndel         =cr_ndel+1
	              endif
	            enddo
	          else
c
c------	------------'append' mode, insert new atom only if no other atom is
c	                           too close. Vacancies are ignored.
c
	            do i=j,k
	              if(cr_at_lis(cr_iscat(i)).ne.'VOID') then
	              if(abs(cr_pos(1,i)-werte(2)).lt.werte( 8) .and.
     &	                 abs(cr_pos(2,i)-werte(3)).lt.werte( 9) .and.
     &	                 abs(cr_pos(3,i)-werte(4)).lt.werte(10) ) then
	                goto 10
	              endif
	              endif
	            enddo
	          endif
	          call do_ins_atom(name,werte,ianz)
	        endif
	      elseif(cr_natoms.eq.0) then
c
c------	--------The crystal is empty. Insert atom in any case
c
	        call do_ins_atom(name,werte,ianz)
	      else
c
c------	--------Wrong range of atoms to compare to the new one
c
	        ier_num = -2
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -10
	  ier_typ = ER_APPL
	endif
10	continue
	end
c****7******************************************************************
	subroutine do_ins_atom(name,werte,ianz)
c-
c	Inserts the atom given by name and position in werte into the
c	structure.
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=5)
c
	character*4   name
	integer       i,l,ianz
	logical       lda
	real          werte(maxw)
c
	if(cr_natoms.lt.NMAX) then
	  call do_cap(name)
	  i  =0
	  if(name.eq.'YYYY') then
	    i = nint(werte(1))
	    if(0.le.i .and. i.le.cr_nscat) then
	      ier_num = 0
	      ier_typ = ER_NONE
	      cr_natoms = cr_natoms+1
	      cr_iscat(cr_natoms)= i
	    else
	      ier_num = -27
	      ier_typ = ER_APPL
	    endif
	  else
	    lda=name    .eq.cr_at_lis(i)   .and.
     &	        werte(5).eq.cr_dw(i)
	    do while(.not.lda  .and. i.lt.cr_nscat)
	      i   = i+1
	      lda = name    .eq.cr_at_lis(i)   .and.
     &	            werte(5).eq.cr_dw(i)
	    enddo
	    if(lda) then
	      cr_natoms          = cr_natoms+1
	      cr_iscat(cr_natoms)= i
	    else
	      if(cr_nscat+1.le.maxscat) then
	        cr_natoms           = cr_natoms+1
	        cr_nscat            = cr_nscat +1
	        cr_iscat(cr_natoms) = cr_nscat
	        cr_at_lis(cr_nscat) = name
	        cr_dw(cr_nscat)     = werte(5)
	      else
	        ier_num = -26
	        ier_typ = ER_APPL
	      endif
	    endif
	  endif
	  if(ier_num.eq.0) then
	    cr_pos(1,cr_natoms) = werte(2)
	    cr_pos(2,cr_natoms) = werte(3)
	    cr_pos(3,cr_natoms) = werte(4)
	    do l=1,3
	      cr_dim(l,1)=amin1(cr_dim(l,1),cr_pos(l,cr_natoms))
	      cr_dim(l,2)=amax1(cr_dim(l,2),cr_pos(l,cr_natoms))
	    enddo
	  endif
	else
	  ier_num = -10
	  ier_typ = ER_APPL
	endif
	end
c*****7*****************************************************************
	subroutine do_remove(line,ll)
c-
c	Removes a single atom from the structure. line is evaluated to
c	give the index of the atom.
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer         maxw
	parameter      (maxw=1)
c
	character*(*)   line
	character*200   cpara(maxw)
	integer         lpara(maxw)
	integer         ll,index,ianz
	real            werte(maxw)
c
c------	Get parameters
c
	call  get_params(line,ianz,cpara,lpara,maxw,ll)
	if(ier_num.eq.0) then
c
c------	--Calculate value of parameters
c
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  if(ier_num.eq.0) then
	    index = nint(werte(1))
c
c------	----If index of atom is within limits, remove atom by
c	    Setting its scattering curve to zero
c
	    if(0.lt.index .and. index.le.NMAX) then
	      cr_iscat(index) =0
	      cr_ndel         =cr_ndel+1
	    else
	      ier_num = -19
	      ier_typ = ER_APPL
	    endif
	  endif
	endif
c
	end
c*****7**************************************************************
	subroutine do_purge
c-
c	Purges the list of atoms from all deleted atoms
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       i,ii,idel
c
	if(cr_ndel.ne.0) then
	  idel=0
	  do i=1,cr_natoms-cr_ndel
	    do while (cr_iscat(i+idel).eq.0)
	      idel=idel+1
	    enddo
	    ii            = i+idel
	    cr_pos(1,i)   = cr_pos(1,ii)
	    cr_pos(2,i)   = cr_pos(2,ii)
	    cr_pos(3,i)   = cr_pos(3,ii)
	    cr_iscat(i)   = cr_iscat(ii)
	    cr_md_next(i) = cr_md_next(ii)
	    cr_md_dist(i) = cr_md_dist(ii)
	  enddo
	  cr_natoms=cr_natoms-cr_ndel
	  cr_ndel  =0
	endif
	write(*,1000) char(7)
c
1000	format(
     &	' ****APPL****All functions that require identical     ****'/
     &	'         ****number of atoms in ALL unit cells might  ****'/
     &	'         ****not work correctly after a purge command ****',
     &	a1)
c
	end
c*****7***********************************************************************
	subroutine do_copy(line,lp)
c-
c	copies an atom to a new position given in relativ or absolute
c	fractional coordinates
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=5)
c
	character*(*) line
	character*80  zeile
	character*200 cpara(maxw)
	integer       lpara(maxw)
	integer       ianz,i,lp,ind
	real          werte(maxw)
	real          berechne
c
	zeile =' '
	call get_params(line,ianz,cpara,lpara,maxw,lp)
	if(ianz.ne.5) then
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
	if(ier_num.eq.0) then
	  do i=2,ianz
	    lp=lpara(i)
	    zeile=' '
	    zeile(1:1)='('
	    zeile(2:lp+1)=cpara(i)(1:lp)
	    zeile(lp+2:lp+2)=')'
	    lp              = lp+2
	    werte(i)=berechne(zeile,lp)
	    if(ier_num.ne.0) return
	  enddo
	  ind=int(werte(2))
	  zeile =' '
	  zeile(1:4)=cr_at_lis(cr_iscat(ind))
	  zeile(5:5)=','
	  if(cpara(1)(1:1).eq.'a') then
c	    write(*          ,3000) (werte(i),i=3,5),
c     &	    cr_dw(cr_iscat(ind))
	    write(zeile(7:57),3000) (werte(i),i=3,5),
     &	    cr_dw(cr_iscat(ind))
	    lp = 57
	  elseif(cpara(1)(1:1).eq.'r') then
c	    write(*          ,3000) (werte(i)+cr_pos(i-2,ind),i=3,5),
c     &	    cr_dw(cr_iscat(ind))
	    write(zeile(7:57),3000) (werte(i)+cr_pos(i-2,ind),i=3,5),
     &	    cr_dw(cr_iscat(ind))
	    lp = 57
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	    return
	  endif
	  call do_ins(zeile,lp)
	endif
3000	format(3(e12.5e1,','),e12.5e1)
	end
c*****7*****************************************************************
	subroutine do_switch(line,lp)
c-
c	Switches two atoms in the structure. The number of the two
c	atoms must be given.
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=2)
c
	character*(*) line
	character*200 cpara(maxw),zeile
	integer       lpara(maxw)
	integer       i,ianz,lp,j,is
	real          werte(maxw)
	real          berechne
c
c	write(*,'(a)') line
c
	call get_params(line,ianz,cpara,lpara,maxw,lp)
	if(ier_num.eq.0) then
	  do i=1,ianz
	    lp=lpara(i)
	    zeile=' '
	    zeile(1:1)='('
	    zeile(2:lp+1)=cpara(i)(1:lp)
	    zeile(lp+2:lp+2)=')'
	    lp              = lp + 2
	    werte(i)=berechne(zeile,lp)
	    if(ier_num.ne.0) return
	  enddo
	  if(ianz.eq.2) then
	    i=nint(werte(1))
	    j=nint(werte(2))
	    if(0.lt.i .and. i.le.NMAX .and.
     &	       0.lt.j .and. j.le.NMAX       ) then
	      is         =cr_iscat(i)
	      cr_iscat(i)=cr_iscat(j)
	      cr_iscat(j)=is
	    else
	      ier_num = -19
	      ier_typ = ER_APPL
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
	end
c*****7*****************************************************************
	subroutine do_find(line,laenge)
c-
c	Finds the environment around an atom
c+
	implicit     	none
c
	include 	'config.inc'
	include 	'charact.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer       maxw
	parameter    (maxw=15)
	integer       mmaxw
	parameter    (mmaxw=4)
c
	character*(*) line
	character*200 cpara(maxw)
	character*200 ccpara(mmaxw)
	integer       lpara(maxw)
	integer       llpara(maxw)
	integer       i,ii,ianz,iianz,laenge
	logical       lnew,lquick
	real          radius
	real          werte(maxw)
	real          wwerte(maxw)
	real          x(3)
c
	logical       str_comp
c
	lquick = .false.
cdbg   	lquick = .true.
c
	call get_params(line,ianz,cpara,lpara,maxw,laenge)
	if(ier_num.eq.0) then
	  if(str_comp(cpara(1),'env',1,lpara(1),3)) then
c
c------	----Find environment
c
	    if(ianz.ge.6) then
c
c------	------copy last three parameters for evaluation
c
	      do i=ianz-3,ianz
	        ii         = i - (ianz-4)
	        ccpara(ii) = cpara(i)
	        llpara(ii) = lpara(i)
	      enddo
	      iianz = 4
	      call ber_params(iianz,ccpara,llpara,wwerte,mmaxw)
	      x(1)   = wwerte(1)
	      x(2)   = wwerte(2)
	      x(3)   = wwerte(3)
	      radius = wwerte(4)
	      if(ier_num.eq.0) then
c
c------	-------- shift remaining parameters one left
c
	        do i=2,ianz-4
	          cpara(i-1) = cpara(i)
	          lpara(i-1) = lpara(i)
	        enddo
	        ianz = ianz -4
c
c------	--------Get scattering curves
c
	        call get_iscat(ianz,cpara,lpara,werte,maxw,lnew)
	        if(ier_num.eq.0) then
	          call do_find_env(ianz,werte,maxw,x,0.0,radius,lquick)
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -10
	  ier_typ = ER_APPL
	endif
c
	end
c*****7*****************************************************************
	subroutine do_find_env(ianz,werte,maxw,x,rmin,rmax,quick)
c 
c	This routine finds all atoms around x with a minimal
c	distance of rmin and a maximum distance of rmax.
c-
	implicit      none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'atom_env.inc'
	include      'errlist.inc'
c
	integer       ianz,maxw
	real          werte(maxw)
	real          x(3)
	real          rmin,rmax
	logical       quick
c
	integer       i,j,k,ii
	integer       istart(3),iend(3),iii(3),iatom
	logical       ltype
c
	logical       atom_allowed
c
	atom_env(0) = 0
	if (quick) then
c
c------ --quick version only looks at neighbouring unit cells
c
	  do i=1,3
	    iii(i)    = int(x(i) - cr_dim0(i,1))+1
	    istart(i) = max(1,iii(i)-1-int(rmax/cr_a0(i)))
	    iend(i)   = min(iii(i)+1+int(rmax/cr_a0(i)),cr_icc(i))
	  enddo
c
	  do k=istart(3),iend(3)
	  do j=istart(2),iend(2)
	  do i=istart(1),iend(1)
	    do ii=1,cr_ncatoms
	      iatom = ((k-1)*cr_icc(1)*cr_icc(2) +
     &	               (j-1)*cr_icc(1)           + (i-1))*cr_ncatoms+ii
	      ltype = atom_allowed (iatom,werte,ianz,maxw)
	      if(ltype) then
	        call check_blen (x,iatom,rmin,rmax)
	        if (ier_num.ne.0) return
	      endif
	    enddo
	  enddo
	  enddo
	  enddo
c
c------	--exact: loop over all atoms in crystal that have been added
c
	  do i=cr_ncatoms*cr_icc(1)*cr_icc(2)*cr_icc(3)+1,cr_natoms
	    ltype = atom_allowed (i,werte,ianz,maxw)
	    if(ltype) then
	      call check_blen (x,i,rmin,rmax)
	      if (ier_num.ne.0) return
	    endif
	  enddo
	else
c
c------	--exact: loop over all atoms in crystal
c
	  do i=1,cr_natoms
	    ltype = atom_allowed (i,werte,ianz,maxw)
	    if(ltype) then
	      call check_blen (x,i,rmin,rmax)
	      if (ier_num.ne.0) return
	    endif
	  enddo
	endif
c
	end
c*****7*****************************************************************
	subroutine check_blen (x,iatom,rmin,rmax)
c+
c	checks if atom 'iatom' is within rmin -> rmax awaz from
c	position x(3). All matching atoms are stored in the
c	arrays 'atom_env' and 'res_para'.
c-
	implicit	none
c
	include		'config.inc'
	include		'crystal.inc'
	include		'crystal.cmm'
	include		'atom_env.inc'
	include		'param.inc'
	include		'errlist.inc'
c
	real		x(3),rmin,rmax
	integer		iatom
c
	real		v(3),dist,do_blen
	integer		j
	logical		lspace
c
	lspace      = .true.
c
	do j=1,3
	  v(j) = cr_pos(j,iatom)
	enddo
	dist = do_blen(lspace,x,v)
	if(dist.ge.rmin .and. dist.le.rmax) then
	  if(atom_env(0).lt.MAX_ATOM_ENV) then
	    atom_env(0) = atom_env(0) + 1
	    atom_env(atom_env(0)) = iatom
	    res_para(atom_env(0)) = dist
	    res_para(0)           = float(nint(res_para(0)) + 1)
	  else
	    ier_num = -45
	    ier_typ = ER_APPL
	  endif
	endif
	end
c*****7*****************************************************************
	logical function atom_allowed (i,werte,ianz,maxw)
c+
c	checks if atom i is within the selected atom range in
c	werte(ianz).
c-
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer		i,ianz,maxw
	real		werte(maxw)
c
	integer		j
	logical		ltype
c
	if(werte(1).eq.-1) then
	  ltype = .true.
	else
	  ltype = .false.
	  do j=1,ianz
	    ltype = ltype .or. cr_iscat(i).eq.nint(werte(j))
	  enddo
	endif
	atom_allowed = ltype
	end
c*****7*****************************************************************
	subroutine celltoindex (icell,isite,iatom)
c-
c 	calculates in which unit cell on which site the atom <ia> is
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer		iatom,isite,icell(3)
c
	iatom = ((icell(3)-1)*cr_icc(1)*cr_icc(2) +
     &	         (icell(2)-1)*cr_icc(1)           + 
     &	         (icell(1)-1)                      )*cr_ncatoms+isite
c
	end
c*****7*****************************************************************
	subroutine indextocell (iatom,icell,isite)
c-
c 	calculates in which unit cell on which site the atom <ia> is
c+
	implicit	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include 	'errlist.inc'
c
	integer		iatom,isite,icell(3)
	integer		ia
c
        ia       = iatom-1
c
        icell(3) = int(ia/cr_icc(1)/cr_icc(2)/cr_ncatoms)+1
        ia       = ia-(icell(3)-1)*cr_icc(1)*cr_icc(2)*cr_ncatoms
        icell(2) = int(ia/cr_icc(1)/cr_ncatoms)+1
        ia       = ia-(icell(2)-1)*cr_icc(1)*cr_ncatoms
        icell(1) = int(ia/cr_ncatoms)+1
	isite    = ia-(icell(1)-1)*cr_ncatoms+1
c
	end

