c*****7*****************************************************************
	subroutine patterson(inverse_type)
c-
c	patterson sets up the menu for inverse Fourier and Patterson
c	calculations.
c
c	Version  : 1.0
c	Date     : 05 Oct 96
c
c	Author   : R.B. Neder (neder@yoda.kri.physik.uni-muenchen.de)
c+
	implicit        none
c
	include        'config.inc'
	include        'crystal.inc'
	include        'crystal.cmm'
	include        'doact.inc'
	include        'intens.inc'
	include        'inverse.inc'
	include        'learn.inc'
	include        'macro.inc'
	include        'output.inc'
	include        'patters.inc'
	include        'prompt.inc'
	include        'diffuse.inc'
	include        'errlist.inc'
c
	integer         maxw
	parameter      (maxw=MAXSCAT)
	logical         lold
	parameter      (lold=.false.)
c
        character*1     extr_achs(0:3)
        character*1     rho_extr_achs(0:3)
	character*5     befehl
	character*16    prom
	character*14    cvalue(0:6)
	character*15    cgraphik(0:4)
	character*200   zeile,cpara(maxw)
	character*200   line
	logical         lspace
	logical         ltwo_files
	integer         lpara(maxw)
	integer         i,j,ianz,lp,length
	integer         indxg,lbef
	integer         ftyp
	real            werte(maxw)
	real            divis(2)
	real            rho_divis(2)
	real            u(3),v(3),w(3),dvi1,dvi2,dvi3,dvi4
c
	logical         str_comp
	real            do_blen,do_bang
c
        data extr_achs/' ','h','k','l'/
        data rho_extr_achs/' ','x','y','z'/
c
	data cgraphik
     &	/'Standard','Postscript','Pseudo Grey Map','Gnuplot','SHELXL'/
c
	data cvalue
     &	/'undefined     ',
     &	 'Intensity     ',
     &	 'Amplitude=Fobs',
     &	 'Phase angle   ',
     &	 'Real Part     ',
     &	 'Imaginary Part',
     &	 'Fcalc         '/
c
	if(cr_natoms.gt.0 .and. as_natoms.gt.0) then
	  patt_scale = float(cr_ncatoms)/float(cr_natoms)
	elseif(patt_scale.eq.0) then
	  patt_scale = 1.0
	endif
c
10	continue
c
	call no_error
c
	divis(1)     = float(max(1,    inc(1)-1))
	divis(2)     = float(max(1,    inc(2)-1))
	rho_divis(1) = float(max(1,rho_inc(1)-1))
	rho_divis(2) = float(max(1,rho_inc(2)-1))
c
	if(inverse_type.eq.INV_INV) then
	  prom = prompt//'/inverse'
	elseif(inverse_type.eq.INV_DIFF) then
	  prom = prompt//'/diff-four'
	elseif(inverse_type.eq.INV_PATT) then
	  prom = prompt//'/patterson'
	endif
	call get_command (line,length,befehl,lbef,zeile,lp,prom)
	if(line(1:1).eq.' ' .or. line(1:1).eq.'#')  goto 10
c
c------	search for "="
c
	indxg=index(line,'=')
	if(indxg.ne.0 .and. .not.(str_comp(befehl,'echo',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'syst',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)))then
c
c------	--evaluatean expression and assign the value to a variabble
c
	  call do_math(line,indxg,length)
	else
c
c------ execute a macro file
c
        if(befehl(1:1).eq.'@') then
	  if(length.ge.2) then
	    call file_kdo(line(2:length),length-1)
	  else
	    ier_num = -13
	    ier_typ = ER_MAC
	  endif
c
c------	Define the ascissa 'absc'
c
	elseif(str_comp(befehl,'absc',1,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ianz.eq.1) then
            if(cpara(1).eq.'h') then
              extr_abs=1
            elseif(cpara(1).eq.'k') then
              extr_abs=2
            elseif(cpara(1).eq.'l') then
              extr_abs=3
            else
              ier_num = -6
	      ier_typ = ER_COMM
            endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------	continues a macro 'continue'
c
	elseif(str_comp(befehl,'continue',1,lbef,8)) then
	  call macro_continue(zeile,lp)
c
c------ Echo a string, just for interactive check in a macro 'echo'
c
	elseif(str_comp(befehl,'echo',2,lbef,4)) then
          write(*,'(1x,a)') zeile(1:79)
c
c------	 Evaluate an expression, just for interactive check 'eval'
c
	elseif(str_comp(befehl,'eval',2,lbef,4)) then
	  call do_eval(zeile,lp)
c
c------	Terminate invers Fourier / Patterson 'exit'
c
	elseif(str_comp(befehl,'exit',3,lbef,4)) then
	  goto 9999
c
c------	define the input file names 'file'
c
	elseif(str_comp(befehl,'file',1,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.ge.2) then
	      if(str_comp(cpara(1),'a    ',1,lpara(2),5)) then
		call do_build_name(ianz,cpara,lpara,werte,maxw,2)
	        if(ier_num.eq.0) then
	          i = 1
	          rho_file(i) = cpara(2)
	        endif
	      elseif(str_comp(cpara(1),'b    ',1,lpara(2),5)) then
		call do_build_name(ianz,cpara,lpara,werte,maxw,2)
	        if(ier_num.eq.0) then
	          i = 2
	          rho_file(i) = cpara(2)
	        endif
	      else
	        ier_num = -41
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	Determine format for input 'format'
c
	elseif(str_comp(befehl,'form',1,lbef,4)) then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if(ier_num.eq.0) then
	    if(ianz.eq.1 .or. ianz.eq.2) then
c
c------	--Switch input type to GNUPLOT 'gnup'
c
	      if(str_comp(cpara(1),'gnup',1,lpara(1),4)) then
	        ftyp=3
c
c------	Switch input type to standard  'stan'
c
	      elseif(str_comp(cpara(1),'stan',2,lpara(1),4)) then
	        ftyp=0
c
c------	Switch input type to SHELXL List Type 5 'shelxl'
c
	      elseif(str_comp(cpara(1),'shelx',2,lpara(1),5)) then
	        ftyp=4
	        rho_type(1) = AMPLITUDE
	        if(ianz.eq.2) then
	          if(str_comp(cpara(2),'fobs',2,lpara(2),4)) then
	            rho_type(1) = AMPLITUDE
	          elseif(str_comp(cpara(2),'fcalc',2,lpara(2),5)) then
	            rho_type(1) = FCALC
	          else
	            ier_num = -52
	            ier_typ = ER_APPL
	          endif
	        endif
	      else
	        ier_num = -9
	        ier_typ = ER_APPL
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	help 'help' , '?'
c
	elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	       str_comp(befehl,'?   ',1,lbef,4)     ) then
	  if(str_comp(zeile,'errors',2,lp,6) ) then
	    lp = lp + 7
	    call do_hel('discus '//zeile,lp)
	  else
	    if(inverse_type.eq.INV_INV) then
	      lp = lp+15
	      call do_hel('discus inverse '//zeile,lp)
	    elseif(inverse_type.eq.INV_DIFF) then
	      lp = lp+17
	      call do_hel('discus diff-four '//zeile,lp)
	    elseif(inverse_type.eq.INV_PATT) then
	      lp = lp+17
	      call do_hel('discus patterson '//zeile,lp)
	    endif
	  endif
c
c------	define the whole layer 'laye'
c
	elseif(str_comp(befehl,'laye',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.11) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        do j=1,3
	          do i=1,3
	            eck(i,j)=werte((j-1)*3+i)
	          enddo
	        enddo
	        inc(1)=nint(werte(10))
	        inc(2)=nint(werte(11))
	        divis(1) = float(max(1,inc(1)-1))
	        divis(2) = float(max(1,inc(2)-1))
	        do i=1,3              
	          vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	          vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the lower left corner 'll'
c
	elseif(str_comp(befehl,'ll  ',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=1
	        do i=1,3
	          eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	          vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the lower right corner 'lr'
c
	elseif(str_comp(befehl,'lr  ',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=2
	        do i=1,3
	          eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	          vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the number of points along the abscissa 'na'
c
	elseif(str_comp(befehl,'nabs',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        if(werte(1).gt.0) then
	          inc(1)   = nint(werte(1))
	          divis(1) = float(max(1,inc(1)-1))
	          do i=1,3              
	            vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	            vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	          enddo
	        else
	          ier_num = -12
	          ier_typ = ER_APPL
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c------	define the number of points along the ordinate 'no'
c
	elseif(str_comp(befehl,'nord',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        if(werte(1).gt.0) then
	          inc(2)   = nint(werte(1))
	          divis(2) = float(max(1,inc(2)-1))
	          do i=1,3              
	            vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	            vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	          enddo
	        else
	          ier_num = -12
	          ier_typ = ER_APPL
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the ordinate  'ordi'
c
	elseif(str_comp(befehl,'ordi',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ianz.eq.1) then
            if(cpara(1).eq.'h') then
              extr_ord=1
            elseif(cpara(1).eq.'k') then
              extr_ord=2
            elseif(cpara(1).eq.'l') then
              extr_ord=3
            else
              ier_num = -6
	      ier_typ = ER_COMM
            endif
	  endif
c
c------	Define the real space ascissa 'rhoabsc'
c
	elseif(str_comp(befehl,'rhoab',4,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ianz.eq.1) then
            if(cpara(1).eq.'x') then
              rho_extr_abs=1
            elseif(cpara(1).eq.'y') then
              rho_extr_abs=2
            elseif(cpara(1).eq.'z') then
              rho_extr_abs=3
            else
              ier_num = -6
	      ier_typ = ER_COMM
            endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c------	define the whole real space layer 'rholayer'
c
	elseif(str_comp(befehl,'rhola',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.11) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        do j=1,3
	          do i=1,3
	            rho_eck(i,j)=werte((j-1)*3+i)
	          enddo
	        enddo
	        rho_inc(1)=nint(werte(10))
	        rho_inc(2)=nint(werte(11))
	        rho_divis(1) = float(max(1,rho_inc(1)-1))
	        rho_divis(2) = float(max(1,rho_inc(2)-1))
	        do i=1,3              
	          rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/rho_divis(1)
	          rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/rho_divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the real space lower left corner 'rholl'
c
	elseif(str_comp(befehl,'rholl',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=1
	        do i=1,3
	          rho_eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/rho_divis(1)
	          rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/rho_divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the real space lower right corner 'rholr'
c
	elseif(str_comp(befehl,'rholr',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=2
	        do i=1,3
	          rho_eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/rho_divis(1)
	          rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/rho_divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the real space number of points along the abscissa 'rhonabs'
c
	elseif(str_comp(befehl,'rhona',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        if(werte(1).gt.0) then
	          rho_inc(1)   = nint(werte(1))
	          rho_divis(1) = float(max(1,rho_inc(1)-1))
	          do i=1,3              
	            rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/
     &		    rho_divis(1)
	            rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/
     &		    rho_divis(2)
	          enddo
	        else
	          ier_num = -12
	          ier_typ = ER_APPL
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the real space number of points along the ordinate 'rhonord'
c
	elseif(str_comp(befehl,'rhono',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        if(werte(1).gt.0) then
	          rho_inc(2)   = nint(werte(1))
	          rho_divis(2) = float(max(1,rho_inc(2)-1))
	          do i=1,3              
	            rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/rho_divis(1)
	            rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/rho_divis(2)
	          enddo
	        else
	          ier_num = -12
	          ier_typ = ER_APPL
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the real space ordinate  'rhoordi'
c
	elseif(str_comp(befehl,'rhoor',5,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ianz.eq.1) then
            if(cpara(1).eq.'x') then
              rho_extr_ord=1
            elseif(cpara(1).eq.'y') then
              rho_extr_ord=2
            elseif(cpara(1).eq.'z') then
              rho_extr_ord=3
            else
              ier_num = -6
	      ier_typ = ER_COMM
            endif
	  endif
c
c------	define the real space  upper left corner 'rhoul'
c
	elseif(str_comp(befehl,'rhoul',4,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=3
	        do i=1,3
	          rho_eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          rho_vi(i,1)=(rho_eck(i,2)-rho_eck(i,1))/rho_divis(1)
	          rho_vi(i,2)=(rho_eck(i,3)-rho_eck(i,1))/rho_divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	start the inverse Fourier transform 'run'
c
	elseif(str_comp(befehl,'run ',1,lbef,4)) then
	  if(inc(1)*inc(2).le.MAXQXY) then
	    if(rho_type(2).eq.INTENSITY       .or.
     &	       rho_type(2).eq.AMPLITUDE       .or.
     &	       rho_type(2).eq.REAL_PART            ) then
	      line = ' '
	      line = rho_file(2)
	      i    = rho_type(2)
	      rho_file(2) = rho_file(1)
	      rho_type(2) = rho_type(1)
	      rho_file(1) = line
	      rho_type(1) = i
	    endif
	    if(ftyp.eq.4) then
	      ltwo_files = .false.
	      if(rho_type(1).eq.AMPLITUDE  .or. 
     &	         rho_type(1).eq.FCALC                ) then
	        call no_error
	      else
	        ier_num = -51
	        ier_typ = ER_APPL
	      endif
	    else
	      ltwo_files = .true.
	      if(inverse_type.eq.INV_INV) then
	        if(rho_type(1).eq.INTENSITY .and. 
     &	           rho_type(2).eq.PHASE_ANG       .or.
     &	           rho_type(1).eq.AMPLITUDE .and.
     &	           rho_type(2).eq.PHASE_ANG       .or.
     &	           rho_type(1).eq.REAL_PART .and.
     &	           rho_type(2).eq.IMAG_PART           ) then
	          call no_error
	        else
	          ier_num = -36
	          ier_typ = ER_APPL
	        endif
	      elseif(inverse_type.eq.INV_PATT) then
	        if(rho_type(1).eq.INTENSITY       .or.
     &	           rho_type(1).eq.AMPLITUDE       .or.
     &	           rho_type(1).eq.REAL_PART .and.
     &	           rho_type(2).eq.IMAG_PART           ) then
	          call no_error
	        else
	          ier_num = -38
	          ier_typ = ER_APPL
	        endif
	        if(rho_type(1).eq.INTENSITY ) then
	          ltwo_files = .false.
	        endif
	      elseif(inverse_type.eq.INV_DIFF) then
	        ltwo_files = .false.
	      endif
	    endif
	    if(ier_num.eq.0) then
	      call do_patters(inverse_type,ltwo_files,ftyp,cr_vr,
     &	                      cr_acentric)
	    endif
	  else
	    ier_num = -8
	    ier_typ = ER_APPL
	  endif
c
c------	Define the type of the input file 'type'
c
	elseif(str_comp(befehl,'type',1,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.2) then
	      if(str_comp(cpara(1),'a    ',1,lpara(1),5)) then
	        i = 1
	      elseif(str_comp(cpara(1),'b    ',1,lpara(1),5)) then
	        i = 2
	      else
	        ier_num = -41
	        ier_typ = ER_APPL
	      endif
	      if(ier_num.eq.0) then
	        if(str_comp(cpara(2),'inten',2,lpara(2),5)) then
	          rho_type(i) = INTENSITY
	        elseif(str_comp(cpara(2),'ampli',1,lpara(2),5)) then
	          rho_type(i) = AMPLITUDE
	        elseif(str_comp(cpara(2),'phase',1,lpara(2),5)) then
	          rho_type(i) = PHASE_ANG
	        elseif(str_comp(cpara(2),'real ',1,lpara(2),5)) then
	          rho_type(i) = REAL_PART
	        elseif(str_comp(cpara(2),'imagi',2,lpara(2),5)) then
	          rho_type(i) = IMAG_PART
	        elseif(str_comp(cpara(2),'fobs' ,2,lpara(2),4)) then
	          rho_type(i) = AMPLITUDE
	        elseif(str_comp(cpara(2),'fcalc',2,lpara(2),5)) then
	          rho_type(i) = FCALC
	        else
	          rho_type(i) = 0
	          ier_num = -42
	          ier_typ = ER_APPL
	        endif
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the scale factor
c
	elseif(str_comp(befehl,'scale',2,lbef,5)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.1) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
		patt_scale = werte(1)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	set various parameters 'set'
c
	elseif(str_comp(befehl,'set',2,lbef,3)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.2) then
c
c------	------set mode for accumulation 'accu'
c	      either initialize or add to previous patterson.
c
	      if(str_comp(cpara(1),'accu',1,lbef,4)) then
	        if(str_comp(cpara(2),'init',1,lbef,4)) then
	          patt_accu = PATT_INIT
	        elseif(str_comp(cpara(2),'add',1,lbef,3)) then
	          patt_accu = PATT_ADD
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	define the sign for inverse or direct Fourier 'sign'
c
	elseif(str_comp(befehl,'sign',2,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
	    if(str_comp(cpara(1),'inverse',1,lpara(1),7)) then
	      patt_sign = -1
	    elseif(str_comp(cpara(1),'fourier',1,lpara(1),7)) then
	      patt_sign =  1
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c------	Show the current settings for the Fourier 'show'
c
	elseif(str_comp(befehl,'show',2,lbef,4)) then
	  if(inverse_type.eq.INV_INV) then
	    write(*,*) ' technique           : inverse Fourier'
	  elseif(inverse_type.eq.INV_DIFF) then
	    write(*,*) ' technique           : Difference Fourier '
	  elseif(inverse_type.eq.INV_PATT) then
	    write(*,*) ' technique           : Patterson '
	  endif
	  if(patt_accu.eq.PATT_INIT) then
	    write(*,*) ' Accumulation mode   : Initialize'
	  elseif(patt_accu.eq.PATT_ADD) then
	    write(*,*) ' Accumulation mode   : Add to previous'
	  endif
	  write(*,*)
	  write(*,*) ' Geometry            : reciprocal space'
	  write(*,*) ' Input file format   : ',cgraphik(ftyp)
	  write(*,*) ' Input file A        : ',rho_file(1)
	  write(*,*) ' File type  A        : ',cvalue(rho_type(1))
	  write(*,*) ' Input file B        : ',rho_file(2)
	  write(*,*) ' File type  B        : ',cvalue(rho_type(2))
	  write(*,*) ' Scale factor        : ',patt_scale
	  write(*,*) ' Sign in exponent    : ',patt_sign
	  write(*,3060) ((eck(i,j),i=1,3),j=1,3)
	  write(*,3061) inc
	  do i=1,3
	    u(i) = vi(i,1)
	    v(i) = 0.0
	    w(i) = vi(i,2)
	  enddo
	  lspace = .false.
	  dvi1   = do_blen(lspace,u,v)
	  dvi2   = do_blen(lspace,w,v)
	  if(inc(1).gt.1 .and. inc(2).gt.1) then
	    dvi3   = do_bang(lspace,u,v,w)
	  else
	    dvi3 = 0.0
	  endif
	  if(dvi3.gt.0) then
	    dvi4   = dvi2/dvi1
	  else
	    dvi4   = 0.0
	  endif
	  write(*,3062) (vi(i,1),i=1,3),dvi1,(vi(i,2),i=1,3),dvi2,
     &	                                dvi3,dvi4
	  write(*,3063) extr_achs(extr_abs)
	  write(*,3064) extr_achs(extr_ord)
	  if(ier_num.ne.0) then
	    call errlist
	    call no_error
	  endif
c
	  write(*,*)
	  write(*,*   ) ' Geometry   : real space'
	  write(*,*)
	  write(*,3260) ((rho_eck(i,j),i=1,3),j=1,3)
	  write(*,3061) rho_inc
	  do i=1,3
	    u(i) = rho_vi(i,1)
	    v(i) = 0.0
	    w(i) = rho_vi(i,2)
	  enddo
	  lspace = .true.
	  dvi1   = do_blen(lspace,u,v)
	  dvi2   = do_blen(lspace,w,v)
	  if(rho_inc(1).gt.1 .and. rho_inc(2).gt.1) then
	    dvi3   = do_bang(lspace,u,v,w)
	  else
	    dvi3 = 0.0
	  endif
	  if(dvi3.gt.0) then
	    dvi4   = dvi2/dvi1
	  else
	    dvi4   = 0.0
	  endif
	  write(*,3262) (rho_vi(i,1),i=1,3),dvi1,
     &	                (rho_vi(i,2),i=1,3),dvi2,
     &	                                dvi3,dvi4
	  write(*,3063) rho_extr_achs(rho_extr_abs)
	  write(*,3064) rho_extr_achs(rho_extr_ord)
	  if(ier_num.ne.0) then
	    call errlist
	    call no_error
	  endif
c
c------	define the upper left corner 'ul'
c
	elseif(str_comp(befehl,'ul  ',1,lbef,4)) then
          call get_params(zeile,ianz,cpara,lpara,maxw,lp)
          if(ier_num.eq.0) then
            if(ianz.eq.3) then
              call ber_params(ianz,cpara,lpara,werte,maxw)
              if(ier_num.eq.0) then
	        j=3
	        do i=1,3
	          eck(i,j)=werte(i)
	        enddo
	        do i=1,3              
	          vi(i,1)=(eck(i,2)-eck(i,1))/divis(1)
	          vi(i,2)=(eck(i,3)-eck(i,1))/divis(2)
	        enddo
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
c
c-------Operating System Kommandos 'syst'
c
	elseif(str_comp(befehl,'syst',2,lbef,4)) then
	  if(zeile.ne. ' ') then
	    call do_operating(zeile(1:lp))
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
c
c
c------	waiting for user input
c
	elseif(str_comp(befehl,'wait',3,lbef,4)) then
	  call do_input(zeile,lp)
c
c------	unknown command
c
	else
	  ier_num = -8
	  ier_typ = ER_COMM
	endif
	endif
	if(ier_num.ne.0) then
	  call errlist
	  if(lmakro) then
	    call macro_close
	    prompt_status = PROMPT_ON
	  endif
	  if(lblock) then
	    ier_num = -11
	    ier_typ = ER_COMM
	    return
	  endif
	  call no_error
	endif
	goto 10
9999	continue
3060	format(/' reciprocal layer    :'/
     &	       ' lower left  corner  : ',3(2x,f9.4)/
     &	       ' lower right corner  : ',3(2x,f9.4)/
     &	       ' upper left  corner  : ',3(2x,f9.4))
3061	format(/' number of points '/
     &	       ' horizontally        : ',2x,i4/
     &	       ' vertically          : ',2x,i4)
3062	format(' increment vectors   :',
     &	  7x,'h',10x,'k',10x,'l',15x,'A**-1'/
     &	  ' horizontally        : ',3(2x,f9.4) ,7x,F9.4/
     &	  ' vertically          : ',3(2x,f9.4) ,7x,F9.4/
     &	 /' Angle               : ',2x,f9.4,
     &	  ' degrees         Ratio v/h : ',F9.4)
3063	format(' Abszisse            : ', a)
3064	format(' Ordinate            : ', a)
3260	format(/' real space layer    :'/
     &	       ' lower left  corner  : ',3(2x,f9.4)/
     &	       ' lower right corner  : ',3(2x,f9.4)/
     &	       ' upper left  corner  : ',3(2x,f9.4))
3262	format(' increment vectors   :',
     &	  7x,'x',10x,'y',10x,'z',15x,'A'/
     &	  ' horizontally        : ',3(2x,f9.4) ,7x,F9.4/
     &	  ' vertically          : ',3(2x,f9.4) ,7x,F9.4/
     &	 /' Angle               : ',2x,f9.4,
     &	  ' degrees         Ratio v/h : ',F9.4)
c
      end
c*****7*****************************************************************
	subroutine do_patters(inverse_type,ltwo_files,ftyp,vr,
     &	                      acentric)
c-
c	Reads the files, if necessary calculates the values and
c	calls the patterson function
c+
	implicit       none
c
	include        'config.inc'
	include        'crystal.inc'
	include        'crystal.cmm'
	include        'errlist.inc'
	include        'intens.inc'
	include        'inverse.inc'
	include        'output.inc'
	include        'patters.inc'
	include        'recipro.inc'
	include        'diffuse.inc'
c
	logical      ltwo_files
	logical      acentric
	real         vr
c
	integer      ifa,ifb
	parameter   (ifa=21,ifb=22)
c
	integer      KUPL  ,GNU  ,SHELXL
	parameter   (KUPL=0,GNU=3,SHELXL=4)
c
	character*200  line
	integer      i,j,ii,k,itic
	integer      extr_ima
	integer      nx(2),ny(2)
	integer      ftyp
	real	     h(3)
	real         y(3),phase
	real         xmin(2),xmax(2)
	real         ymin(2),ymax(2)
	real         x1,x2,y1,y2,zz1,zz2,zz3,zz4
	real         z1(10000),z2(10000)
	complex      a_b
c
	call oeffne(ifa,rho_file(1),'old',.true.)
	if(ier_num.ne.0) then
	  return
	endif
	if(ltwo_files) then
	  call oeffne(ifb,rho_file(2),'old',.true.)
	  if(ier_num.ne.0) then
	    return
	  endif
	endif
c
	if(patt_accu.eq.PATT_INIT) then
	  ii = 0
	  do i=1,rho_inc(1)
	    do j=1,rho_inc(2)
	      ii = ii + 1
	      csf(ii) = cmplx(0.0d0,0.0d0)
	    enddo
	  enddo
	endif
c
	if(ftyp.eq.SHELXL) then
10	  continue
c
c------	----read hkl,fobs,fcalc,phase
c
	    read(ifa,*,end=20,err=900) h,zz1,zz2,zz3
c
c------	----Apply reciprocal space symmetry operations
c
	    do k=1,rec_n_sym
	      phase = 0.0
	      do i=1,3
	        y(i) = 0
	        do j=1,3
	          y(i) = y(i) + rec_sym(i,j,k)*h(j)
	        enddo
	        phase = phase + y(i)*rec_sym(i,4,k)
	      enddo
	      zz4 = zz3 + 360.0 * phase
c
c------	------Calculate appropriate value, contribute to invers/Patterson
c
	      call set_patt_value_s(a_b,inverse_type,rho_type,
     &	                            zz1,zz2,zz4)
	      call calc_patters(a_b,y,vr)
c
c------	------If the space group is acentric, apply -1 operation
c
	      if(acentric) then
	        do i=1,3
	          y(i) = -y(i)
	        enddo
	        zz4 = -zz4
	        call set_patt_value_s(a_b,inverse_type,rho_type,
     &	                              zz1,zz2,zz4)
	        call calc_patters(a_b,y,vr)
	      endif
	    enddo
	  goto 10
20	  continue
	else
	  extr_ima = 6 - extr_abs - extr_ord
c
c------	--One dimensional input files
c
	  if(inc(1).eq.1 .or. inc(2).eq.1) then
	    ii = max(inc(1),inc(2))
	    itic = max(5,ii/10)
	    do i=1,ii
	      if(mod(i,itic).eq.0) write(*,*) i
	      read(ifa,*,end=900,err=900) h(extr_abs),z1(1)
	      if(ltwo_files) then
	        read(ifb,*,end=900,err=900) h(extr_abs),z2(1)
	      else
	        z2(1) = 0.0
	      endif
c	      write(*,*) h(extr_abs),z1(1),z2(1)
	      j = 1
	      do k=1,3
	        h(k) = eck(k,1) + vi(k,1)*float(i-1) + 
     &	                          vi(k,2)*float(j-1)
	      enddo
	      call set_patt_value(a_b,inverse_type,rho_type,z1,z2,1)
	      call calc_patters(a_b,h,vr)
	    enddo
c
c------	--Two dimensional Files (KUPL Format)
c
	  else
	    if(ftyp.eq.KUPL) then
	      ier_num = -3
	      ier_typ = ER_IO
	      read(ifa,*,err=900,end=900) nx(1),ny(1)
	      read(ifa,*,err=900,end=900) xmin(1),xmax(1),ymin(1),ymax(1)
	      if(ltwo_files) then
	        read(ifb,*,err=900,end=900) nx(2),ny(2)
	        read(ifb,*,err=900,end=900) xmin(2),xmax(2),
     &	                                    ymin(2),ymax(2)
	      else
	          nx(2)   = nx(1)
	        ny(2)   = ny(1)
	        xmin(2) = xmin(1)
	        xmax(2) = xmax(1)
	        ymin(2) = ymin(1)
	        ymax(2) = ymax(1)
	      endif
	      ier_num = 0
	      ier_typ = ER_NONE
	      if(nx(1)  .eq.nx(2)   .and. ny(1)  .eq.ny(2)   .and.
     &	         xmin(1).eq.xmin(2) .and. ymin(1).eq.ymin(2) .and.
     &	         xmax(1).eq.xmax(2) .and. ymax(1).eq.ymax(2) ) then
	        itic = max(5,inc(2)/10)
	        do j=1,ny(1)
	          if(mod(j,itic).eq.0) write(*,*) j
	          ier_num = -3
	          ier_typ = ER_IO
	          read(ifa,*,err=900,end=900) (z1(i),i=1,nx(1))
	          if(ltwo_files) then
	            read(ifb,*,err=900,end=900) (z2(i),i=1,nx(1))
	          endif
	          ier_num = 0
	          ier_typ = ER_NONE
	          do i=1,inc(1)
	            call set_patt_value(a_b,inverse_type,rho_type,
     &	                                z1,z2,i)
	            do k=1,3
	              h(k) = eck(k,1) + vi(k,1)*float(i-1) + 
     &	                                vi(k,2)*float(j-1)
	            enddo
	            call calc_patters(a_b,h,vr)
	          enddo
	        enddo
	      else
	        ier_num = -22
	        ier_typ = ER_APPL
	      endif
	    elseif(ftyp.eq.GNU) then
	      ier_num = -23
	      ier_typ = ER_APPL
	      itic = max(5,inc(2)/10)
	      do j=1,inc(2)
	        if(mod(j,itic).eq.0) write(*,*) j
	        do i=1,inc(1)
	          read(ifa,*,end=900,err=900) x1,y1,z1(1),zz1
	          if(ltwo_files) then
	            read(ifb ,*,end=900,err=900) x2,y2,z2(1),zz2
	          endif
	          if(.not. ltwo_files  .or. (ltwo_files .and.
     &	             (x1.eq.x2 .and. y1.eq.y2 .and. zz1.eq.zz2)) ) then
	            h(extr_abs) = x1
	            h(extr_ord) = y1
	            h(extr_ima) = zz1
	            call set_patt_value(a_b,inverse_type,rho_type,
     &	                                z1,z2,1)
	            call calc_patters(a_b,h,vr)
	          else
	            ier_num = -24
	            ier_typ = ER_APPL
	            goto 900
	          endif
	        enddo
	        read(ifa,1000,end=900,err=900) line
	        if(line.eq.' ') then
	          if(ltwo_files) then
	            read(ifb,1000,end=900,err=900) line
	          endif
	          if(line.ne.' ') then
	            ier_num = -23
	            ier_typ = ER_APPL
	            goto 900
	          endif
	        endif
	      enddo
	      ier_num =  0
	      ier_typ = ER_NONE
	    endif
	  endif
	endif
c
900	continue
c
	ii = 0
	do i=1,rho_inc(1)
	  do j=1,rho_inc(2)
	    ii = ii + 1
	    csf(ii) = csf(ii)*patt_scale*vr
	  enddo
	enddo
c
	close(ifa)
	if(ltwo_files) then
	  close(ifb)
	endif
c
1000	format(a)
2000	format(5(f9.3,2x))
	end
c*****7*****************************************************************
	subroutine calc_patters(a_b,h,vr)
c-
c	Calculates the patterson or inverse Fourier at all points
c	in real space.
c+
	implicit      none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'patters.inc'
	include      'diffuse.inc'
c
	real          h(3)
	real          vr
c
	real*8	      xarg0,xincu,xincv
	integer	      iarg,iarg0,iincu,iincv,iadd
	integer       i,j,ii
	complex       a_b
c
	integer       ISHFT,IAND
c
	call four_cexpt
	ii = max(5,rho_inc(2)/10)
c
	xarg0 = rho_eck(1,1)*h(1)+rho_eck(2,1)*h(2)+rho_eck(3,1)*h(3)
	xincu = rho_vi (1,1)*h(1)+rho_vi (2,1)*h(2)+rho_vi (3,1)*h(3)
	xincv = rho_vi (1,2)*h(1)+rho_vi (2,2)*h(2)+rho_vi (3,2)*h(3)
c
	iarg0 = nint( 64*I2PI*( xarg0-int(xarg0)+1.0d0))
	iincu = nint( 64*I2PI*( xincu-int(xincu)+1.0d0))
	iincv = nint( 64*I2PI*( xincv-int(xincv)+1.0d0))
c
	iarg0 = patt_sign*iarg0
	iarg  = iarg0
c
	ii = 0
c
	do j=1,rho_inc(1)
	  do i=1,rho_inc(2)
	    iadd = ISHFT(iarg,-6)
	    iadd = IAND (iadd,MASK)
	    ii = ii + 1
	    csf(ii) = csf(ii) + cex(iadd)*a_b
	    iarg = iarg + iincv * patt_sign
	  enddo
	  iarg = iarg0 + iincu*j * patt_sign
	enddo
c
	end
c*****7*******1**********************************************************
	subroutine set_patt_value(a_b,inverse_type,rho_type,z1,z2,i)
c-
c	Sets the appropriate values for the inverse Fourier or
c	Patterson.
c+
	implicit      none
c
	include      'intens.inc'
	include      'inverse.inc'
c
	integer       rho_type(2)
	real          z1(10000),z2(10000)
	complex       a_b
c
	integer       i
c
	real          cosd,sind
c
	if(inverse_type.eq.INV_INV) then
	  if(    rho_type(1).eq.REAL_PART .and.
     &	         rho_type(2).eq.IMAG_PART       ) then
	    a_b = cmplx( z1(i),
     &	                 z2(i) )
	  elseif(rho_type(1).eq.INTENSITY .and.
     &	         rho_type(2).eq.PHASE_ANG       ) then
	    a_b = cmplx( sqrt(z1(i)) * cosd(z2(i)),
     &	                 sqrt(z1(i)) * sind(z2(i)) )
	  elseif(rho_type(1).eq.AMPLITUDE .and.
     &	         rho_type(2).eq.PHASE_ANG       ) then
	    a_b = cmplx(      z1(i)  * cosd(z2(i)),
     &	                      z1(i)  * sind(z2(i)) )
	  endif
	elseif(inverse_type.eq.INV_PATT) then
	  if(    rho_type(1).eq.INTENSITY       ) then
	    a_b = cmplx( z1(i),
     &	                 0.0   )
	  elseif(rho_type(1).eq.REAL_PART .and.
     &	         rho_type(2).eq.IMAG_PART       ) then
	    a_b = cmplx( z1(i)*z1(i) + z2(i)*z2(i),
     &	                 0.0                       )
	  elseif(rho_type(1).eq.AMPLITUDE       ) then
	    a_b = cmplx( z1(i)*z1(i),
     &	                 0.0         )
	  endif
	endif
c
	end
c*****7*****************************************************************
	subroutine set_patt_value_s(a_b,inverse_type,rho_type,
     &	                            zz1,zz2,zz3)
c-
c	Sets the appropriate values for the inverse Fourier or
c	Patterson. Special Version for SHELXL Input
c+
	implicit      none
c
	include      'intens.inc'
	include      'inverse.inc'
c
	integer       rho_type(2)
	real          zz1,zz2,zz3
	complex       a_b
c
	real          cosd,sind
c
	if(inverse_type.eq.INV_INV) then
	  if(    rho_type(1).eq.AMPLITUDE       ) then
	    a_b = cmplx(      zz1    * cosd(zz3  ) ,
     &	                      zz1    * sind(zz3  )  )
	  elseif(rho_type(1).eq.FCALC           ) then
	    a_b = cmplx(      zz2    * cosd(zz3  ) ,
     &	                      zz2    * sind(zz3  )  )
	  endif
	elseif(inverse_type.eq.INV_PATT) then
	  if(    rho_type(1).eq.AMPLITUDE       ) then
	    a_b = cmplx(      zz1    *   zz1 ,
     &	                      0.0             )
	  elseif(rho_type(1).eq.FCALC           ) then
	    a_b = cmplx(      zz2    *   zz2 ,
     &	                      0.0             )
	  endif
	elseif(inverse_type.eq.INV_DIFF) then
	  a_b = cmplx( (zz1 - zz2) * cosd(zz3  ) ,
     &	               (zz1 - zz2) * sind(zz3  )  )
	endif
c
	end
