c*****7*****************************************************************
	subroutine do_show(line,laenge)
c-
c	These subroutine is the main routine for showing various
c	parameters.
c
c	Version  : 1.0
c	Date     : 03 Jul 96
c
c	Author   : R.B. Neder (neder@yoda.kri.physik.uni-muenchen.de)
c+
	implicit       none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'errlist.inc'
	include       'param.inc'
c
	integer        maxw
	parameter     (maxw=7)
c
	character*200  cpara(maxw),line
	integer        lpara(maxw)
	integer        ianz
	integer        i,j
	integer        laenge
	real           werte(maxw)
c
	logical        str_comp
c
	call get_params(line,ianz,cpara,lpara,maxw,laenge)
	if(ier_num.eq.0) then
c
c------	--Interprete first parameter as command
c
c
c------	----Show composition of asymmetric unit 'asym'
c
	  if(str_comp(cpara(1),'asym',2,lpara(1),4)) then
	    call show_asym
c
c------	----Show an atom                     'atom'
c
	  elseif(str_comp(cpara(1),'atom',2,lpara(1),4)) then
	    call do_show_atom(ianz,cpara,lpara,werte,maxw)
c
c------	----Show the chemistry               'chem'
c
	  elseif(str_comp(cpara(1),'chem',1,lpara(1),4)) then
	    call show_chem
c
c------	----Show the dimensions              'cdim'
c
	  elseif(str_comp(cpara(1),'cdim',1,lpara(1),4)) then
	    write(*,2000) ((cr_dim(j,i),i=1,2),j=1,3)
c
c------	----Show the error status            'error'
c
	  elseif(str_comp(cpara(1),'error',1,lpara(1),5)) then
	    if(ier_sta.eq.ER_S_CONT) then
	      write(*,2100)
	    else
	      write(*,2105)
	    endif
c
c------	----Show result array                'result'
c
	  elseif(str_comp(cpara(1),'result',1,lpara(1),6)) then
	    call do_show_res
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	endif
c
2000	format(' Current crystal dimensions:'/
     &	       '          minimum       maximum'/
     &	       '  X ',2(2x,f12.4)/
     &	       '  Y ',2(2x,f12.4)/
     &	       '  Z ',2(2x,f12.4))
2100	format(' Program continues after display of error message')
2105	format(' Program terminates after display of error message')
c
	end
c*****7*****************************************************************
	subroutine show_asym
c-
c	This subroutine shows the content of the asymmetric unit
c+
	implicit      none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'macro.inc'
	include       'envir.inc'
c
	character*1   cdummy
	integer       i,j,k,l
c
	do j=1,as_natoms/(LINES-2)
	  write(*,2000)
	  do i=1,LINES-2
	    k = (j-1)*(LINES-2) + i
	    write(*,2010) as_at_lis(k),as_iscat(k),
     &	                  (as_pos(l,k),l=1,3),as_dw(as_iscat(k))
	  enddo
	  if (.not. lmakro) then
	    write(*,2020)
	    read (*,1000) cdummy
	  endif
	enddo
	write(*,2000)
	j=as_natoms/(LINES-2)+1
	do i=1,as_natoms-(as_natoms/(LINES-2))*(lines-2)
	  k = (j-1)*(LINES-2) + i
	  write(*,2010) as_at_lis(k),as_iscat(k),
     &	                (as_pos(l,k),l=1,3),as_dw(as_iscat(k))
	enddo
c
1000	format(a)
2000	format(' Asymmetric unit'/ ' Name    Type       x',
     &	'             y             z               B')
2010	format(1x,a4,2x,i4,3(2x,f12.5),4x,f12.5)
2020	format(' Press RETURN for more ...')
	end
c*****7*****************************************************************
	subroutine show_chem
c-
c	This subroutine shows the different atom types present
c	in the crystal
c+
	implicit      none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'macro.inc'
	include       'envir.inc'
c
	character*1   cdummy
	integer       i,j,k
	integer       kvoid
c
	character*9   at_name
c
	if(cr_ndel.gt.0) then
	  kvoid = -1
	else
	  kvoid =  0
	endif
c
	do j=1,(cr_nscat - kvoid)/(LINES-2)
	  write(*,2000)
	  do i=1,LINES-2
	    k = (j-1)*(LINES-2) + i + kvoid
	    write(*,2010) at_name(k),k,cr_dw(k)
	  enddo
	  if (.not. lmakro) then
	    write(*,2020)
	    read (*,1000) cdummy
	  endif
	enddo
	write(*,2000)
	j=(cr_nscat - kvoid)/(LINES-2)+1
	do i=1,cr_nscat-((cr_nscat-kvoid)/(LINES-2))*(LINES-2) - kvoid
	  k = (j-1)*(LINES-2) + i + kvoid
	  write(*,2010) cr_at_lis(k),k,cr_dw(k)
	enddo
c
1000	format(a)
2000	format(' Atoms present  '/ ' Name         Type       B')
2010	format(1x,a9,2x,i4,2x,f12.5)
2020	format(' Press RETURN for more ...')
	end
c*****7*****************************************************************
	subroutine do_show_res
c-
c	Shows the result array
c+
	implicit       none
c
	include       'errlist.inc'
	include       'param.inc'
c
	integer        i,j,k,k1,k2
c
	if(nint(res_para(0)).eq.0) then
	  write(*,*) 'Result array is empty'
	else
	  write(*,2000) nint(res_para(0))
	  j = nint(res_para(0))/5
	  if(mod(nint(res_para(0)),5).eq.0) then
	    j = j-1
	  endif
	  do i=0,j
	    k1 =     5*i+1
	    k2 = min(5*i+5,nint(res_para(0)))
	    write(*,2001) (res_para(k),k=k1,k2)
	  enddo
	endif
c
2000	format( i8,' Values in the result array')
2001	format(5(2x,g13.7))
	end
c*****7*****************************************************************
	subroutine do_show_atom(ianz,cpara,lpara,werte,maxw)
c-
c	Shows information about an atom.
c+
	implicit       none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'errlist.inc'
c
	integer        maxw
c
	character*200  cpara(maxw)
	integer        ianz
	integer        lpara(maxw)
	real           werte(maxw)
c
	integer        i,istart,iend
c
	character*9    at_name
c
	cpara(1) = '0.0'
	lpara(1) = 3
c
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if(ier_num.eq.0) then
	  if(ianz.eq.2 .or. ianz.eq.3) then
	    istart = nint(werte(2))
	    if(ianz.eq.2) then
	      iend = istart
	    else
	      iend = nint(werte(3))
	    endif
	    write(*,3000)
	    do i=istart,iend
	      write(*,3010) at_name(cr_iscat(i)),
     &	          cr_pos(1,i),cr_pos(2,i),cr_pos(3,i),
     &	          cr_dw(cr_iscat(i))
	    enddo
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	endif
c
3000	format(' Name',11x,'x',13x,'y',13x,'z',11x,'B')
3010	format(1x,a9,3(2x,f12.6),4x,f10.6)
	end
c*****7*****************************************************************
