c*****7*****************************************************************
c
c	This file contains several subroutines for command language
c	handling.
c
c	Version : 1.1
c	Date    : 16 Oct 96
c
c	Authors : R.B. Neder  (neder@yoda.kri.physik.uni-muenchen.de)
c                 Th. Proffen (proffen@rsc.anu.edu.au)
c
c*****7*****************************************************************
	subroutine do_cap (str)
c+
c 	Converts string 'str' to upper letters
c-
	implicit      none
c
	character*(*) str
	integer       i
	integer       len
C
        do i=1,len(str)
	  if (ichar(str(i:i)).ge.ichar('a') .and. 
     &	      ichar(str(i:i)).le.ichar('z'))      then 
	    str(i:i) = char (ichar(str(i:i))-ichar('a')+ichar('A'))
	  endif
	enddo
	end		
C*****7***********************************************************
	subroutine ini_ran(iflag)
c
	implicit      none
c
	include      'random.inc'
c
	integer          iflag
	real             seknds
c
	if(iflag.ge.0) then
	  idum=  -seknds(0.0)
	else
	  idum = iflag
	endif
	iset = 0
	end
c*****7***********************************************************
	subroutine get_command (line,ll,befehl,lbef,zeile,lp,prom)
c+
c	This subroutine gets a command for processing. If it
c	is keyboard input and the program was compiled with
c	READLINE defined, you will have basic line editing
c	functions.
c-
	implicit	none
c
	include		'macro.inc'
	include		'doact.inc'
	include		'learn.inc'
	include		'errlist.inc'
	include		'prompt.inc'
c
	character*(*)	line,befehl,zeile,prom
	character*30	bprom
	integer		lbef,lpr,lp,ll,indxb
	integer         lll
	logical		lreg
	logical         str_comp
c
	integer		len_str
c
	line = ' '
c
	if(lblock) then
	  call do_execute(lreg,line,ll)
          if(ier_num.ne.0 .or. .not. lreg) return
	elseif(lmakro .and. .not.lblock_dbg) then
	  call do_prompt(prom)
	  call macro_read(line,ll)
          if(ier_num.ne.0) return
	else
c
c------	--Normal mode, if status is PROMPT_OFF or PROMPT_REDIRECT
c------ --we assume non interactive input and use 'normal' FORTRAN
c------ --READ to avoid EOF problems.
c
	  if(prompt_status.eq.PROMPT_ON) then
	    lpr   = len_str(prom)
	    bprom = char(27)//'[1m '//prom(1:lpr)//' > '//
     &	            char(27)//'[0m' 
	    lpr   = len_str(bprom)
	    ll    = len(line)
c
c------	----call the c-routine that enables command history & line editing
c
	    call cread(bprom,lpr,line,ll)
	    if (ll.lt.0) then
	      call do_prompt(prom)
	      read(* ,2000,end=990,err=995) line
	    endif
c
c------ --otherwise use normal READ
c
	  else
	    call do_prompt(prom)
	    read(* ,2000,end=990,err=995) line
	  endif
c
	  ll = len_str(line)
          if(prompt_status.eq.PROMPT_REDIRECT) then
            if(ll.gt.0) then
              write(*,2000) line(1:ll)
            else
              write(*,2000)
            endif
          endif
	endif
c
	if(ll.eq.0 .or. line(1:1).eq.'#' .or. line(1:1).eq.' ') then
	  ll = 0
	  return
	endif
c
c------	Learn command for learn sequence
c
	lll = min(ll,4)
	if(llearn .and.
     &	   .not.str_comp(line(1:lll),'lend',3,lll,4) ) then
	  if(ll.gt. 0) then
	    write (33,2000) line(1:ll)
	  else
	    write (33,2000)
	  endif
	endif
c
c------	The maximum number of significant characters depends on the length of
c------	the character constant befehl.
c
	lbef   = len(befehl)
	befehl = '    '
	indxb  = index(line,' ')
	lbef   = min(indxb-1,lbef)
	befehl = line(1:lbef)
c
c------	command parameters start at the first character following 
c------ the blank
c
	zeile = ' '
	lp    = 0
	if(indxb+1 .le. ll) then
	  zeile = line(indxb+1:ll)
	  lp    = ll - indxb
	endif
c
c------	Normal return
c
	return
c
c------	EOF in input
c
990	continue
	line ='exit'
	ll   = 4
	befehl = 'exit'
	lbef   = 4
	zeile  = ' '
	lp     = 0
	return
c
c------	Error in input
c
995	continue
	ier_num = -9
	ier_typ = ER_IO
	return
c
2000	format (a)
	end
c*****7***********************************************************
	subroutine do_input(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
	include      'param.inc'
c
	integer       maxw
	parameter    (maxw=1)
c
	character*(*) zeile
	character*200 cpara(maxw)
	character*1   cdummy
	real          wert
	integer       lpara(maxw),lp
	integer       ianz
	logical       str_comp
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if(ier_num.ne.0) return
c
	if(ianz.eq.0) then
	  write (*,1000)
	  read  (*,5000,err=50,end=50) cdummy
	elseif(ianz.eq.1) then
	  if(str_comp(cpara(1),'return',1,lpara(1),6)) then
	    write (*,1000)
	    read  (*,5000,err=50,end=50) cdummy
	  elseif(str_comp(cpara(1),'input',1,lpara(1),5)) then
	    write (*,1500)
	    read  (*,*,err=50,end=50) wert
	    res_para(0)=1.0
	    res_para(1)=wert
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
	return
c
50	continue
	ier_num = -9
	ier_typ = ER_IO
c
1000	format (' ------ > Waiting for <RETURN> : ',$)
1500	format (' ------ > Waiting for input : ',$)
5000	format (a)
	end
C*****7***********************************************************
	subroutine do_seed(zeile,lp)
c
	implicit      none
c
	include      'errlist.inc'
c
	integer       maxw
	parameter    (maxw=1)
c
	character*(*) zeile
	character*200 cpara(maxw)
	integer       lpara(maxw),lp
	integer       ianz,iflag
	real          werte(maxw)
c
	if(zeile.ne. ' ') then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if(ier_num.eq.0) then
	    if(ianz.eq.1) then
	      call ber_params(ianz,cpara,lpara,werte,maxw)
	      if(ier_num.eq.0) then
	        iflag = -iabs(nint(werte(1)))
	        call ini_ran(iflag)
	      endif
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  endif
	else
	  call ini_ran(0)
	endif
	end
c*****7***********************************************************
	subroutine do_prompt(prom)
c*
c	This routine prints the bold prompt on the screen
c-
	implicit      none
c
	include      'prompt.inc'
c
	character*(*)   prom
	character*4     fett,norm
c
	if(prompt_status.eq.PROMPT_ON       .or.
     &	   prompt_status.eq.PROMPT_REDIRECT      ) then
	  fett  = char(27)//'[1m'
	  norm  = char(27)//'[0m'
	  write (*,'(1X,A4,A,A4,'' > '',$)') fett,prom,norm
	endif
c
	end
C*****7***********************************************************
	logical function str_comp(a,b,j,la,lb)
c-
c	compares the first non blank characters of the two strings 
c	for equality. At least j characters must be identical.
c+
	implicit      none
c
	character*(*) a,b
	integer       i,j,la,lb,ia,ib
c
	ia = min(index(a,' '),la)
	ib = min(index(b,' '),lb)
	if(ia.eq.0) then
	  ia = la
	endif
	if(ib.eq.0) then
	  ib = lb
	endif
	i = min(ia,ib)
	i = max(i,j)
	str_comp = a(1:i).eq.b(1:i)
c
	end
C*****7***********************************************************
	subroutine do_set(zeile,lp)
c-
c	Sets the value of status variables
c+
	implicit      none
c
	include      'errlist.inc'
	include      'prompt.inc'
c
	integer       maxw
	parameter    (maxw=2)
c
	character*(*) zeile
	character*200 cpara(maxw)
	integer       lpara(maxw),lp
	integer       ianz
c
	logical       str_comp
c
	ier_num = 0
	ier_typ = ER_NONE
	if(zeile.ne. ' ') then
	  call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	  if(ier_num.eq.0) then
	    if(str_comp(cpara(1),'error',1,lpara(1),5)) then
	      if(ianz.eq.2) then
	        if(str_comp(cpara(2),'cont',2,lpara(2),4)) then
	          ier_sta = ER_S_CONT
	        elseif(str_comp(cpara(2),'exit',2,lpara(2),4)) then
	          ier_sta = ER_S_EXIT
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    elseif(str_comp(cpara(1),'prompt',1,lpara(1),6)) then
	      if(ianz.eq.2) then
	        if(str_comp(cpara(2),'on',2,lpara(2),2)) then
	          prompt_status = PROMPT_ON
	        elseif(str_comp(cpara(2),'off',2,lpara(2),2)) then
	          prompt_status = PROMPT_OFF
	          write(*,2000)
	        elseif(str_comp(cpara(2),'redirect',1,lpara(2),8)) then
	          prompt_status = PROMPT_REDIRECT
	          write(*,2000)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
	    endif
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
2000	format(a)
c
	end
C*****7*****************************************************************
