c+
c	Generalized symmetry operations:
c	Rotations around a general axis by a general angle
c	Mirror operations with free choice of normal and glide 
c	component.
c
c	Version : 2.0
c	Date    : 12 Jul 96
c
c	Author  : R.B. Neder  (neder@yoda.kri.physik.uni-muenchen.de)
c
C*****7*****************************************************************
	subroutine symm
c-
c	Main menu for generalized symmetry operations
c+
	implicit      none
c
	include       'config.inc'
	include       'crystal.inc'
	include       'crystal.cmm'
	include       'doact.inc'
	include       'errlist.inc'
	include       'learn.inc'
	include       'macro.inc'
	include       'prompt.inc'
	include       'symm.inc'
c
	integer        maxw
	parameter     (maxw=MAXSCAT)
	logical        lnew,lold
	parameter     (lnew=.true.,lold=.false.)
c
	character*5    befehl
	character*11   prom
	character*200  line,zeile,cpara(maxw)
	integer        lpara(maxw),lp,length,lbef
	integer        indxg,ianz,i,j
	logical        lend,lspace
	real           hkl(3)
	real           werte(maxw)
c
	logical        str_comp
c
	include 'microsta.inc'
c
	lend=.false.
	call no_error
c
	do while (.not. lend)
	  prom=prompt//'/symm'
	  call get_command (line,length,befehl,lbef,zeile,lp,prom)
	  if(line.ne.' ' .and. line(1:1).ne.'#') then
c
c------	----search for "="
c
	    indxg=index(line,'=')
	    if(indxg.ne.0 
     &	              .and. .not.(str_comp(befehl,'echo',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'syst',2,lbef,4))
     &	              .and. .not.(str_comp(befehl,'help',2,lbef,4) .or.
     &	                          str_comp(befehl,'?   ',2,lbef,4)) )then
c
c------	------evaluatean expression and assign the value to a variabble
c
	      call do_math(line,indxg,length)
	    else
c
c------ ----execute a macro file
c
            if(befehl(1:1).eq.'@') then
	      if(length.ge.2) then
	        call file_kdo(line(2:length),length-1)
	      else
	        ier_num = -13
	        ier_typ = ER_MAC
	      endif
c
c------	----angle of rotation 'angle'
c
	    elseif(str_comp(befehl,'angle',2,lbef,5)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.1) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          sym_angle = werte(1)
	        endif
	      endif
c
c------	----list asymmetric unit 'asym'
c
	    elseif(str_comp(befehl,'asym',2,lbef,4)) then
	      call show_asym
c
c------	----calculate a single symmetry operation
c
	    elseif(str_comp(befehl,'calc',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.3) then
		  cpara(4) = 'd'
		  lpara(4) = 1
		endif
		ianz = 3
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            hkl(i) = werte(i)
	          enddo
	          if(str_comp(cpara(4),'d',1,lpara(4),1)) then
		    lspace = .true.
	          elseif(str_comp(cpara(4),'r',1,lpara(4),1)) then
		    lspace = .false.
		  else
	            ier_num = -6
	            ier_typ = ER_COMM
		  endif
		  if(ier_num.eq.0) then
	            if(sym_power_mult ) then
	              call symm_ca_mult(hkl,lspace)
	            else
	              call symm_ca_single(hkl,lspace)
	            endif
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----continues a macro 'continue'
c
	    elseif(str_comp(befehl,'continue',2,lbef,8)) then
	      call macro_continue(zeile,lp)
c
c------	----list atoms present in the crystal 'chem'
c
	    elseif(str_comp(befehl,'chem',2,lbef,4)) then
	      call show_chem
c
c------	----Deselect which atoms are included in the wave 'dese'
c
	    elseif(str_comp(befehl,'dese',1,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 ) then
	        if(cpara(1)(1:3).eq.'mic') then
	          sym_md_s  = MD_S_EVE
	          sym_md_nr = 0
	        else
	          call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	          if(ier_num.eq.0) then
	            if(werte(1).eq.-1) then
	              do i=1,cr_nscat
	                sym_latom(i) = .false.
	              enddo
	            else
	              do i=1,ianz
	                sym_latom(nint(werte(i))) = .false.
	              enddo
	            endif
	          endif
	        endif
	      endif
c
c------ ----Echo a string, just for interactive check in a macro 'echo'
c
	    elseif(str_comp(befehl,'echo',2,lbef,4)) then
              write(*,'(1x,a)') zeile(1:79)
c
c------	 ---Evaluate an expression, just for interactive check 'eval'
c
	    elseif(str_comp(befehl,'eval',2,lbef,4)) then
	      call do_eval(zeile,lp)
c
c------	----exit 'exit'
c
	    elseif(str_comp(befehl,'exit',2,lbef,4)) then
	      lend=.true.
c
c------	----help 'help','?'
c
	    elseif(str_comp(befehl,'help',2,lbef,4) .or.
     &	           str_comp(befehl,'?   ',1,lbef,4)     ) then
	      if(str_comp(zeile,'errors',2,lp,6) ) then
	        lp = lp + 7
	        call do_hel('discus '//zeile,lp)
	      else
	        lp = lp + 12
	        call do_hel('discus symm '//zeile,lp)
	      endif
c
c------	----Select the reciprocal space direction of the symmetry axis 'hkl'
c
	    elseif(str_comp(befehl,'hkl ',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            sym_hkl(i) = werte(i)
	          enddo
	          call trans(sym_hkl,cr_rten,sym_uvw,3)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select range of atoms within crystal to be included 'incl'
c
	    elseif(str_comp(befehl,'incl',1,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.2) then
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	            sym_start = nint(werte(1))
	            sym_end   = nint(werte(2))
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----Select the mode of symmetry operation                  'mode'
c
	    elseif(str_comp(befehl,'mode',1,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1) then
	          if(str_comp(cpara(1),'copy',1,lpara(1),4)) then
	            sym_mode = .true.
	          elseif(str_comp(cpara(1),'repl',1,lpara(1),4)) then
	            sym_mode = .false.
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        endif
	      endif
c
c------	----Select the origin of the symmetry operation  'origin'
c
	    elseif(str_comp(befehl,'origin',1,lbef,6)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            sym_orig(i) = werte(i)
	          enddo
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Set the power of the symmetry operation  'power'
c
	    elseif(str_comp(befehl,'power',1,lbef,6)) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1 .or. ianz.eq.2) then
	          if(ianz.eq.2) then
	            if(str_comp(cpara(2),'mult',1,lpara(2),4)) then
	              sym_power_mult = .true.
	            elseif(str_comp(cpara(2),'sing',1,lpara(2),4)) then
	              sym_power_mult = .false.
	            else
	              ier_num = -6
	              ier_typ = ER_COMM
	            endif
	          endif
	          ianz = 1
	          call ber_params(ianz,cpara,lpara,werte,maxw)
	          if(ier_num.eq.0) then
	              sym_power = nint(werte(1))
	          endif
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      endif
c
c------	----run waves 'run'
c
	    elseif(str_comp(befehl,'run ',1,lbef,4)) then
	      call symm_setup
	      if(sym_power_mult ) then
	        call symm_op_mult
	      else
	        call symm_op_single
	      endif
c
c------	----Select which atoms are copied to their image 'sele'
c
	    elseif(str_comp(befehl,'sele',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call  get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(cpara(1)(1:3).eq.'mic' .and. ianz.eq.2) then
	          if(cpara(2)(1:3).eq.'all') then
	            sym_md_s  = MD_S_ALL
	            sym_md_nr = 0
	          elseif(cpara(2)(1:3).eq.'non') then
	            sym_md_s  = MD_S_NON
	            sym_md_nr = 0
	          elseif(cpara(2)(1:3).eq.'eve') then
	            sym_md_s  = MD_S_EVE
	            sym_md_nr = 0
	          else
	            cpara(1) = '0.0'
	            lpara(1) = 3
	            call ber_params(ianz,cpara,lpara,werte,maxw)
	            sym_md_nr = nint(werte(2))
	            sym_md_s  = MD_S_IND
	          endif
	        else
	          call get_iscat(ianz,cpara,lpara,werte,maxw,lold)
	          if(ier_num.eq.0) then
	            if(werte(1).eq.-1) then
	              do i=1,cr_nscat
	                sym_latom(i) = .true.
	              enddo
	            else
	              do i=1,ianz
	                sym_latom(nint(werte(i))) = .true.
	              enddo
	            endif
	          endif
	        endif
	      endif
c
c------	----show current parameters 'show'
c
	    elseif(str_comp(befehl,'show',2,lbef,4)) then
	      call symm_setup
	      write(*,3000) sym_uvw
	      write(*,3010) sym_hkl
	      write(*,3020) sym_orig
	      write(*,3030) sym_angle
	      write(*,3040) sym_trans
	      write(*,3039) ((sym_mat (i,j),j=1,4),i=1,3)
	      write(*,3044) ((sym_rmat(i,j),j=1,3),i=1,3)
	      write(*,3041) sym_power
	      if(sym_power_mult) then
	        write(*,3042)
	      else
	        write(*,3043)
	      endif
	      if(sym_type) then
	        write(*,3050)
	      else
	        write(*,3051)
	      endif
	      if(sym_mode) then
	        write(*,3060)
	      else
	        write(*,3061)
	      endif
	      write(*,3070) cmic_s(sym_md_s)
	      if(sym_md_s.eq.MD_S_IND) then
	        write(*,3075) sym_md_nr
	      endif
	      write(*,3090)
	      write(*,3091)
	      do i=1,cr_nscat
	        if(sym_latom(i)) then
	          write(*,3092) i,cr_at_lis(i)
	        endif
	      enddo
	      write(*,3080) sym_start,sym_end
c
c------	----Select translational part of the symmetry operation 'trans'
c
	    elseif(str_comp(befehl,'trans',2,lbef,5)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            sym_trans(i) = werte(i)
	          enddo
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------	----Select the type of symmetry operation                  'type'
c
	    elseif(str_comp(befehl,'type',2,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0) then
	        if(ianz.eq.1) then
	          if(str_comp(cpara(1),'proper',1,lpara(1),6)) then
	            sym_type = .true.
	          elseif(str_comp(cpara(1),'improper',1,lpara(1),8)) then
	            sym_type = .false.
	          else
	            ier_num = -6
	            ier_typ = ER_COMM
	          endif
	        endif
	      endif
c
c------	----Select the direct space direction of the symmetry axis 'uvw'
c
	    elseif(str_comp(befehl,'uvw ',1,lbef,4)) then
	      ier_num = -6
	      ier_typ = ER_COMM
	      call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	      if(ier_num.eq.0 .and. ianz.eq.3) then
	        call ber_params(ianz,cpara,lpara,werte,maxw)
	        if(ier_num.eq.0) then
	          do i=1,3
	            sym_uvw(i) = werte(i)
	          enddo
	          call trans(sym_uvw,cr_gten,sym_hkl,3)
	        else
	          ier_num = -6
	          ier_typ = ER_COMM
	        endif
	      else
	        ier_num = -6
	        ier_typ = ER_COMM
	      endif
c
c------- -Operating System Kommandos 'syst'
c
	  elseif(str_comp(befehl,'syst',2,lbef,4)) then
	    if(zeile.ne. ' ') then
	      call do_operating(zeile(1:lp))
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
c
c------  -----waiting for user input
c
	    elseif(str_comp(befehl,'wait',3,lbef,4)) then
	      call do_input(zeile,lp)
	    else
	      ier_num = -8
	      ier_typ = ER_COMM
	    endif
	    endif
	  endif
	  if(ier_num.ne.0) then
	    call errlist
	    if(lmakro) then
	      call macro_close
	      prompt_status = PROMPT_ON
	    endif
	    if(lblock) then
	      ier_num = -11
	      ier_typ = ER_COMM
	      return
	    endif
	    call no_error
	  endif
	enddo
c
9999	continue
c
3000	format(' Generalized Symmetry Operation'/
     &	       ' =============================='//
     &	       ' Axis in direct space      : ',3(2x,f9.4))
3010	format(' Axis in reciprocal space  : ',3(2x,f9.4))
3020	format(' Origin of symmetry element: ',3(2x,f9.4))
3030	format(' Rotation angle            : ',  2x,f9.4 )
3040	format(' Translation part          : ',3(2x,f9.4)/)
3039	format(' Real space matrix         : ',4(2x,f9.4)/
     &	     2('                           : ',4(2x,f9.4)/))
3044	format(' Reciprocal space matrix   : ',3(2x,f9.4)/
     &	     2('                           : ',3(2x,f9.4)/))
3041	format(' Power of symmetry element : ', (2x,i4  ))
3042	format(' Mode of power level       :   Multiple',
     &         ' copies of original')
3043	format(' Mode of power level       :   Single',
     &         ' copy of original')
3050	format(' Type of symmetry element  :   Proper Rotation')
3051	format(' Type of symmetry element  :   Improper Rotation')
3060	format(' Mode of symmetry operation:   Copy atom to new position')
3061	format(' Mode of symmetry operation:   Move atom to new position')
3070	format(/' select status           : ',a)
3075	format(22x,i4)
3080	format(' Range of atoms from to    : ',2(2x,i9))
3090	format(' selected atoms    :')
3091	format('                      type name')
3092	format(20x,2(4x,i2,1x,a4))
c
	end
c*****7*****************************************************************
	subroutine  symm_setup
c-
c	Performs the generalized symmetry operation
c	See Sands, D.E. Vectors and Tensors in Crystallography Chapt. 4.7
c+
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'microdis.inc'
	include      'microsta.inc'
	include      'symm.inc'
c
	integer      i,j,k,l
	real         length
c
	real         uij
	real         ctheta,stheta
	real         sym_d(3),sym_r(3)
	real         kron(3,3)
	real         a(3,3)
	real         b(3,3)
c
	real         cosd,sind
	real         skalpro
c
c
	data kron    /1.0,0.0,0.0,   0.0,1.0,0.0,   0.0,0.0,1.0/
c
c------	initialize matrix and angle
c
	do i=1,4
	  do j=1,4
	    sym_mat (i,j)= 0.0
	    sym_rmat(i,j)= 0.0
	  enddo
	enddo
	sym_mat (4,4)= 1.0
	sym_rmat(4,4)= 0.0
	if(sym_power_mult) then
	  ctheta = cosd(sym_angle)
	  stheta = sind(sym_angle)
	else
	  ctheta = cosd(sym_angle*sym_power)
	  stheta = sind(sym_angle*sym_power)
	endif
c
c------	Create vectors of unit length in direct and reciprocal space
c
	length = sqrt(skalpro(sym_uvw,sym_uvw,cr_gten))
	if(length.eq.0.0) then
	  ier_num = -32
	  ier_typ =ER_APPL
	  return
	endif
	do j=1,3
	  sym_d(j) = sym_uvw(j)/length
	enddo
	length = sqrt(skalpro(sym_hkl,sym_hkl,cr_rten))
	if(length.eq.0.0) then
	  ier_num = -32
	  ier_typ =ER_APPL
	  return
	endif
	do j=1,3
	  sym_r(j) = sym_hkl(j)/length
	enddo
c	write(*,2001) sym_d,sym_r
c2001	format('direct axis     :',3(2x,f10.6)/
c    &	       'reciprocal axis :',3(2x,f10.6))
c
c------	calculate symmetry operation
c
	do i=1,3
	  do j=1,3
	  sym_mat(i,j) = 0.0
	    do k=1,3
	      do l=1,3
	        sym_mat(i,j) = sym_mat(i,j) + 
     &	                       cr_rten(i,k)*cr_eps(k,l,j)*sym_d(l)
	      enddo
	    enddo
	    uij          = sym_d(i)*sym_r(j)
	    sym_mat(i,j) = sym_mat(i,j)*stheta +
     &	                   uij + (kron(i,j)-uij)*ctheta
	  enddo
	  if(sym_power_mult) then
	    sym_mat(i,4) = sym_trans(i)
	  else
	    sym_mat(i,4) = sym_trans(i)*sym_power
	  endif
	enddo
c
c------	In case of improper rotation, multiply by -1
c
	if(.not.sym_type .and.
     &	   (sym_power_mult .or.
     &	    .not.sym_power_mult .and.mod(sym_power,2).ne.0) ) then
	  do i=1,3
	    do j=1,3
	      sym_mat(i,j) = -sym_mat(i,j)
	    enddo
	  enddo
	endif
c	write(*,2000) ((sym_mat(i,j),j=1,3),i=1,3)
c2000	format(3(3(2x,f10.6)/))
c
c
c
c------	Transform symmetry operation into reciprocal space
c
	do i=1,3
	  do j=1,3
	    a(i,j) = sym_mat(i,j)
	  enddo
	enddo
c
c------	do transformation q = gSg*
c
	call matmul (b,a,cr_rten)
	call matmul (a,cr_gten,b)
	do i=1,3
	  do j=1,3
	    sym_rmat(i,j) = a(i,j)
	  enddo
	enddo
c	write(*,2000) ((sym_rmat(i,j),j=1,3),i=1,3)
c2000	format(3(3(2x,f10.6)/))
c
	end
c*****7*****************************************************************
	subroutine symm_op_mult
c-
c	Performs the actual symmetry operation, multiple copy version
c+
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'microdis.inc'
	include      'symm.inc'
	include      'microsta.inc'
c
	character*4  name
c
	integer      i,j,k
c
	real         usym(4),ures(4)
	real         werte(5)
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	Apply symmetry operation to all atoms within selected range
c
	do i=sym_start,sym_end
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(sym_latom(cr_iscat(i)) .and. 
     &	     ( sym_md_s.eq.MD_S_EVE                               .or.
     &	       sym_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0      .or.
     &	       sym_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                     mc_type(-cr_md_next(i)).eq.sym_md_nr   .or.
     &	       sym_md_s.eq.MD_S_NON .and. sym_md_nr.eq.0      .and.
     &	                            cr_md_next(i).ge.0      )  ) then
c
c------	----Subtract origin 
c
	    do j=1,3
	      usym(j) = cr_pos(j,i) - sym_orig(j)
	    enddo
c
c-----	----Apply symmetry operation
c
	    usym(4)=1.0
	    do k=1,sym_power
	    call trans(usym,sym_mat,ures,4)
c
c------	----Add origin 
c
	    do j=1,3
	      werte(j+1) = ures(j) + sym_orig(j)
	    enddo
c
c------	----Insert copy of atom or replace original atom by its image
c
	    if(sym_mode) then
	      name     = cr_at_lis(cr_iscat(i))
	      werte(5) = cr_dw(cr_iscat(i))
	      call do_ins_atom(name,werte,5)
	      if(ier_num.ne.0) then
	        return
	      endif
	    else
	      do j=1,3
	        cr_pos(j,i) = werte(j+1)
	      enddo
	    endif
	    do j=1,3
	      usym(j) = ures(j)
	    enddo
	    enddo
	  endif
	enddo
c
	end
c*****7*****************************************************************
	subroutine symm_op_single
c-
c	Performs the actual symmetry operation, single result version
c+
	implicit     none
c
	include      'config.inc'
	include      'crystal.inc'
	include      'crystal.cmm'
	include      'errlist.inc'
	include      'microdis.inc'
	include      'microsta.inc'
	include      'symm.inc'
c
	character*4  name
	integer      i,j
	real         usym(4),ures(4)
	real         werte(5)
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	Apply symmetry operation to all atoms within selected range
c
	do i=sym_start,sym_end
c
c------	--Select atom if:
c	  type has been selected and
c	       all atoms are selected                            or
c	       all microdomains have been selected               or
c	       a specific microdomain type has been selected     or
c	       microdomains are deselected and atom is outside
c
	  if(sym_latom(cr_iscat(i)) .and. 
     &	     ( sym_md_s.eq.MD_S_EVE                               .or.
     &	       sym_md_s.eq.MD_S_ALL .and. cr_md_next(i).lt.0      .or.
     &	       sym_md_s.eq.MD_S_IND .and. cr_md_next(i).lt.0 .and.
     &                     mc_type(-cr_md_next(i)).eq.sym_md_nr   .or.
     &	       sym_md_s.eq.MD_S_NON .and. sym_md_nr.eq.0      .and.
     &	                            cr_md_next(i).ge.0      )  ) then
c
c------	----Subtract origin 
c
	    do j=1,3
	      usym(j) = cr_pos(j,i) - sym_orig(j)
	    enddo
c
c-----	----Apply symmetry operation
c
	    usym(4)=1.0
	    call trans(usym,sym_mat,ures,4)
c
c------	----Add origin 
c
	    do j=1,3
	      werte(j+1) = ures(j) + sym_orig(j)
	    enddo
c
c------	----Insert copy of atom or replace original atom by its image
c
	    if(sym_mode) then
	      name     = cr_at_lis(cr_iscat(i))
	      werte(5) = cr_dw(cr_iscat(i))
	      call do_ins_atom(name,werte,5)
	      if(ier_num.ne.0) then
	        return
	      endif
	    else
	      do j=1,3
	        cr_pos(j,i) = werte(j+1)
	      enddo
	    endif
	  endif
	enddo
c
	end
c*****7*****************************************************************
	subroutine symm_ca_mult(uvw,lspace)
c-
c	Performs the actual symmetry operation, multiple copy version
c	Only the input vector uvw is used in direct or reciprocal space
c+
	implicit     none
c
	include      'config.inc'
	include      'errlist.inc'
	include      'param.inc'
	include      'symm.inc'
c
	integer      j,k
	logical      lspace
c
	real         uvw(3)
	real         usym(4),ures(4)
	real         werte(5)
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	real space part
c
	if(lspace) then
c
c------	----Subtract origin, if in real space 
c
	  do j=1,3
	    usym(j) = uvw(j) - sym_orig(j)
	  enddo
c
c-----	--Apply symmetry operation
c
	  usym(4)=1.0
	  do k=1,sym_power
	    call trans(usym,sym_mat,ures,4)
c
c------	----Add origin and store result
c
	    do j=1,3
	      res_para((k-1)*3+j) = ures(j) + sym_orig(j)
	    enddo
	    write(*,3000) (res_para((k-1)*3+j),j=1,3)
c
c------	----Replace current vector by its image
c
	    do j=1,3
	      usym(j) = ures(j)
	    enddo
	  enddo
	else
c
c------	----Reciprocal space part 
c
	  do j=1,3
	    usym(j) = uvw(j)
	  enddo
c
c-----	--Apply symmetry operation
c
	  usym(4)=0.0
	  do k=1,sym_power
	    call trans(usym,sym_rmat,ures,4)
c
c------	----Store result
c
	    do j=1,3
	      res_para((k-1)*3+j) = ures(j)
	    enddo
	    write(*,3000) (res_para((k-1)*3+j),j=1,3)
c
c------	----Replace current vector by its image
c
	    do j=1,3
	      usym(j) = ures(j)
	    enddo
	  enddo
	endif
c
	res_para(0) = sym_power*3
c
3000	format(' Result    : ',3(2x,f9.4))
	end
c*****7*****************************************************************
	subroutine symm_ca_single(uvw,lspace)
c-
c	Performs the actual symmetry operation, multiple copy version
c	Only the input vector uvw is used in direct or reciprocal space
c+
	implicit     none
c
	include      'config.inc'
	include      'errlist.inc'
	include      'param.inc'
	include      'symm.inc'
c
	integer      j
	logical      lspace
c
	real         uvw(3)
	real         usym(4),ures(4)
	real         werte(5)
c
	data usym    /0.0,0.0,0.0,1.0/
	data werte   /0.0,0.0,0.0,0.0,0.0/
c
c------	real space part
c
	if(lspace) then
c
c------	----Subtract origin, if in real space 
c
	  do j=1,3
	    usym(j) = uvw(j) - sym_orig(j)
	  enddo
c
c-----	--Apply symmetry operation
c
	  usym(4)=1.0
	    call trans(usym,sym_mat,ures,4)
c
c------	----Add origin and store result
c
	    do j=1,3
	      res_para(j) = ures(j) + sym_orig(j)
	    enddo
c
c------	----Replace current vector by its image
c
	    do j=1,3
	      usym(j) = ures(j)
	    enddo
	else
c
c------	----Subtract origin, if in real space 
c
	  do j=1,3
	    usym(j) = uvw(j)
	  enddo
c
c-----	--Apply symmetry operation
c
	  usym(4) = 0.0
	    call trans(usym,sym_rmat,ures,4)
c
c------	----Add origin and store result
c
	    do j=1,3
	      res_para(j) = ures(j)
	    enddo
c
c------	----Replace current vector by its image
c
	    do j=1,3
	      usym(j) = ures(j)
	    enddo
	endif
c
	res_para(0) = 3
	write(*,3000) (res_para(j),j=1,3)
c
3000	format(' Result    : ',3(2x,f9.4))
	end
