c*****7*****************************************************************
      	subroutine ther_displ (line,ll)
c-
c     	Displaces atoms in a completely random fashion. the mean square
c     	displacement is given by the temperature factor.
c+
	implicit      	none
c
	include 	'config.inc'
	include 	'crystal.inc'
	include 	'crystal.cmm'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=1)
c
	character*(*)	line
	character*200	cpara(maxw)
	integer		lpara(maxw)
	integer 	ll,i,j,is,ii,ianz
	integer		uc_n(0:maxscat)
      	real 		uc(3),up(3)
	real		uc_sum(3,0:maxscat)
	real		uc_max(3,0:maxscat)
	real            avc(0:maxscat)
	real		pi2,bfac,a
	real    	gasdev
	real            quad
	logical 	flag_all
c
c------ get parameters
c
	call get_params(line,ianz,cpara,lpara,maxw,ll)
	if (ier_num.ne.0) return
c
	if (ianz.eq.0) then
	  flag_all = .true.
	else
	  flag_all = (cpara(1)(1:1).ne.'2')
	endif
c
c------ reset counters
c
	do i=0,cr_nscat
	  uc_n(i)=0
	  do j=1,3
	    uc_sum(j,i)=0.0
	    uc_max(j,i)=0.0
	  enddo
	  avc(i) = 0.0
	enddo
c
      	pi2  = (4.0*atan(1.0))**2
      	bfac = 1.0/(8.0*pi2)
c
c------ displace atoms
c
      	do i=1,cr_natoms
	  is=cr_iscat(i)
          a=sqrt(bfac*cr_dw(is))
	  do ii=1,3
	    if (flag_all .or. cr_icc(ii).ne.1) then
	      up(ii)=gasdev(a)
	    else
	      up(ii)=0.0
	    endif
	  enddo
          call trans(up,cr_gmat,uc,3)
          do j=1,3
            cr_pos(j,i )=cr_pos(j,i)+uc(j)
	    uc_sum(j,is)=uc_sum(j,is)+abs(up(j))
	    uc_max(j,is)=max(uc_max(j,is),abs(up(j)))
	  enddo
	  uc_n(is)=uc_n(is)+1  
c
	  avc(is) = avc(is) + quad(uc,uc,cr_gten)
	enddo
c
c------	Update crystal dimensions
c
	call update_cr_dim
c
c------ print statistics of 'therm' command
c
	write (*,1000)
	do i=0,cr_nscat
	  if (uc_n(i).ne.0) then
	    write (*,1100) cr_at_lis(i),cr_dw(i),sqrt(bfac*cr_dw(i)),
     &	                   ((uc_sum(j,i)/uc_n(i)),j=1,3),
     &	                   (uc_max(j,i),j=1,3)
c
            write(*,1200) bfac*cr_dw(i),avc(i)/float(uc_n(is))
	  endif
	enddo
c
1000	format (' Thermal displacements summary :',//,
     &          3X,'Atom',3X,'B',5X,'<u>',9X,'achieved  <u>',9X,
     &	        'maximum displacement ',/,
     &          16X,             '<u**2>',6X,'achieved  <u**2>',/
     &	        3X,68('='))
1100	format (3X,A4,1X,F5.2,2X,F6.4,2X,3(F6.4,2X),2X,3(F6.4,2X))
1200	format (15x,f6.4,2x,f6.4)
      	end
c*****7*****************************************************************
      	real function gasdev(sig)
c-
c	calculates a random number for gaussian distribution of
c	sigma.
c+
	implicit      none
c
	include       'random.inc'
c
	real          sig,v1,v2,r,fac,gset
	real          ran1
c
	save          gset
c
      	if (iset.eq.0) then
1         v1=2.*ran1(idum)-1.
          v2=2.*ran1(idum)-1.
          r=v1**2+v2**2
          if(r.ge.1.)go to 1
          fac=sqrt(-2.0*log(r)/r)
          gset=v1*fac
          gasdev=v2*fac
          iset=1
        else
          gasdev=gset
          iset=0
        endif
  	  gasdev = gasdev*sig
        end
c*****7*****************************************************************
        real function ran1(idum)
c
	implicit      none
c
	integer      m1,m2,m3,ia1,ia2,ia3,ic1,ic2,ic3
	integer      iff,idum,ix1,ix2,ix3,j
	real         rm1,rm2,r(97)
c
c	save         m1,m2,m3,ia1,ia2,ia3,ic1,ic2,ic3,ix1,ix2,ix3,iff
	save         ix1,ix2,ix3,iff
	save         r
c
c       dimension r(97)
c
        parameter (m1=259200,ia1=7141,ic1=54773,rm1=3.8580247e-6)
        parameter (m2=134456,ia2=8121,ic2=28411,rm2=7.4373773e-6)
        parameter (m3=243000,ia3=4561,ic3=51349)
c
        data iff /0/
c
        if (idum.lt.0.or.iff.eq.0) then
          iff=1
          ix1=mod(ic1-idum,m1)
          ix1=mod(ia1*ix1+ic1,m1)
          ix2=mod(ix1,m2)
          ix1=mod(ia1*ix1+ic1,m1)
          ix3=mod(ix1,m3)
          do 11 j=1,97
            ix1=mod(ia1*ix1+ic1,m1)
            ix2=mod(ia2*ix2+ic2,m2)
            r(j)=(float(ix1)+float(ix2)*rm2)*rm1
11        continue
          idum=1
        endif
        ix1=mod(ia1*ix1+ic1,m1)
        ix2=mod(ia2*ix2+ic2,m2)
        ix3=mod(ia3*ix3+ic3,m3)
        j=1+(97*ix3)/m3
        if(j.gt.97.or.j.lt.1) then
  	  write(*,*) j,idum,iff
	  write(*,*) ix1,ix2,ix3
	  stop
	endif
        ran1=r(j)
        r(j)=(float(ix1)+float(ix2)*rm2)*rm1
        end
