 	subroutine do_calc (zeile,lp)
c*****7*****************************************************************
c
c	These routines perform data manipulation - which is much
c	faster than using the build in interpreter - but less
c	flexible ..
c
c	Version : 1.0
c	Date    : 23 Oct 96
c
c	Author  : Th. Proffen  (proffen@rsc.anu.edu.au)
c
c*****7*****************************************************************
c
	implicit	none
c
	integer		maxw
	parameter	(maxw=4)
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*3	oper
	character*2	unt
	real		werte(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ilen,ik
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.lt.3 .or. ianz.gt.4) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	oper = cpara(1)(1:3)
	unt  = cpara(2)(1:2)
	call do_cap(oper)
	call do_cap(unt)
c
	call del_params(2,ianz,cpara,lpara,maxw)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	ik=nint(werte(1))
	if (ik.gt.0 .and. ik.lt.iz) then
	  ilen=len(ik)
	  if     (unt.eq.'WX') then
     	    if (lni(ik)) ilen=nx(ik)
	    call calc_xy ( x,ilen,ik,oper,werte,maxw,ianz)
	    if (ier_num.ne.0) return
	    call get_extrema_xy (x,ik,ilen,xmin,xmax)
	    call show_data (ik)
	  elseif (unt.eq.'WY') then
     	    if (lni(ik)) ilen=ny(ik)
	    call calc_xy ( y,ilen,ik,oper,werte,maxw,ianz)
	    if (ier_num.ne.0) return
	    call get_extrema_xy (y,ik,ilen,ymin,ymax)
	    call show_data (ik)
	  elseif (unt.eq.'DX') then
	    call calc_xy (dx,len(ik),ik,oper,werte,maxw,ianz)
	  elseif (unt.eq.'DY') then
	    call calc_xy (dy,len(ik),ik,oper,werte,maxw,ianz)
	  elseif (unt.eq.'WZ') then
	    if (lni(ik)) then
	      call calc_z  (z,nx(ik),ny(ik),ik,oper,werte,maxw,ianz)
	      if (ier_num.ne.0) return
	      call get_extrema_z (z,ik,nx(ik),ny(ik),zmin,zmax)
	      call show_data (ik)
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	    endif
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -4
	  ier_typ = ER_APPL
	endif		  
c
	end
c*****7*****************************************************************
	subroutine calc_xy (a,ilen,ik,op,werte,maxw,ianz)
c+
c	berechnungen fuer x und y feld
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	op
	integer		ilen,ik,ianz,maxw,i
	real	   	werte(maxw),a(maxarray)
	real		summand,faktor
c
	if     (op.eq.'INV') then
	  do i=1,ilen
	    if (a((ik-1)*maxpkt+i).ne.0.0) then
	      a((ik-1)*maxpkt+i) = 1.0/a((ik-1)*maxpkt+i)
	    else
	      a((ik-1)*maxpkt+i) = 0.0
	    endif
	  enddo	
	elseif (op.eq.'LOG') then
	  do i=1,ilen
	    if (a((ik-1)*maxpkt+i).gt.0.0) then
	      a((ik-1)*maxpkt+i) = log(a((ik-1)*maxpkt+i))
	    else
	      a((ik-1)*maxpkt+i) = 0.0
	    endif
	  enddo	
	elseif (op.eq.'EXP') then
	  do i=1,ilen
	    a((ik-1)*maxpkt+i) = exp(a((ik-1)*maxpkt+i))
	  enddo	
	elseif (op.eq.'SQU') then
	  do i=1,ilen
	    a((ik-1)*maxpkt+i) = a((ik-1)*maxpkt+i)*a((ik-1)*maxpkt+i)
	  enddo	
	elseif (op.eq.'SQR') then
	  do i=1,ilen
	    if (a((ik-1)*maxpkt+i).ge.0.0) then
	      a((ik-1)*maxpkt+i) = sqrt (a((ik-1)*maxpkt+i))
	    else
	      a((ik-1)*maxpkt+i) = 0.0
	    endif
	  enddo	
	elseif (op.eq.'ADD') then
	  summand=0.0
	  if (ianz.eq.2) summand=werte(2)
	  do i=1,ilen
	    a((ik-1)*maxpkt+i) = a((ik-1)*maxpkt+i)+summand
	  enddo	
	elseif (op.eq.'MUL') then
	  faktor=1.0
	  if (ianz.eq.2) faktor=werte(2)
	  do i=1,ilen
	    a((ik-1)*maxpkt+i) = a((ik-1)*maxpkt+i)*faktor
	  enddo	
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*****************************************************************
	subroutine calc_z (a,nxx,nyy,ik,op,werte,maxw,ianz)
c+
c	berechnungen fuer z feld
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	op
	integer		nxx,nyy,ik,maxw,ianz,i,j,ikk
	real	   	werte(maxw),a(maxarray)
	real		faktor,summand
c
	if     (op.eq.'INV') then
	  do i=1,nxx
	  do j=1,nyy
	    ikk=(ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.0.0 .and. a(ikk).ne.-9999.0) then
	      a(ikk) = 1.0/a(ikk) 
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'LOG') then
	  do i=1,nxx
	  do j=1,nyy
	    ikk=(ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.0.0 .and. a(ikk).ne.-9999.0) then
	      a(ikk) = log(a(ikk) )
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'EXP') then
	  do i=1,nxx
	  do j=1,nyy
	    ikk=(ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.-9999.0) then
	      a(ikk) = exp(a(ikk))
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'SQU') then
	  do i=1,nxx
	  do j=1,nyy
	    ikk=(ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.-9999.0) then
	      a(ikk) = a(ikk)**2 
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'SQR') then
	  do i=1,nxx
	  do j=1,nyy
	    ikk=(ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+j
	    if (a(ikk).ge.0.0 .and. a(ikk).ne.-9999.0) then
	      a(ikk) = sqrt(a(ikk))
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'ADD') then
	  summand=0.0
	  if (ianz.eq.2) summand=werte(2)
	  do i=1,nxx
	  do j=1,nyy
	    ikk=(ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.-9999.0) then
	      a(ikk) = a(ikk)+summand 
	    endif
	  enddo	
	  enddo	
	elseif (op.eq.'MUL') then
	  faktor=1.0
	  if (ianz.eq.2) faktor=werte(2)
	  do i=1,nxx
	  do j=1,nyy
	    ikk=(ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+j
	    if (a(ikk).ne.-9999.0) then
	      a(ikk) = a(ikk)*faktor 
	    endif
	  enddo	
	  enddo	
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	end
c*****7*******************************************************************
	subroutine do_kmath (zeile,lp)
c+
c	Add or multiply complete data sets
c-
	implicit	none
c
	integer		maxw
	parameter	(maxw=3)
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*3	oper
	real		werte(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ik1,ik2,ikk1,ikk2,ikk3,ix,iy,i,ii
c
c------ space left for new data set ??
c
	if (iz.gt.maxkurv) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ check arguments
c
	if (ianz.ne.3) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	oper = cpara(1)(1:3)
	call do_cap(oper)
	if (oper.ne.'ADD' .and. oper.ne.'MUL') then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	call del_params(1,ianz,cpara,lpara,maxw)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
	ik1=nint(werte(1))
	ik2=nint(werte(2))
c
	if (ik1.lt.1 .or. ik1.gt.(iz-1) .or.
     &	    ik2.lt.1 .or. ik2.gt.(iz-1)    ) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
c------ if we have a 3d data set
c
	if    (lni(ik1)             .and. 
     &	       lni(ik2)             .and. 
     &	       (nx(ik1).eq.nx(ik2)) .and.
     &	       (ny(ik1).eq.ny(ik2)))     then
	  do ix=1,nx(ik1)
	    do iy=1,ny(ik1)
	      ikk1=(ik1-1)*nx(1)*ny(1)+(ix-1)*ny(ik1)+iy
	      ikk2=(ik2-1)*nx(1)*ny(1)+(ix-1)*ny(ik1)+iy
	      ikk3=(iz -1)*nx(1)*ny(1)+(ix-1)*ny(ik1)+iy
	      if (z(ikk1).eq.-9999. .or. z(ikk2).eq.-9999) then
	        z(ikk3)=-9999.0
	      else
	        if (oper.eq.'MUL') z(ikk3)=z(ikk1)*z(ikk2)
	        if (oper.eq.'ADD') z(ikk3)=z(ikk1)+z(ikk2)
	      endif
	    enddo
	  enddo
	  do i=1,nx(ik1)
	    x((iz-1)*maxpkt+i)=x((ik1-1)*maxpkt+i)
	  enddo
	  do i=1,ny(ik1)
	    y((iz-1)*maxpkt+i)=y((ik1-1)*maxpkt+i)
	  enddo
	  nx(iz)    = nx(ik1)
	  ny(iz)    = ny(ik1)
	  len(iz)   = len(ik1)
	  lni(iz)   = .true.
	  fname(iz) = 'result.dat'
	  fform(iz) = fform(ik1)
	  iz        = iz+1
	  call get_extrema_xy (x,iz-1,nx(iz),xmin,xmax)
	  call get_extrema_xy (y,iz-1,ny(iz),ymin,ymax)
	  call get_extrema_z  (z,iz-1,nx(iz),ny(iz),zmin,zmax)
	  call show_data (iz-1)
c
c------ here for a 2d data set
c
	elseif (.not.lni(ik1)        .and.
     &	        .not.lni(ik2)        .and.
     &	        (len(ik1).eq.len(ik2)))    then
	  do ii=1,len(ik1)
	    ikk1=(ik1-1)*maxpkt+ii
	    ikk2=(ik2-1)*maxpkt+ii
	    ikk3=(iz -1)*maxpkt+ii
	    x(ikk3)=x(ikk1)
	    if(oper.eq.'MUL') y(ikk3)=y(ikk1)*y(ikk2)
	    if(oper.eq.'ADD') y(ikk3)=y(ikk1)+y(ikk2)
	  enddo
	  len(iz)   = len(ik1)
	  fform(iz) = fform(ik1)
	  fname(iz) = 'result.dat'
	  iz        = iz+1
	  call get_extrema_xy (x,iz-1,len(iz),xmin,xmax)
	  call get_extrema_xy (y,iz-1,len(iz),ymin,ymax)
	  call show_data (iz-1)
c
c------ incompatible data sets
c
	else
	  ier_num = -23
	  ier_typ = ER_APPL
	endif
c
	end	  
