	subroutine clip_array (ex,ey,ax,ay,npkt)
c***********************************************************************
c
c	These routines perform the clipping of the view graph to
c	the current plotting window.
c
c	Version : 1.1
c	Date    : 23 Oct 96
c
c	Author  : Th. Proffen (proffen@rsc.anu.edu.au)
c
c***********************************************************************
c 
	implicit	none
c
	integer		i,j,npkt
	logical 	inrect,in1,in2,in3,sf
	real		ex(2),ey(2),ax(npkt),ay(npkt)
	real		xs,ys,axp,ayp
c
	if (npkt.lt.2) return
c
	j = 1
c
c------ First point
c
	in2 = inrect (ex,ey,ax(1),ay(1))
	in3 = inrect (ex,ey,ax(2),ay(2))
	if (in2) then
	  ax(j) = ax(1)
	  ay(j) = ay(1)
	  j = j+1
	elseif (.not.in2 .and. in3) then
	  call schnitt (ex,ey,ax(1),ay(1),ax(2),ay(2),xs,ys,sf)
	  ax(j) = xs
	  ay(j) = ys
	  j = j+1
	endif
c
	axp = ax(1)
	ayp = ay(1)
c
c------ Check supsequent points
c
	do i = 2,npkt-1
	  in1 = inrect (ex,ey,axp,ayp)
	  in2 = inrect (ex,ey,ax(i),ay(i))
	  in3 = inrect (ex,ey,ax(i+1),ay(i+1))
          if (in2) then
	    axp = ax(i)
	    ayp = ay(i)
	    ax(j) = ax(i)
	    ay(j) = ay(i)
	    j = j+1
	  elseif (.not.in2 .and. in1) then
	    call schnitt (ex,ey,axp,ayp,ax(i),ay(i),xs,ys,sf)
	    axp = ax(i)
	    ayp = ay(i)
	    ax(j) = xs
	    ay(j) = ys
	    j = j+1
	  elseif (.not.in2 .and. in3) then
	    call schnitt (ex,ey,ax(i),ay(i),ax(i+1),ay(i+1),xs,ys,sf)
	    axp = ax(i)
	    ayp = ay(i)
	    ax(j) = xs
	    ay(j) = ys
	    j = j+1
	  else
	    axp = ax(i)
	    ayp = ay(i)
	    continue
	  endif
	enddo
c
c------ Last point
c
	in1 = inrect (ex,ey,axp,ayp)
	in2 = inrect (ex,ey,ax(npkt),ay(npkt))
	if (in2) then
	  ax(j) = ax(npkt)
	  ay(j) = ay(npkt)
	  j = j+1
	elseif (.not.in2 .and. in1) then
	  call schnitt (ex,ey,axp,ayp,ax(npkt),ay(npkt),xs,ys,sf)
	  ax(j) = xs
	  ay(j) = ys
	  j = j+1
	endif
c
	npkt = j-1
c
	end
c***********************************************************************
      	subroutine schnitt(ex,ey,x1,y1,x2,y2,xs,ys,sflag)
c-
c     	Calculates the intersection of the line from x1,y1 to x2,y2
c     	with rectangle given by ex(2),ey(2)
c+              
	implicit	none
c
	real		ex(2),ey(2)
	real		xs,ys,x1,y1,x2,y2
	real		lam,mue                     
	logical 	sflag
c                    
	sflag = .false.
        call cross(lam,mue,ex(1),ex(2),x1,x2,ey(1),ey(1),y1,y2,xs,ys)
        if (0. .le. lam .and. lam .le. 1.  .and.
     &      0. .le. mue .and. mue .le. 1.       ) then
          sflag = .true.
	  return
	endif
        call cross(lam,mue,ex(2),ex(2),x1,x2,ey(1),ey(2),y1,y2,xs,ys)
        if (0. .le. lam .and. lam .le. 1.  .and.
     &      0. .le. mue .and. mue .le. 1.       ) then
          sflag = .true.
	  return
	endif
        call cross(lam,mue,ex(2),ex(1),x1,x2,ey(2),ey(2),y1,y2,xs,ys)
        if (0. .le. lam .and. lam .le. 1.  .and.
     &      0. .le. mue .and. mue .le. 1.       ) then
          sflag = .true.
	  return
	endif
        call cross(lam,mue,ex(1),ex(1),x1,x2,ey(2),ey(1),y1,y2,xs,ys)
        if (0. .le. lam .and. lam .le. 1.  .and.
     &      0. .le. mue .and. mue .le. 1.       ) then
          sflag = .true.
	  return
	endif
      	end
c*********************************************************************
      	subroutine cross(lam,mue,x1,x2,x3,x4,y1,y2,y3,y4,xs,ys)
c-
c     	Calculates intersection of two vectors : 12 and 34
c     	if singulaer lam and mue are set to  -20.
c+
	implicit	none
c
	real		x1,x2,x3,x4,x21,x43,x13
	real		y1,y2,y3,y4,y21,y43,y13
	real		xs,ys,det
      	real 		lam,mue 
c
      	x21=x2-x1
      	x43=x4-x3
      	x13=x1-x3
      	y21=y2-y1
      	y43=y4-y3
      	y13=y1-y3
      	det=y43*x21-x43*y21
      	if(abs(det) .eq. 0.0) then
          lam=-20.
          mue=-20.
      	else
          lam=(x21*y13-x13*y21)/det
          mue=(x43*y13-x13*y43)/det
          xs=x3+lam*x43
          ys=y3+lam*y43
      	endif
      	end
c*********************************************************************** 
      	logical function inrect (ex,ey,x,y) 
c-
c     	Checks if point x,y is within rectangle ex(2),ey(2).
c+
      	real 	x,y,ex(2),ey(2)
c       
	inrect = (x.ge.ex(1) .and. x.le.ex(2)) .and.
     & 	         (y.ge.ey(1) .and. y.le.ey(2))
      	end
c*****7*****************************************************************
