c*****7*****************************************************************
	subroutine initarrays
c+
c	This is the initialisation routine called at startup time
c	of KUPL. In the first section there are a few definitions
c	that might need adjustment.
c
c	Version : 1.0
c	Date    : 10 Oct 96
c
c	Author  : Th. Proffen (proffen@rsc.anu.edu.au)
c+
	implicit	none
c
	include		'kuplot.inc'
	include		'envir.inc'
	include		'errlist.inc'
	include		'learn.inc'
c
	integer		i,j
	integer		id_x11,id_tek
	integer		stift(0:4)
c
	data	stift	/5,3,1,2,4/
c
c------ Print command for PS files and HPGL files
c
	prnps   = ' '
	prnhpgl = ' '
c
c------ initial screen width in pixels for X11 terminals
c
	iscr_width = 640
c
c------ check if there is an X11 display ?
c
	id_x11=x11
	id_tek=tek
	call setdisplay (id_dev_screen,id_x11,id_tek)
	id_dev_hardcopy = ps
c
	itek_typ = 0
c
c------ common /errors/
c
	ier_num = 0
	ier_typ = ER_NONE
	ier_sta = ER_S_CONT
	do i=1,3
	  ier_msg(i) = ' '
	enddo
c
c------ setting default color map for bitmaps
c
	col_typ = 1
	do i=1,maxcol
	  col_map(i,1)=float(i)/float(maxcol)
	  col_map(i,2)=float(i)/float(maxcol)
	  col_map(i,3)=float(i)/float(maxcol)
	enddo
c
c------ here start all the defaults for the variables
c
	ftyp     = 'POLY'
	fstart   = .true.
	ikfirst  = .true.
	wtyp     = 'INV'
	urf      = 10.0
	ncycle   = 30
	npara    = 2
	np1      = 2
	np2      = 0
	np3      = 0
	maxkurv  = 10
	maxpkt   = 10000
	ipara    = 2
	fpara    = 'kupl.par'
	iframe   = 1
	ifen     = 10
	iz       = 1
	orient   = .true.
	tot_frame= .false.
	iaf      = 1  
c
	do i=1,maxpara
	  p(i)    = 0.0
	  pinc(i) = 1.0
	enddo
c
	linewid(0)  = 0.5
	ilinecol(0) = 6
	do i=1,maxkurvtot
	  lni(i)      = .false.
	  iho(i)      = 1
	  linewid(i)  = 0.5
	  ilegend(i)  = 0
	  ilinecol(i) = stift(mod(i,5))
	  imarkcol(i) = stift(mod(i,5))
	  ierr(i)     = 0
	  ilinetyp(i) = 1
	  imarktyp(i) = 0
	  imarkmax(i) = 0
	  ilineart(i) = 1
	  hlineart(i) = 1
	  sizemark(i)= 0.20
	  do j=1,maxhl
	    hlinecol(i,j) = stift(mod(j,5))
	    hlinetyp(i,j) = 1
	  enddo
	enddo
c
	do i=1,maxframe
	  do j=1,maxan
	    antext(i,j) = 'OFF'
	    anx(i,j)    = 0.0
	    any(i,j)    = 0.0
	    anjust(i,j) = if_left
	  enddo
c
	  do j=1,maxhl
	    z_min(i,j) = 50.0
	    z_inc(i,j) = 50.0
	    nz(i,j) = 10
	  enddo
c
	  frjust(i)     = if_left
	  frback(i,1)   = 1.0
	  frback(i,2)   = 1.0
	  frback(i,3)   = 1.0
	  fonsize(i,1)  = 180.0
	  fonsize(i,2)  = 160.0
	  fonsize(i,3)  = 120.0
	  fonsize(i,4)  = 120.0
	  fonsize(i,5)  = 120.0
	  fonsize(i,6)  = 120.0
	  fonsize(i,7)  = 120.0
	  fonsize(i,8)  = 120.0
	  fonsize(i,9)  = 120.0
	  fonsize(i,10) = 120.0
	  fon_id(i,1)   = 1
	  fon_id(i,2)   = 1
	  fon_id(i,3)   = 1
	  fon_id(i,4)   = 1
	  fon_id(i,5)   = 2
	  fon_id(i,6)   = 1
	  fon_id(i,7)   = 1
	  fon_id(i,8)   = 1
	  fon_id(i,9)   = 1
	  fon_id(i,10)  = 1
	  foncol(i,1)   = 6
	  foncol(i,2)   = 6
	  foncol(i,3)   = 6
	  foncol(i,4)   = 6
	  foncol(i,5)   = 6
	  foncol(i,6)   = 6
	  foncol(i,7)   = 6
	  foncol(i,8)   = 6
	  foncol(i,9)   = 6
	  foncol(i,10)  = 6
	  ifname(i)     = .true. 
	  igrid(i)      = .false.
	  ibox(i)       = 3
	  do j=1,maxkurvtot
	    infra(i,j) = j
	  enddo
	  ftext(i)   = 'kupl.par'
	  ex(i,1)    = -9999.
	  ex(i,2)    = -9999.
	  ey(i,1)    = -9999.
	  ey(i,2)    = -9999.
	  t(i,1)     = -9999.
	  t(i,2)     = -9999.
	  plmass(i)  = -9999.
	  yskal(i)   = -9999.
	  titel(i,1) = ' '
	  titel(i,2) = ' '
	  achse(i,1) = ' x '
	  achse(i,2) = ' y '
	  shear(i)   = 90.0
	  sfl(i)     = .true.
	  frame(i,1) = 0.0
	  frame(i,2) = 0.0
	  frame(i,3) = 1.0
	  frame(i,4) = 1.0
	enddo
c
	end
c*****7*****************************************************************
	subroutine do_read_def (zeile,lp)
c+
c	Reading defaults
c-
	implicit	none
c
	include		'errlist.inc'
c
	integer		maxw,idef
	parameter	(maxw=5)
	parameter	(idef=9)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*80	cdummy
	integer		lp,ianz
	integer		lpara(maxw)
	real		werte(maxw)
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
	if(ianz.eq.0) then
	  cdummy='kuplot.def'
	else
	  call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	  if (ier_num.ne.0) return
	  cdummy=cpara(1)
	endif
c
	call oeffne(idef,cdummy,'old',.false.)
	if (ier_num.eq.0) then
	  call read_def(idef)
	  write (*,1000) cdummy(1:len_str(cdummy))
	  close(idef)
	endif
c
1000	format (' ------ > Reading defaults from file ',a,' ..')
	end
c*****7*****************************************************************
	subroutine do_write_def (zeile,lp)
c+
c	Writing defaults
c-
	implicit	none
c
	include		'errlist.inc'
c
	integer		maxw,idef
	parameter	(maxw=5)
	parameter	(idef=9)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*80	cdummy
	integer		lpara(maxw)
	integer		lp,ianz
	real		werte(maxw)
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
	if(ianz.eq.0) then
	  cdummy='kuplot.def'
	else
	  call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	  if (ier_num.ne.0) return
	  cdummy=cpara(1)
	endif
c
	call oeffne(idef,cdummy,'unknown',.false.)
	if (ier_num.eq.0) then
	  call write_def(idef)
	  write (*,1000) cdummy(1:len_str(cdummy))
	  close(idef)
	endif
c
1000	format (' ------ > Writing defaults to file ',a,' ..')
	end
c*****7*****************************************************************
	subroutine write_def (idef)
c+
c 	This routine saves the current settings to a file
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		idef
c
	write (idef,1) prnps,prnhpgl
	write (idef,1) titel,clegend
	write (idef,1) fname,fpara
	write (idef,1) ftext,achse
	write (idef,1) ftyp,wtyp
	write (idef,1) fform,orient
	write (idef,*) maxkurv,frame,shear,linewid,fonsize,frjust,
     &	               fon_id,foncol,iho,igrid,ierr,ifname,ilinecol,
     &	               imarkcol,ilinetyp,imarktyp,ilineart,imarkmax,
     &	               ilegend,hlinecol,hlinetyp,hlineart,z_min,z_inc,
     &	               nz,infra,tot_frame,urf,ncycle,fstart,
     &	               frame,iaf,frback,sizemark,iscr_width,
     &	               col_typ,col_map,ibox
c
1	format(a)
	end
c*****7*****************************************************************
	subroutine read_def (idef)
c+
c 	This routine reads defaults from a file
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		idef
c
	read (idef,1,err=98,end=99) prnps,prnhpgl
	read (idef,1,err=98,end=99) titel,clegend
	read (idef,1,err=98,end=99) fname,fpara
	read (idef,1,err=98,end=99) ftext,achse
	read (idef,1,err=98,end=99) ftyp,wtyp
	read (idef,1,err=98,end=99) fform,orient
	read (idef,*,err=98,end=99) 
     &	             maxkurv,frame,shear,linewid,fonsize,frjust,
     &	             fon_id,foncol,iho,igrid,ierr,ifname,ilinecol,
     &	             imarkcol,ilinetyp,imarktyp,ilineart,imarkmax,
     &	             ilegend,hlinecol,hlinetyp,hlineart,z_min,z_inc,
     &	             nz,infra,tot_frame,urf,ncycle,fstart,
     &	             frame,iaf,frback,sizemark,iscr_width,
     &	             col_typ,col_map,ibox
c
	col_typ = abs(col_typ)
c
	return
c
98	continue
	ier_num = -3
	ier_typ = ER_IO
	return
c
99	continue
	ier_num = -6
	ier_typ = ER_IO
	return
c
1	format (a)
	end
c*****7*****************************************************************
	subroutine auto_def
c+
c	If the default setup file is there load it ..
c-
	implicit	none
c
	integer		idef
c
	include		'envir.inc'
	include		'errlist.inc'
c
	idef    = 33
	ier_num = 0
	ier_typ = ER_NONE
c
	call open_def(idef)
	if(ier_num.eq.0) then
	  write (*,1000) deffile
	  call read_def (idef)
	else
	  ier_num = 0
	  ier_typ = ER_NONE
	endif
	close (idef)
c
1000	format (10x,'Reading defaults from file : ',a40)
	end
