#ifdef VMS

char *vms_init();
void vms_reset();
void term_mode_tek();
void term_mode_native();
void term_pasthru();
void term_nopasthru();

#define tekinit_     TEKINIT
#define tekexit_     TEKEXIT
#define tekvector_   TEKVECTOR
#define tekgraph_    TEKGRAPH
#define tektext_     TEKTEXT
#define tekcolkerm_  TEKCOLKERM
#define tekcolxterm_ TEKCOLXTERM
#define tekltyp_     TEKLTYP
#define tekin_       TEKIN

#endif

#ifdef hpux

#define tekinit_     tekinit
#define tekexit_     tekexit
#define tekvector_   tekvector
#define tekgraph_    tekgraph
#define tektext_     tektext
#define tekcolkerm_  tekcolkerm
#define tekcolxterm_ tekcolxterm
#define tekltyp_     tekltyp
#define tekin_       tekin

#endif

#define HX 0x20
#define HY 0x20
#define LX 0x40
#define LY 0x60

#define LOWER5 31
#define UPPER5 (31<<5)

tekinit_()
{
	char *terminal;

#ifdef VMS
	terminal = vms_init();
	term_pasthru();
#endif
	printf("\033[?38h\033\014");
}

tekexit_()
{
#ifdef VMS
	term_nopasthru();
	vms_reset();
#endif
}


tekvector_ (x,y)
unsigned int *x,*y;
{
	(void) putchar((HY | (*y & UPPER5)>>5));
	(void) putchar((LY | (*y & LOWER5)));
	(void) putchar((HX | (*x & UPPER5)>>5));
	(void) putchar((LX | (*x & LOWER5)));
}

tekgraph_ ()
{
	(void) putchar('\035');
}

tektext_ (chfeld,ilen)
unsigned int *chfeld[132];
int *ilen;
{
	char  str[132];
	int   i;

   	for (i=0 ; i < *ilen ; i++)
	{
   		str[i] = (char) *(chfeld+i);
   	}
	str[i]='\0';

	printf("\037%s\n",str);
}

static char *kermit_color[8] = {
       "\033[1;31m","\033[1;32m","\033[1;34m","\033[1;35m",
       "\033[1;33m","\033[1;37m","\033[1;36m","\033[0;33m"};

tekcolkerm_ (col)
int *col;
{
	if (*col > 8)
		*col %= 8;
	printf("%s",kermit_color[*col-1]);
} 	

static char *xterm_color[8] = {
       "\033]15;1\007" ,"\033]15;5\007",
       "\033]15;2\007" ,"\033]15;6\007",
       "\033]15;3\007" ,"\033]15;RoyalBlue\007",
       "\033]15;4\007" ,"\033]15;8\007"};

tekcolxterm_ (col)
int *col;
{
        if (*col > 8)
                *col %= 8;
        printf("%s",xterm_color[*col-1]);
}

static char *kermit_linetyp = "`abcde`a";

tekltyp_ (typ)
int *typ;
{
	if (*typ > 8)
		*typ %= 8;
	printf("\033%c",kermit_linetyp[*typ-1]);
}

tekin_ (buf)
char *buf[6];
{
  
	printf("\033\032");
	scanf("%s",buf);
}  
/*
*  TERMINALCHARACTERISTIKEN BEI VMS SETZEN
*/
#ifdef vms
/* these are needed to modify terminal characteristics */
#include <descrip.h>
#include <iodef.h>
#include <ttdef.h>
#include <tt2def.h>
#include <dcdef.h>
#include <ssdef.h>
#include <stat.h>
#include <fab.h>
static unsigned short   chan;
static int  old_char_buf[3], cur_char_buf[3];
$DESCRIPTOR(sysoutput_desc,"SYS$OUTPUT");

char *vms_init()
/*
 * Determine if we have a regis terminal
 * and save terminal characteristics
*/
{
   /* Save terminal characteristics in old_char_buf and
   initialise cur_char_buf to current settings. */
   int i;
   sys$assign(&sysoutput_desc,&chan,0,0);
   sys$qiow(0,chan,IO$_SENSEMODE,0,0,0,old_char_buf,12,0,0,0,0);
   for (i = 0 ; i < 3 ; ++i) cur_char_buf[i] = old_char_buf[i];
   sys$dassgn(chan);

}

void
vms_reset()
/* set terminal to original state */
{
   int i;
   sys$assign(&sysoutput_desc,&chan,0,0);
   sys$qiow(0,chan,IO$_SETMODE,0,0,0,old_char_buf,12,0,0,0,0);
   for (i = 0 ; i < 3 ; ++i) cur_char_buf[i] = old_char_buf[i];
   sys$dassgn(chan);
}

void
term_mode_tek()
/* set terminal mode to tektronix */
{
   long status;
   sys$assign(&sysoutput_desc,&chan,0,0);
   cur_char_buf[0] = 0x004A0000 | DC$_TERM | (TT$_TEK401X<<8);
   cur_char_buf[1] = (cur_char_buf[1] & 0x00FFFFFF) | 0x18000000;

   cur_char_buf[1] &= ~TT$M_CRFILL;
   cur_char_buf[1] &= ~TT$M_ESCAPE;
   cur_char_buf[1] &= ~TT$M_HALFDUP;
   cur_char_buf[1] &= ~TT$M_LFFILL;
   cur_char_buf[1] &= ~TT$M_MECHFORM;
   cur_char_buf[1] &= ~TT$M_NOBRDCST;
   cur_char_buf[1] &= ~TT$M_NOECHO;
   cur_char_buf[1] &= ~TT$M_READSYNC;
   cur_char_buf[1] &= ~TT$M_REMOTE;
   cur_char_buf[1] |= TT$M_LOWER;
   cur_char_buf[1] |= TT$M_TTSYNC;
   cur_char_buf[1] |= TT$M_WRAP;
   cur_char_buf[1] &= ~TT$M_EIGHTBIT;
   cur_char_buf[1] &= ~TT$M_MECHTAB;
   cur_char_buf[1] &= ~TT$M_SCOPE;
   cur_char_buf[1] |= TT$M_HOSTSYNC;

   cur_char_buf[2] &= ~TT2$M_APP_KEYPAD;
   cur_char_buf[2] &= ~TT2$M_BLOCK;
   cur_char_buf[2] &= ~TT2$M_DECCRT3;
   cur_char_buf[2] &= ~TT2$M_LOCALECHO;
   cur_char_buf[2] &= ~TT2$M_PASTHRU;
   cur_char_buf[2] &= ~TT2$M_REGIS;
   cur_char_buf[2] &= ~TT2$M_SIXEL;
   cur_char_buf[2] |= TT2$M_BRDCSTMBX;
   cur_char_buf[2] |= TT2$M_EDITING;
   cur_char_buf[2] |= TT2$M_INSERT;
   cur_char_buf[2] |= TT2$M_PRINTER;
   cur_char_buf[2] &= ~TT2$M_ANSICRT;
   cur_char_buf[2] &= ~TT2$M_AVO;
   cur_char_buf[2] &= ~TT2$M_DECCRT;
   cur_char_buf[2] &= ~TT2$M_DECCRT2;
   cur_char_buf[2] &= ~TT2$M_DRCS;
   cur_char_buf[2] &= ~TT2$M_EDIT;
   cur_char_buf[2] |= TT2$M_FALLBACK;

   status = sys$qiow(0,chan,IO$_SETMODE,0,0,0,cur_char_buf,12,0,0,0,0);
   if (status == SS$_BADPARAM) {
      /* terminal fallback utility not installed on system */
      cur_char_buf[2] &= ~TT2$M_FALLBACK;
      sys$qiow(0,chan,IO$_SETMODE,0,0,0,cur_char_buf,12,0,0,0,0);
   }
   else {
      if (status != SS$_NORMAL)
         lib$signal(status,0,0);
   }
   sys$dassgn(chan);
}

void
term_mode_native()
/* set terminal mode back to native */
{
   int i;
   sys$assign(&sysoutput_desc,&chan,0,0);
   sys$qiow(0,chan,IO$_SETMODE,0,0,0,old_char_buf,12,0,0,0,0);
   for (i = 0 ; i < 3 ; ++i) cur_char_buf[i] = old_char_buf[i];
   sys$dassgn(chan);
}

void
term_pasthru()
/* set terminal mode pasthru */
{
   sys$assign(&sysoutput_desc,&chan,0,0);
   cur_char_buf[2] |= TT2$M_PASTHRU;
   sys$qiow(0,chan,IO$_SETMODE,0,0,0,cur_char_buf,12,0,0,0,0);
   sys$dassgn(chan);
}

void
term_nopasthru()
/* set terminal mode nopasthru */
{
   sys$assign(&sysoutput_desc,&chan,0,0);
   cur_char_buf[2] &= ~TT2$M_PASTHRU;
   sys$qiow(0,chan,IO$_SETMODE,0,0,0,cur_char_buf,12,0,0,0,0);
   sys$dassgn(chan);
}

#endif
