c******7******************************************************************
c
c	Here are the mouse input routines. 
c
c	Version : 1.0
c	Date    : 23 Oct. 96
c
c	Author  : Th. Proffen  (proffen@rsc.anu.edu.au)
c
c******7******************************************************************
	subroutine do_koor 
c
c	Show coordinates of mouse pointer position
c
	implicit 	none
c
	include 	'kuplot.inc'
	include 	'param.inc'
	include 	'errlist.inc'
c
	character*1  	key
	real		wxi,wyi,wx,wy,wz,dxx,dyy
	integer		nxx,nyy
c
	id_dev=id_dev_screen
c
	if (id_dev.eq.tek) then
	  write (*,2000)
	elseif (id_dev.eq.x11) then
	  write (*,2010)
	endif
c
	if (lni(1)) then
	  write (*,2100)
	else
	  write (*,2110)
	endif
c
	call do_plot ('plot',' ',4,1)
	res_para(0)=0
10	continue
	  call in_kupl (wxi,wyi,key)
	  if (key.eq.'A' .or. key.eq.'a') goto 20
	  if (.not.lni(1)) then
c
	    write(*,2200) wxi,wyi
c
	    if(res_para(0)-2.gt.maxpar_res) then
	      ier_num = -24
	      ier_typ = ER_APPL
	      return
	    endif
	    res_para(0)=res_para(0)+2
	    res_para(res_para(0)-1)=wxi
	    res_para(res_para(0)  )=wyi
	  else
            dxx = (xmax(1)-xmin(1))/float(nx(1)-1)
            dyy = (ymax(1)-ymin(1))/float(ny(1)-1)
	    nxx = nint (((wxi - xmin(1))/dxx))+1
	    nyy = nint (((wyi - ymin(1))/dyy))+1
	    wx  = xmin(1) + (nxx-1)*dxx
	    wy  = ymin(1) + (nyy-1)*dyy
	    wz  = z((nxx-1)*ny(1)+nyy)
c	    
	    write(*,2210) wxi,wyi,wx,wy,wz
c
	    if(res_para(0)-5.gt.maxpar_res) then
	      ier_num = -24
	      ier_typ = ER_APPL
	      return
	    endif
	    res_para(0)=res_para(0)+5
	    res_para(res_para(0)-4)=wxi
	    res_para(res_para(0)-3)=wyi
	    res_para(res_para(0)-2)=wx
	    res_para(res_para(0)-1)=wy
	    res_para(res_para(0)  )=wz
	  endif
	goto 10
c
20	continue
c
2000	format(' Press <K> to see coordinates, <A> to exit .. ',/)
2010	format(' LEFT mouse button to see coordinates,',
     &	       ' RIGHT to exit .. ',/)
2100	format(5x,'x-value',7x,'y-value',7x,'grid x',8x,'grid y',
     &	       8x,'grid z',/,3x,70('-'))
2110	format(5x,'x-value',7x,'y-value',/,3x,28('-'))
2200	format(3x,2(g12.6,2x))
2210	format(3x,5(g12.6,2x))
c
	end
c******7******************************************************************
	subroutine do_unter(zeile,lp)
c+
c	Define background with mouse and save coordinates to a file
c-
	implicit	none
c
	include 	'kuplot.inc'
	include 	'errlist.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*1  	key
	real		werte(maxw)
	real		xa(2),ya(2),wx,wy
	integer		lpara(maxw),lp
	integer		ianz
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.lt.2) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	call do_cap(cpara(1))
	call do_build_name(ianz,cpara,lpara,werte,maxw,2)
	if (ier_num.ne.0) return
c
	call oeffne(77,cpara(2),'unknown',.false.)
	if (ier_num.ne.0) return
c
	id_dev=id_dev_screen
	if (id_dev.eq.tek) then
	  write (*,2000) cpara(2)(1:len_str(cpara(2)))
	elseif (id_dev.eq.x11) then
	  write (*,2010) cpara(2)(1:len_str(cpara(2)))
	endif
c
	call do_plot ('plot',' ',4,1)
c
	call col_kupl (6)
	call in_kupl (wx,wy,key)
	if (key.eq.'A' .or. key.eq.'a') goto 20
	if (cpara(1)(1:1).eq.'B') then
 	  write (77,1000) nint(wx*100.0),nint(wy)
	else
 	  write (77,1500) wx,wy
	endif
	xa(1)=wx
	ya(1)=wy
10	continue
	  call in_kupl (wx,wy,key)
	  if (key.eq.'A' .or. key.eq.'a') goto 20
	  if (cpara(1)(1:1).eq.'B') then
 	    write (77,1000) nint(wx*100.0),nint(wy)
	  else
 	    write (77,1500) wx,wy
	  endif
	  xa(2)=wx
	  ya(2)=wy
	  call pline_kupl (2,xa,ya)
	  xa(1)=wx
	  ya(1)=wy
	  call flush_kupl
	goto 10
20	continue
c
	if (cpara(1)(1:1).eq.'B') write (77,1010) 
	close (77)
c
1000	format (1x,i5,1x,i10)
1010	format (1x,'-100')
1500	format (1x,2(g12.6,2x))
2000	format (' ------ > Save coordinates to file ',a,' ..',/
     &	        ' ------ > Press <K> to select point and <A> to exit ..')
2010	format (' ------ > Save coordinates to file ',a,' ..',/
     &	        ' ------ > Left mouse button to select point,'
     &	                 ' right button to exit ..')
	end
c******7******************************************************************
	subroutine do_wg(zeile,lp)
c+
c	Defines excluded regions and saves them to file
c-
	implicit	none
c
	include 	'kuplot.inc'
	include 	'errlist.inc'
c
	integer		mrect
	parameter	(mrect=500)
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*1  	key
	real		werte(maxw)
	real		rect (mrect,4),xm,ym,xd,yd
	real		wx1,wx2,wy1,wy2
	integer		lpara(maxw),lp
	integer		ianz,irect,i,j
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.lt.1) then
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	if (ier_num.ne.0) return
c
	call oeffne(77,cpara(1),'unknown',.false.)
	if (ier_num.ne.0) return
c
	id_dev=id_dev_screen
	if (id_dev.eq.tek) then
	  write (*,2000) cpara(1)(1:len_str(cpara(1)))
	elseif (id_dev.eq.x11) then
	  write (*,2010) cpara(1)(1:len_str(cpara(1)))
	endif
c
	call do_plot ('plot',' ',4,1)
c
	irect = 0
10	continue
	  call in_kupl (wx1,wy1,key)
	  if (key.eq.'A' .or. key.eq.'a') goto 20
	  call in_kupl (wx2,wy2,key)
	  if (key.eq.'A' .or. key.eq.'a') goto 20
	  irect = irect+1
	  rect (irect,1) = wx1
	  rect (irect,2) = wx2
	  rect (irect,3) = wy1
	  rect (irect,4) = wy2
	  xd=0.5*(wx2-wx1)
	  yd=0.5*(wy2-wy1)
	  xm=wx1+xd
	  ym=wy1+yd
	  call colrgb_kupl (0.8,0.8,0.8)
	  call rect_kupl (xm,ym,xd,yd,.true.)
	  call col_kupl (6)
	  call rect_kupl (xm,ym,xd,yd,.false.)
	  call flush_kupl
	goto 10
20	continue
c
	write (77,1000) irect
	do i=1,irect
	  write (77,1010) (rect(i,j),j=1,4)
	enddo
	close (77)
c
1000	format(1x,i4)
1010	format(4(1x,g12.6))
2000	format (' ------ > Save excluded regions to file ',a,' ..',/
     &	        ' ------ > Press <K> to select lower left and upper ',/
     &	        ' ------ > corner, press <A> to exit ..')
2010	format (' ------ > Save excluded regions to file ',a,' ..',/
     &	        ' ------ > Left mouse button to select lower left and',/
     &	        ' ------ > upper right corner, right button to exit ..')
5000	format(a)
c
	end
c*****7*******************************************************************
