c*****7****************************************************************
c
c	Routines to allocate memory for data sets and load data sets
c	using different file formats.
c
c	Version : 2.0
c	Date    : 17 Oct 96
c
c	Author  : Th. proffen (proffen@rsc.anu.edu.au)
c
c*****7****************************************************************
	subroutine do_allocate (zeile,lp)
c
c	Allocate space for new data set
c
	implicit	none
c
	include		'errlist.inc'
	include		'kuplot.inc'
c
	integer		maxw
	parameter	(maxw=3)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*40	cdummy
	integer		lp,lpara(maxw)
	integer		ianz,i,ii,jj
	real		werte(maxw)
c
	call no_error
c
c------ space left for additional data set ?
c
	if (iz.gt.maxkurv) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	cdummy=cpara(1)
	call del_params(1,ianz,cpara,lpara,maxw)
c
c------ 1D data set
c
	if (ianz.eq.1) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  ii=nint(werte(1))
	  if(ii.gt.0 .and. ii.le.maxpkt) then
	    do i=1,ii
	       x((iz-1)*maxpkt+i) = 0.0
	       y((iz-1)*maxpkt+i) = 0.0
	      dx((iz-1)*maxpkt+i) = 0.0
	      dy((iz-1)*maxpkt+i) = 0.0
	    enddo
	    fname(iz) = cdummy
	    fform(iz) = 'XY'
	    lni(iz)   = .false.
	    len(iz)   = ii
	    iz = iz+1
	    call show_data(iz-1)
	  else
	    ier_num = -6
	    ier_typ = ER_APPL
	  endif
c
c------ 2D data set
c
	elseif (ianz.eq.2) then
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  nx(iz)=nint(werte(1))
	  ny(iz)=nint(werte(2))
	  if(nx(iz).gt.0 .and. ny(iz).gt.0        .and. 
     &	     nx(iz)*ny(iz).le.maxpkt              .and.
     &	     nx(iz).le.nx(1) .and. ny(iz).le.ny(1)     ) then
	    do ii=1,nx(iz)
	      do jj=1,ny(iz)
	         z((iz-1)*nx(1)*ny(1)+(ii-1)*ny(iz)+jj)=0.0
	         x((iz-1)*maxpkt+ii) = 0.0
	         y((iz-1)*maxpkt+jj) = 0.0
	        dx((iz-1)*maxpkt+ii) = 0.0
	        dy((iz-1)*maxpkt+jj) = 0.0
	      enddo
	    enddo
	    fname(iz) = cdummy
	    fform(iz) = 'NI'
	    lni(iz)   = .true.
	    len(iz)   = nx(iz)*ny(iz)
	    iz = iz+1
	    call show_data(iz-1)
	  else
	    ier_num = -6
	    ier_typ = ER_APPL
	  endif
c
	else
	  ier_num = -6
	  ier_typ = ER_COMM  
	endif
c
	end
c*****7****************************************************************
	subroutine do_load (string,laenge)
c
c	Load various file formats
c
	implicit	none
c
	include		'errlist.inc'
	include		'kuplot.inc'
c
	integer		maxw,ifil,iwgb
	parameter	(maxw=10)
	parameter	(ifil=44)
	parameter	(iwgb=45)
c
	character*(*)	string
	character*200	cpara(maxw)
	character*80	wname
	character*2	unter
	real		werte(maxw)
	integer		laenge,lpara(maxw)
	integer		ianz,istr
c
	istr = 1
	call no_error
c
c------ space left for additional data set ?
c
	if (iz.gt.maxkurv) then
	  ier_num = -1
	  ier_typ = ER_APPL
	  return
	endif
c
	call get_params(string,ianz,cpara,lpara,maxw,laenge)
	if (ier_num.ne.0) return
	if (ianz.ge.2) then
c
c------- -get file typ
c
	  unter = cpara(1)(1:2)
	  call do_cap(unter)
c
c------- -build first filename
c
	  call do_build_name(ianz,cpara,lpara,werte,maxw,2)
	  if (ier_num.ne.0) return
	  fname(iz) = cpara(2)
c
c------- -get second filename if present
c
	  if (ianz.eq.3) then
	    call do_build_name(ianz,cpara,lpara,werte,maxw,3)
	    if (ier_num.ne.0) return
	    istr = 2
	    wname = cpara(3)
	  else
	    istr = 1
	    wname = ' '
	  endif
c
c------- -for format 'ZZ' or 'DE' get grid size 
c
	  if ((unter.eq.'ZZ' .or. unter.eq.'DE')) then
	    if (ianz.eq.4) then
	      call del_params (2,ianz,cpara,lpara,maxw)
	      call ber_params (ianz,cpara,lpara,werte,maxw)
	      if (ier_num.ne.0) return
	    else
	      ier_num = -6
	      ier_typ = ER_COMM
	      return
	    endif  
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
c------ open the datafile(s)
c
	call oeffne(ifil,fname(iz),'old',.true.)
	if (ier_num.ne.0) return
	if (istr.eq.2 .and. unter.ne.'ZZ' .and. unter.ne.'DE') then
	  call oeffne(iwgb,wname,'old',.true.)
	  if (ier_num.ne.0) then
	    istr=1
	    ier_num = 0
	    ier_typ = ER_NONE
	  endif
	endif
c
c-------unterkommando pruefen
c	
	fform(iz)=unter
	if    (unter.eq.'XY' .or. unter.eq.'XY') then
	  call read_xy (ifil,unter.eq.'XY')
	elseif(unter.eq.'CR') then
	  call read_crystal (ifil)
	elseif(unter.eq.'DE') then
	  call read_xyz(ifil,werte(1),werte(2),.true.)
	elseif(unter.eq.'ZZ') then
	  call read_xyz(ifil,werte(1),werte(2),.false.)
	elseif(unter.eq.'Z1') then	
	  call read_z(ifil,1)
	elseif(unter.eq.'Z2') then	
	  call read_z(ifil,2)
	elseif(unter.eq.'MA') then	
	  call read_marker (ifil)
	elseif(unter.eq.'NI') then
	  call read_nipl (ifil,iwgb,istr,.false.)
	elseif(unter.eq.'PG') then
	  call read_nipl (ifil,iwgb,istr,.true.)
	elseif(unter.eq.'T1') then
	  call read_mess (ifil,4,8, '2-theta [deg.]','counts z1')
	elseif(unter.eq.'T2') then
	  call read_mess (ifil,4,9, '2-theta [deg.]','counts z2')
	elseif(unter.eq.'C1') then
	  call read_mess (ifil,5,8, 'chi [deg.]'    ,'counts z1')
	elseif(unter.eq.'C2') then
	  call read_mess (ifil,5,9, 'chi [deg.]'    ,'counts z2')
	elseif(unter.eq.'P1') then
	  call read_mess (ifil,6,8, 'phi [deg.]'    ,'counts z1')
	elseif(unter.eq.'P2') then
	  call read_mess (ifil,6,9, 'phi [deg.]'    ,'counts z2')
	elseif(unter.eq.'O1') then
	  call read_mess (ifil,7,8, 'omega [deg.]'  ,'counts z1')
	elseif(unter.eq.'O2') then
	  call read_mess (ifil,7,9, 'omega [deg.]'  ,'counts z2')
	elseif(unter.eq.'H1') then
	  call read_mess (ifil,1,8, 'h [r.l.u.]'    ,'counts z1')
	elseif(unter.eq.'H2') then
	  call read_mess (ifil,1,9, 'h [r.l.u.]'    ,'counts z2')
	elseif(unter.eq.'K1') then
	  call read_mess (ifil,2,8, 'k [r.l.u.]'    ,'counts z1')
	elseif(unter.eq.'K2') then
	  call read_mess (ifil,2,9, 'k [r.l.u.]'    ,'counts z2')
	elseif(unter.eq.'L1') then
	  call read_mess (ifil,3,8, 'l [r.l.u.]'    ,'counts z1')
	elseif(unter.eq.'L2') then
	  call read_mess (ifil,3,9, 'l [r.l.u.]'    ,'counts z2')
	elseif(unter.eq.'TE') then
	  call read_mess (ifil,0,11,'data point'    ,'temperature [k]')
	elseif(unter.eq.'DM') then
	  call read_mess (ifil,0,12,'data point'    ,'value DMM')
	elseif(unter.eq.'ZE') then
	  call read_mess (ifil,0,10,'data point'    ,'time [sec]')
	else
	  ier_num = -2
	  ier_typ = ER_APPL
	endif
c
	close (ifil)
	if (istr.eq.2) close(iwgb)
c
	end  
c*****7****************************************************************
	subroutine read_xyz(ifil,deltax,deltay,dens)
c+
c	Load xyz files ..
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	real		xw,yw,zw
	real		deltax,deltay,dxx,dyy
	integer		np(maxarray)
	integer		ifil,ixx,iyy,izeig,i
	logical		dens
c
c------ get parameters
c            
	fform(iz)='NI'
c
c------ get dimensions of file
c
	read (ifil,*,end=20) xw,yw,zw
	xmin(iz)=xw
	xmax(iz)=xw
	ymin(iz)=yw
	ymax(iz)=yw
10	continue
	  read (ifil,*,end=20) xw,yw,zw
	  xmin(iz)=min(xmin(iz),xw)
	  xmax(iz)=max(xmax(iz),xw)
	  ymin(iz)=min(ymin(iz),yw)
	  ymax(iz)=max(ymax(iz),yw)
	goto 10
20	continue
	rewind (ifil)
c
c------ check dimensions
c
	if (xmin(iz).eq.xmax(iz) .or. ymin(iz).eq.ymax(iz)) then
	  ier_num = -29
	  ier_typ = ER_APPL
	  return
	endif
c
c------ get grid size 
c
	nx(iz)=nint((xmax(iz)-xmin(iz))/deltax)+1
	ny(iz)=nint((ymax(iz)-ymin(iz))/deltay)+1
c
c-------check array size
c
	if ((nx(iz)*ny(iz).gt.maxpkt) .or.
     &      nx(iz).gt.nx(1) .or. ny(iz).gt.ny(1)) then
	  ier_num = -6
	  ier_typ = ER_APPL
	  return
	endif
c
c------ zero some arrays
c
	do ixx=1,nx(iz)
	  do iyy=1,ny(iz)
	    izeig=(iz-1)*nx(1)*ny(1)+(ixx-1)*ny(iz)+iyy
	    z (izeig)=0.0
	    np(izeig)=0.0
	  enddo
	enddo
c
c------ read file and bin on specified grid
c
	dxx=deltax
	dyy=deltay
30	continue
	  if (dens) then 
	    read (ifil,*,end=40) xw,yw
	    zw=1.0
	  else
	    read (ifil,*,end=40) xw,yw,zw
	  endif
	  if (zw.ne.-9999.0) then
	    ixx=nint((xw-xmin(iz))/dxx) + 1
	    iyy=nint((yw-ymin(iz))/dyy) + 1
	    if (ixx.gt.0 .and. ixx.le.nx(iz) .and.
     &	        iyy.gt.0 .and. iyy.le.ny(iz)      ) then
	      izeig=(iz-1)*nx(1)*ny(1)+(ixx-1)*ny(iz)+iyy
	      z (izeig)=z (izeig)+zw
	      np(izeig)=np(izeig)+1
	    endif
	  endif
	goto 30
40	continue
c
c------ normalise Z
c
	do ixx=1,nx(iz)
	  do iyy=1,ny(iz)
	    izeig=(iz-1)*nx(1)*ny(1)+(ixx-1)*ny(iz)+iyy
	    if (.not. dens) then
	      if (np(izeig).eq.0) then
	        z(izeig)=-9999.0
	      else
	        z(izeig)=z(izeig)/float(np(izeig))
	      endif
	    endif
	    zmax(iz)=max(z(izeig),zmax(iz))
	    zmin(iz)=min(z(izeig),zmin(iz))
	  enddo
	enddo
c
c------ fill X,Y arrays
c
	do i=1,nx(iz)
	  x((iz-1)*maxpkt+i)=xmin(iz)+(i-1)*dxx
	enddo
	do i=1,ny(iz)
	  y((iz-1)*maxpkt+i)=ymin(iz)+(i-1)*dyy
	enddo
c
c------ set other parameters
c
	lni(iz)=.true.
	len(iz)=nx(iz)*ny(iz)
	iz=iz+1
	call show_data (iz-1)
c
	end
c*****7****************************************************************
	subroutine read_mess(ifil,ix,iy,str1,str2)
c+
c	Load MAN2 data files (MAN2 is a control program for the
c	neutron diffractometers at FRM II. For more information
c	contact the authors of KUPLOT.
c-                                
	implicit	none
c
	integer		maxw
	parameter	(maxw=20)
c
	character*(*)	str1,str2
	character*132	line
	real		werte(maxw)
	integer		ix,iy,ifil,nr,ianz,i
c
	include		'errlist.inc'
	include		'kuplot.inc'
c
c------ initial setup
c
	achse(iframe,1)=str1
	achse(iframe,2)=str2
c
c------ read data
c          
	nr=1
	read(ifil,9999,end=20) line
	read(ifil,9999,end=20) line
10	continue
	  read(ifil,9999,end=20) line
	  call count_col (line,ianz)
	  backspace(ifil)
15 	  continue
	  read (ifil,*,end=20) (werte(i),i=1,ianz)
	  if (ix.gt.0) then
	    x((iz-1)*maxpkt+nr)=werte(ix)
	  else
	    x((iz-1)*maxpkt+nr)=float(nr)
	  endif
	  y ((iz-1)*maxpkt+nr)=werte(iy)
	  dx((iz-1)*maxpkt+nr)=0.0
	  dy((iz-1)*maxpkt+nr)=0.0
	  xmax(iz)=max(xmax(iz),x((iz-1)*maxpkt+nr))
	  ymax(iz)=max(ymax(iz),y((iz-1)*maxpkt+nr))
	  xmin(iz)=min(xmin(iz),x((iz-1)*maxpkt+nr))
	  ymin(iz)=min(ymin(iz),y((iz-1)*maxpkt+nr))
	  nr=nr+1
	  if (nr.gt.maxpkt) then
	    ier_num = -6
	    ier_typ = ER_APPL
	    return
	  endif
	goto 15
20	continue
	len(iz)=nr-1
	iz=iz+1
c
	call show_data(iz-1)
c                       
9999	format (a)
c
	end	
c*****7****************************************************************
	subroutine read_nipl (ifil,iwgb,istr,pgm)
c+
c	Read NIPL (KUPLOT own 2D format) and PGM (ASCII) files
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		mrect,maxw
	parameter	(maxw =20)
	parameter	(mrect=50)
c
	character*80	line
	character*5	cmagic,kom
	real		rect(mrect,4)
	real		dxx,dyy,zdummy
	integer		ifil,iwgb,istr,ir,i,j
	integer		nrect
	logical		pgm,inwg
c
c------ if there is a second file containing excluded regions, 
c------ read its contents
c
	if (istr.eq.2 .and. .not.pgm) then
	  read (iwgb,*,end=50,err=55) nrect
	  if (nrect.gt.mrect) then
	    ier_num = -9
	    ier_typ = ER_APPL
	    goto 999
	  endif
	  do i=1,nrect
	    read (iwgb,*,end=50,err=55) (rect(i,j),j=1,4)
	  enddo 
	endif
c
c------ read main data
c------ NIPL file format
c
	if (.not.pgm) then
	  read (ifil,*,end=50,err=55) nx(iz),ny(iz)
c
c------ - check array size
c
	  if ((nx(iz)*ny(iz).gt.maxpkt) .or.
     &        nx(iz).gt.nx(1) .or. ny(iz).gt.ny(1)) then
	    ier_num = -6
	    ier_typ = ER_APPL
	    goto 999
	  endif
	  read (ifil,*,end=50,err=55) xmin(iz),xmax(iz),ymin(iz),ymax(iz) 
c
c------ - check dimensions
c
	  if (xmin(iz).eq.xmax(iz) .or. ymin(iz).eq.ymax(iz)) then
	    ier_num = -29
	    ier_typ = ER_APPL
	    return
	  endif
c
	  do j=1,ny(iz)
	    read (ifil,*,end=50,err=55) 
     &	         (z((iz-1)*nx(1)*ny(1)+(i-1)*ny(iz)+j),i=1,nx(iz))
	  enddo
c
c------ PGM file format
c
	else
	  read (ifil,1000,end=50,err=55) cmagic
	  if (cmagic(1:2).ne.'P2') then
	    ier_num = -5
	    ier_typ = ER_APPL
	    goto 999
	  endif
c
5	  read (ifil,1000,end=50,err=55) kom
	  if (kom(1:1).eq.'#') then
	    backspace (ifil)
	    read (ifil,1000,end=50,err=55) line
	    goto 5
	  else
	    backspace (ifil)
	  endif 
	  read (ifil,*,end=50,err=55) nx(iz),ny(iz),zdummy
c
c------ - check array size
c
	  if ((nx(iz)*ny(iz).gt.maxpkt) .or.
     &        nx(iz).gt.nx(1) .or. ny(iz).gt.ny(1)) then
	    ier_num = -6
	    ier_typ = ER_APPL
	    goto 999
	  endif
	  read (ifil,*,end=50,err=55) 
     &	       ((z((iz-1)*nx(1)*ny(1)+(i-1)*ny(iz)+j),
     &	                   i=1,nx(iz)),j=ny(iz),1,-1)
	  xmin(iz)=0.0
	  xmax(iz)=float(nx(iz)-1)
	  ymin(iz)=0.0
	  ymax(iz)=float(ny(iz)-1)
	endif
c
c------ set values for X and Y
c
	dxx = (xmax(iz)-xmin(iz))/float(nx(iz)-1)
	dyy = (ymax(iz)-ymin(iz))/float(ny(iz)-1)
	do i=1,nx(iz)
	  x((iz-1)*maxpkt+i)=xmin(iz)+(i-1)*dxx
	enddo
	do i=1,ny(iz)
	  y((iz-1)*maxpkt+i)=ymin(iz)+(i-1)*dyy
	enddo
c
c------ check with excluded regions
c
	do i=1,nx(iz)
	  do j=1,ny(iz)
	    if (istr.eq.2 .and. .not.pgm) then
	      inwg = .false.
	      do ir=1,nrect
	        inwg = inwg .or. 
     &                 (x((iz-1)*maxpkt+i).ge.rect(ir,1) .and.
     &	                x((iz-1)*maxpkt+i).le.rect(ir,2) .and.
     &	                y((iz-1)*maxpkt+j).ge.rect(ir,3) .and.
     &                  y((iz-1)*maxpkt+j).le.rect(ir,4))
	      enddo
	      if (inwg) z((iz-1)*nx(1)*ny(1)+(i-1)*ny(iz)+j) = -9999.0
	    endif
	  enddo
	enddo
c
c------ set remaining parameters
c
	lni(iz)=.true.
	len(iz)=nx(iz)*ny(iz)
	iz=iz+1
c
	call show_data (iz-1)
	goto 999
c
50	continue
	ier_num = -6
	ier_typ = ER_IO
	goto 999
c
55	continue
	ier_num = -3
	ier_typ = ER_IO
	goto 999
c
999	continue
1000	format (a)
	end
c*****7****************************************************************
	subroutine read_xy (ifil,noswap)
c+
c	Load x,y or x,y,dx,dy files
c-                                
	implicit	none
c
	include		'errlist.inc'
	include		'kuplot.inc'
c
	integer		maxw
	parameter	(maxw = 4)
c
	character*132	line
	real		werte(maxw)
	integer		ifil,nr,iwex,iwey,iwdx,iwdy
	integer		ianz,i
	logical		noswap
c
c------ xy or yx
c
	if (noswap) then
	  iwex=1
	  iwey=2
	  iwdx=3
	  iwdy=4
	else
	  iwex=2
          iwey=1
          iwdx=4
          iwdy=3
	endif
c
c------ read data
c      
	nr=1
10	continue
	  read(ifil,9999,end=20) line
	  call count_col (line,ianz)
	  if(ianz.eq.0) goto 10
	  backspace (ifil)
15	  continue
	  read(ifil,*,end=20) (werte(i),i=1,ianz)
	  x((iz-1)*maxpkt+nr)=werte(iwex)
	  y((iz-1)*maxpkt+nr)=werte(iwey)
	  if(ianz.ge.3) dx((iz-1)*maxpkt+nr)=werte(iwdx)
	  if(ianz.ge.4) dy((iz-1)*maxpkt+nr)=werte(iwdy)
	  nr=nr+1
	  if (nr.gt.maxpkt) then
	    ier_num = -6
	    ier_typ = ER_APPL
	    return
	  endif
	goto 15
20	continue
	len(iz)=nr-1
	iz=iz+1
c
	call show_data(iz-1)
c                       
9999	format (a)
c
	end	
c*****7****************************************************************
	subroutine read_crystal (ifil)
c+
c	Reads special crystal file format exported from DISCUS. 
c
c	First line    : title
c	Second line   : h,k,l (x-axis), h,k,l (y-axis), angle x&y
c	Per atom      : x,y,z, mtyp,mcol,msiz
c-                                
	implicit	none
c
	include		'errlist.inc'
	include		'kuplot.inc'
c
	real		rmsiz
	integer		ifil,imcol,imtyp,nr,iii
c      
	nr=1
10	continue
	  iii=(iz-1)*maxpkt+nr
	  read(ifil,*,end=20) x(iii),y(iii),z(iii),
     &	                      imtyp,imcol,rmsiz
c
c-------  Put color / marker and size information in DX, DY
c
	  dx(iii)=float(imcol*100+imtyp)
	  dy(iii)=rmsiz
c
	  xmax(iz)=max(xmax(iz),x(iii))
	  ymax(iz)=max(ymax(iz),y(iii))
	  xmin(iz)=min(xmin(iz),x(iii))
	  ymin(iz)=min(ymin(iz),y(iii))
	  nr=nr+1
	  if (nr.gt.maxpkt) then
	    ier_num = -6
	    ier_typ = ER_APPL
	    return
	  endif
	goto 10
20	continue
	len(iz)=nr-1
	iz=iz+1
c
	call show_data(iz-1)
c                       
9999	format (a)
c
	end	
c*****7****************************************************************
	subroutine read_marker (ifil)
c+
c	Read marker file (only x-values)
c-                                
	implicit	none
c
	include		'errlist.inc'
	include		'kuplot.inc'
c
	integer		ifil,nr
c
c------ read data
c          
	nr=1
10	continue
	  read(ifil,*,end=20) x((iz-1)*maxpkt+nr)
	   y((iz-1)*maxpkt+nr)=0.0
	  dx((iz-1)*maxpkt+nr)=0.0
	  dy((iz-1)*maxpkt+nr)=0.0
	  nr=nr+1
	  if (nr.gt.maxpkt) then
	    ier_num = -6
	    ier_typ = ER_APPL
	    return
	  endif
	goto 10
20	continue
	len(iz)=nr-1
	iz=iz+1
c
	call show_data(iz-1)
c
	end	
c*****7****************************************************************
	subroutine read_z(ifil,izaehl)
c+
c	Read powder scan files MAN1 program ..
c-                                
	implicit	none
c
	include		'errlist.inc'
	include		'kuplot.inc'
c
	real		dummy
	integer		ifil,izaehl,nr
c
c------ setup
c
	achse(iframe,1)='2-theta'
	achse(iframe,2)='counts'
c
c------ read data
c          
	nr=1   
        read(ifil,*,end=20)
        read(ifil,*,end=20)
        read(ifil,*,end=20)
10	continue
	  if (izaehl.eq.1) then
	    read(ifil,*,end=20) 
     &	         x((iz-1)*maxpkt+nr),y((iz-1)*maxpkt+nr)
	  else
	    read(ifil,*,end=20) 
     &	         x((iz-1)*maxpkt+nr),dummy,y((iz-1)*maxpkt+nr)
	  endif  
	  dx((iz-1)*maxpkt+nr)=0.0
	  dy((iz-1)*maxpkt+nr)=0.0
	  nr=nr+1
	  if (nr.gt.maxpkt) then
	    ier_num = -6
	    ier_typ = ER_APPL
	    return
	  endif
	goto 10
20	continue
	len(iz)=nr-1
	iz=iz+1
c
	call show_data(iz-1)
c                       
	end	
c*****7****************************************************************
	subroutine get_extrema
c+
c	get max/min values of files
c-                                
	implicit	none
c
	include		'kuplot.inc'
c
	integer		ik
c
	do ik=1,iz-1
	  if(lni(ik)) then
	    call get_extrema_xy (x,ik,nx(ik),xmin,xmax)
	    call get_extrema_xy (y,ik,ny(ik),ymin,ymax)
	    call get_extrema_z  (z,ik,nx(ik),ny(ik),zmin,zmax)
	  else
	    call get_extrema_xy (x,ik,len(ik),xmin,xmax)
	    call get_extrema_xy (y,ik,len(ik),ymin,ymax)
	  endif
	enddo
c
	end  
c*****7****************************************************************
	subroutine count_col (zeile,ianz)
c+
c	This subroutine conts the number of columns of string 'zeile'
c-
	implicit	none
c
	character*(*)	zeile
	integer		ianz,i
	logical		ein
c
	integer		len_str
c
	ianz=0
	ein =.false.
c
	do i=1,len_str(zeile)
	  if (zeile(i:i).ne.' ') then
	    ein  = .true.
	  elseif (zeile(i:i).eq.' ' .and. ein) then
	    ein  = .false.
	    ianz = ianz + 1
	  endif
	enddo
c
	if (ein) ianz=ianz+1
c
	end
