c*****7**************************************************************
c
c	Here are all the 'math' routines for KUPLOT.
c
c	Version : 2.0
c	Date    : 17 Oct 96
c
c	Author  : Th. Proffen  (proffen@rsc.anu.edu.au)
c
c*****7**************************************************************
	subroutine do_sort (zeile,lp)
c+
c	sort xy file after increasing x values
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw = 1)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ik,ir,l,i,j
	real		xxx,yyy,dxx,dyy
	real		werte (maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ier_num.ne.0) return
c
        if (ianz.ne.1) then
          ier_num = -6
	  ier_typ = ER_COMM
        else
          ik=nint(werte(1))
          if(ik.lt.iz .and. ik.gt.0) then
	    write (*,1000) ik
	    l =len(ik)/2+1
	    ir=len(ik)    
10	    continue
	    if (l.gt.1) then
	      l=l-1
	      xxx= x((ik-1)*maxpkt+l)
	      yyy= y((ik-1)*maxpkt+l)
	      dxx=dx((ik-1)*maxpkt+l)
	      dyy=dy((ik-1)*maxpkt+l)
	    else
	      xxx= x((ik-1)*maxpkt+ir)
              yyy= y((ik-1)*maxpkt+ir)
              dxx=dx((ik-1)*maxpkt+ir)
              dyy=dy((ik-1)*maxpkt+ir)
	       x((ik-1)*maxpkt+ir)= x((ik-1)*maxpkt+1)
	       y((ik-1)*maxpkt+ir)= y((ik-1)*maxpkt+1)
	      dx((ik-1)*maxpkt+ir)=dx((ik-1)*maxpkt+1)
	      dy((ik-1)*maxpkt+ir)=dy((ik-1)*maxpkt+1)
	      ir=ir-1
	      if (ir.eq.1) then
	         x((ik-1)*maxpkt+1)=xxx
	         y((ik-1)*maxpkt+1)=yyy
	        dx((ik-1)*maxpkt+1)=dxx
	        dy((ik-1)*maxpkt+1)=dyy
	        return
	      endif
	    endif
	    i=l
	    j=l+l
20	    continue
	    if (j.le.ir) then
	      if (j.lt.ir) then
	        if (x((ik-1)*maxpkt+j).lt.x((ik-1)*maxpkt+j+1)) j=j+1
	      endif
	      if (xxx.lt.x((ik-1)*maxpkt+j)) then
                 x((ik-1)*maxpkt+i)= x((ik-1)*maxpkt+j)
                 y((ik-1)*maxpkt+i)= y((ik-1)*maxpkt+j)
                dx((ik-1)*maxpkt+i)=dx((ik-1)*maxpkt+j)
                dy((ik-1)*maxpkt+i)=dy((ik-1)*maxpkt+j)
	        i=j
	        j=j+j
	      else
	        j=ir+1
	      endif
	      goto 20
	    endif
             x((ik-1)*maxpkt+i)=xxx
             y((ik-1)*maxpkt+i)=yyy
            dx((ik-1)*maxpkt+i)=dxx
            dy((ik-1)*maxpkt+i)=dyy
            goto 10
          else
	    ier_num = -4
	    ier_typ = ER_APPL
          endif
	endif
c
1000	format (' ------ > Sorting data set ',i3,' ..')
	end
c*****7**************************************************************
	subroutine do_glat (zeile,lp)
c+
c	Smooth data set
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=3)
c
	character*(*)	zeile
	integer		lp
c
	character*200	cpara(maxw)
	character*2	dir
	integer		lpara(maxw)
	integer		ianz,ik,ip
	real		werte(maxw)
	logical		gx,gy
c
c------ get parameters
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c	
	if (ianz.eq.2 .or. ianz.eq.3) then
	  if (ianz.eq.3) then
	    call do_cap(cpara(3))
	    gx = (cpara(3)(1:1).eq.'X')
	    gy = (cpara(3)(1:1).eq.'Y')
	    cpara(3) = '0.0'
	  else
	    gx = .true.
	    gy = .true.
	  endif
c
	  call ber_params(ianz,cpara,lpara,werte,maxw)
	  ik=nint(werte(1))
	  ip=nint(werte(2))
	  if(ik.lt.iz .and. ik.gt.0) then
c
	    if (gx) dir = ' x'
	    if (gy) dir = ' y'
	    if (gx .and. gy) dir = 'xy'
c
	    if(lni(ik)) then
	      write (*,1000) ik,ip,dir
	      call do_glatt_z (ik,ip,nx(ik),ny(ik),gx,gy)
	    else
	      write (*,1100) ik,ip
	      call do_glatt_y (ik,ip,len(ik))
	    endif
	  else
	    ier_num = -4
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
1000	format (' ------ > Smoothing data set ',I2,' over ',I2,
     &	        ' pts (',A2,') ..')
1100	format (' ------ > Smoothing data set ',I2,' over ',I2,' pts ..')
	end
c*****7*******************************************************************
	subroutine do_inte (zeile,lp)
c+
c	Compute integral for 2d/3d data sets
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'param.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw = 5)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ipkt,ik,ix,iy
	real		rint,drint,rdx,rdy
	real		wx1,wx2,wy1,wy2
	real		werte(maxw)
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ianz.lt.1) then
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	if (ier_num.ne.0) return
	call skalieren
	ik     = nint (werte(1))
	wx1    = ex(iframe,1)
	wx2    = ex(iframe,2)
	wy1    = ey(iframe,1)
	wy2    = ey(iframe,2)
c
	if(ik.gt.0 .and. ik.lt.iz) then
	  if    (ianz.eq.1) then	
	    continue
	  elseif (ianz.eq.3) then
	    wx1    = werte (2)
	    wx2    = werte (3)
	  elseif (ianz.eq.5 .and. lni(ik)) then
	    wx1    = werte (2)
	    wx2    = werte (3)
	    wy1    = werte (4)
	    wy2    = werte (5)
	  else
	    ier_num = -6
	    ier_typ = ER_COMM
	  endif
	else
	  ier_num = -4
	  ier_typ = ER_APPL
	endif
c
	if (ier_num.ne.0) return
c
	rint  = 0.0
	drint = 0.0
	ipkt  = 0
	if (lni(ik)) then
	  do ix = 1,nx(ik)
	    do iy = 1,ny(ik)
	      if (x((ik-1)*maxpkt+ix).ge.wx1 .and. 
     &	          y((ik-1)*maxpkt+iy).ge.wy1 .and. 	
     &	          x((ik-1)*maxpkt+ix).le.wx2 .and. 
     &	          y((ik-1)*maxpkt+iy).le.wy2      ) then
	            zwert = z((ik-1)*nx(1)*ny(1)+(ix-1)*ny(ik)+iy)
	            if (zwert.ne.-9999.0) then
     	              rint  = rint + zwert 
	              ipkt  = ipkt + 1
	            endif
	      endif
	    enddo
	  enddo
	  rdx = (xmax(ik)-xmin(ik))/float(nx(ik))
	  rdy = (ymax(ik)-ymin(ik))/float(ny(ik))
          write (*,2000) ik,wx1,wx2,wy1,wy2,rint*rdx*rdy,
     &	                 sqrt(rint)*rdx*rdy,ipkt
	  if (maxpar_res.lt.7) then
	    ier_num = -24
	    ier_typ = ER_APPL
	    return
	  endif
	  res_para(0)=7
	  res_para(1)=rint*rdx*rdy
	  res_para(2)=sqrt(rint)*rdx*rdy
	  res_para(3)=float(ipkt)
	  res_para(4)=wx1
	  res_para(5)=wx2
	  res_para(6)=wy1
	  res_para(7)=wy2
 	else
	  do ix = 1,len(ik)
	    if (x((ik-1)*maxpkt+ix).ge.wx1 .and. 
     &	        x((ik-1)*maxpkt+ix).le.wx2       ) then
     	          rint  = rint + y((ik-1)*maxpkt+ix)
	          ipkt  = ipkt + 1
	    endif
	  enddo
	  rdx = (xmax(ik)-xmin(ik))/float(len(ik))
          write (*,2100) ik,wx1,wx2,rint*rdx,sqrt(rint)*rdx,ipkt
	  if (maxpar_res.lt.5) then
	    ier_num = -24
	    ier_typ = ER_APPL
	    return
	  endif
	  res_para(0)=5
	  res_para(1)=rint*rdx
	  res_para(2)=sqrt(rint)*rdx
	  res_para(3)=float(ipkt)
	  res_para(4)=wx1
	  res_para(5)=wx2
	endif
	write(*,*) ' '
c
2000	format(' Integration result for data set ',i3,' :',/
     &	       3x,'x-range    : ',g12.4,' to ',g12.4,/
     &	       3x,'y-range    : ',g12.4,' to ',g12.4,/
     &         3x,'Integral   : ',g12.4,' +- ',g12.4,'  (',i7,' pkt)')
2100	format(' Integration result for data set ',i3,' :',/
     &	       3x,'x-range    : ',g12.4,' to ',g12.4,/
     &         3x,'Integral   : ',g12.4,' +- ',g12.4,'  (',i7,' pkt)')
5000	format(a)
c
	end
c*****7*******************************************************************
	subroutine do_mean (zeile,lp,lout)
c+
c	calculates mean and standard deviation 
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'param.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw = 5)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw),lp
	integer		ianz,ik,ix,iy,i
	real		werte(maxw)
	real		wx1,wx2,wy1,wy2
	real		sum(3),sum2(3),wert(3),ave(3),sig(3),n
	logical		lout
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	call ber_params(ianz,cpara,lpara,werte,maxw)
	if (ianz.lt.1) then
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
	if(ier_num.ne.0) return
c
	ik  = nint (werte(1))
	if (ik.ge.iz .or. len(ik).eq.0) then
	  ier_num = -4
	  ier_typ = ER_APPL
	  return
	endif
c
	call skalieren
	if    (ianz.eq.1) then	
	  wx1 = ex(iframe,1)
	  wx2 = ex(iframe,2)
	  wy1 = ey(iframe,1)
	  wy2 = ey(iframe,2)
	elseif (ianz.eq.3) then
	  wx1 = werte (2)
	  wx2 = werte (3)
	  wy1 = ey(iframe,1)
	  wy2 = ey(iframe,2)
	elseif (ianz.eq.5 .and. lni(ik)) then
	  wx1 = werte (2)
	  wx2 = werte (3)
	  wy1 = werte (4)
	  wy2 = werte (5)
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	  return
	endif
c
	do i=1,3
	  sum (i) = 0.0
	  sum2(i) = 0.0
	enddo
	n = 0
c
	if (lni(ik)) then
	  do ix = 1,nx(ik)
	    do iy = 1,ny(ik)
	      if (x((ik-1)*maxpkt+ix).ge.wx1 .and. 
     &	          y((ik-1)*maxpkt+iy).ge.wy1 .and. 	
     &	          x((ik-1)*maxpkt+ix).le.wx2 .and. 
     &	          y((ik-1)*maxpkt+iy).le.wy2      ) then
	            wert(1) = x((ik-1)*maxpkt+ix)
	            wert(2) = y((ik-1)*maxpkt+iy)
	            wert(3) = z((ik-1)*nx(1)*ny(1)+(ix-1)*ny(ik)+iy)
	            if (werte(3).ne.-9999.0) then
	              do i=1,3
     	                sum (i)  = sum (i) + wert(i)
     	                sum2(i)  = sum2(i) + wert(i)**2
	              enddo
	              n = n + 1
	            endif
	      endif
	    enddo
	  enddo
	  if (n.gt.0) then
	    do i=1,3
	      ave(i)=sum(i)/n
	      sig(i)=sqrt(sum2(i)/n-(sum(i)/n)**2)
	    enddo
            if (lout) write(*,2000) ik,wx1,wx2,wy1,wy2,int(n),
     &	                            (ave(i),sig(i),i=1,3)
	    if (maxpar_res.lt.11) then
	      ier_num = -24
	      ier_typ = ER_APPL
	      return
	    endif
	    res_para( 0)=11
	    res_para( 1)=ave(1)
	    res_para( 2)=ave(2)
	    res_para( 3)=ave(3)
	    res_para( 4)=sig(1)
	    res_para( 5)=sig(2)
	    res_para( 6)=sig(3)
	    res_para( 7)=int(n)
	    res_para( 8)=wx1
	    res_para( 9)=wx2
	    res_para(10)=wy1
	    res_para(11)=wy2
	  else
	    ier_num = -20
	    ier_typ = ER_APPL
	  endif
 	else
	  do ix = 1,len(ik)
	    if (x((ik-1)*maxpkt+ix).ge.wx1 .and. 
     &	        x((ik-1)*maxpkt+ix).le.wx2      ) then
	          wert(1) = x((ik-1)*maxpkt+ix)
	          wert(2) = y((ik-1)*maxpkt+ix)
	          do i=1,2
     	            sum (i)  = sum (i) + wert(i)
     	            sum2(i)  = sum2(i) + wert(i)**2
	          enddo
	          n = n + 1
	    endif
	  enddo
	  if (n.gt.0) then
	    do i=1,2
	      ave(i)=sum(i)/n
	      sig(i)=sqrt(sum2(i)/n-(sum(i)/n)**2)
	    enddo
            if (lout) write(*,2100) ik,wx1,wx2,int(n),
     &	                            (ave(i),sig(i),i=1,2)
	    if (maxpar_res.lt.7) then
	      ier_num = -24
	      ier_typ = ER_APPL
	      return
	    endif
	    res_para( 0)=7
	    res_para( 1)=ave(1)
	    res_para( 2)=ave(2)
	    res_para( 3)=sig(1)
	    res_para( 4)=sig(2)
	    res_para( 5)=int(n)
	    res_para( 6)=wx1
	    res_para( 7)=wx2
	  else
	    ier_num = -20
	    ier_typ = ER_APPL
	  endif
	endif
	if (lout) write(*,*) ' '
c
2000	format(' Average and standard deviation data set ',i3,' :',/
     &	       3x,'x-range   : ',g12.4,' to ',g12.4,/
     &	       3x,'y-range   : ',g12.4,' to ',g12.4,/
     &	       3x,'# points  : ',i7//
     &         3x,'Average x : ',g12.4,' sigma :  ',g12.4,/
     &         3x,'Average y : ',g12.4,' sigma :  ',g12.4,/
     &         3x,'Average z : ',g12.4,' sigma :  ',g12.4)
2100	format(' Average and standard deviation data set ',i3,' :',/
     &	       3x,'x-range   : ',g12.4,' to ',g12.4,/
     &	       3x,'# points  : ',i7//
     &         3x,'Average x : ',g12.4,' sigma :  ',g12.4,/
     &         3x,'Average y : ',g12.4,' sigma :  ',g12.4)
5000	format(a)
c
	end
c*****7*******************************************************************
	subroutine do_smax (zeile,lp)
c+
c	Search for maxima in data set
c-
	implicit	none
c
	integer		maxmax,maxw
	parameter	(maxmax=50)
	parameter	(maxw  =10)
c
	include		'kuplot.inc'
	include		'param.inc'
	include		'errlist.inc'
c
	character*(*)	zeile
	character*200	cpara(maxw)
	character*80	cdummy
	real		werte(maxw)
	real		wmax(maxmax)
	integer		lpara(maxw),lp
	integer		ixm(maxmax),iym(maxmax)
	integer		ianz,ifil,im,ima,ik
c
	integer		len_str
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
	if (ianz.ge.2) then
	  call ber_params(2,cpara,lpara,werte,maxw)
	  if (ier_num.ne.0) return
	  ik  =nint(werte(1))
	  ifen=nint(werte(2))
	  if(ik.gt.0 .and. ik.lt.iz) then
	    if(ianz.gt.2) then
	      call del_params(2,ianz,cpara,lpara,maxw)
	      call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	      if(ier_num.ne.0) return
	      ifil=66
	      cdummy=cpara(1)
	      call oeffne(ifil,cdummy,'unknown',.false.)
	      if(ier_num.ne.0) return
	      write(*,900) cdummy(1:len_str(cdummy))
	    else
	      ifil=6
	    endif
c
c------ --- 3D data set
c
	    if(lni(ik)) then
	      call do_fmax_z (ik,wmax,ixm,iym,maxmax,ima)
	      if (ima.eq.0) then
	        ier_num = -22
	        ier_typ = ER_APPL
	      else
	        write (ifil,1000) ik,ifen
	        if (maxpar_res.lt.2*ima) then
	          ier_num = -24
	          ier_typ = ER_APPL
	          return
	        endif
	        res_para(0)=2.0*ima
	        do im=1,ima
	          write (ifil,1100) im,x(ixm(im)),y(iym(im)),wmax(im)
	          res_para(2*im-1)=float(ixm(im))
	          res_para(2*im  )=float(iym(im))
	        enddo
	      endif
c
c------ --- 3D data set
c
	    else
	      call do_fmax_xy (ik,wmax,ixm,maxmax,ima)
	      if (ima.eq.0) then
	        ier_num = -22
	        ier_typ = ER_APPL
	      else
	        write (ifil,2000) ik,ifen
	        if (maxpar_res.lt.ima) then
	          ier_num = -24
	          ier_typ = ER_APPL
	          return
	        endif
	        res_para(0)=ima
	        do im=1,ima
	          write (ifil,2100) im,x(ixm(im)),wmax(im)
	          res_para(im)=float(ixm(im))
	        enddo
	      endif
    	    endif
	    if(ifil.ne.6) close (ifil)
	    write(ifil,*) ' '
	  else
	    ier_num = -4
	    ier_typ = ER_APPL
	  endif
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
 900	format (' ------ > Saving results to file ',a,' ..')
1000	format (' Found maxima data set ',i3,' (ifen = ',i3,') :',//,
     &	        3x,'No.        pos. x       pos. y         value'/
     &	        3x,'--------------------------------------------------')
1100	format (3x,i3,2x,f11.3,2x,f11.3,2x,f18.3)
2000	format (' Found maxima data set ',i3,' (ifen = ',i3,') :',//,
     &	        3x,'No.        pos. x         value'/
     &	        3x,'-------------------------------------')
2100	format (3x,i3,2x,f11.3,2x,f18.3)
	end	
c*****7*****************************************************************
c	SUPPORT ROUTINES
c*****7*****************************************************************
      	subroutine do_glatt_z (ik,np,nxx,nyy,gx,gy)
c+
c	glaetten des nipl-2d-arrays
c-
	implicit 	none
c
	include		'kuplot.inc'
c
	real 		a(maxarray)
	real		xnw,s
	integer		ik,np,nxx,nyy
	integer		nd,na,ne,ip,jp,im,jm,i,j,k
	logical		gx,gy
c
      	nd=(np-1)/2.+0.1
      	na=nd+1
c
c------ glaettung in x-richtung
c
	if (.not. gx) goto 222
      	ne=nxx-nd
      	do j=1,nyy
          do i=na,ne
            xnw=np
            im=i-nd
            ip=i+nd
            s=0.0
            do k=im,ip
              if (z((ik-1)*nx(1)*ny(1)+(k-1)*ny(ik)+j).ne.-9999.0 .and. 
     &	          z((ik-1)*nx(1)*ny(1)+(k-1)*ny(ik)+j).ne.0.0) then
	        s=s+z((ik-1)*nx(1)*ny(1)+(k-1)*ny(ik)+j)
	      else 
	        xnw=xnw-1
	      endif
	    enddo
            if (xnw.gt.0) then
  	      a(i)=s/xnw
	    else 
	      a(i)=-9999.0
	    endif
	  enddo
          do i=na,ne
            z((ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+j)=a(i)
	  enddo
	enddo
c
c------ glaettung in y-richtung
c
222	continue
	if (.not.gy) goto 333
      	ne=nyy-nd
      	do i=1,nxx
          do j=na,ne
            xnw=np
            jm=j-nd
            jp=j+nd
            s=0.0
            do k=jm,jp
              if (z((ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+k).ne.-9999.0 .and. 
     &	          z((ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+k).ne.0.0) then
	        s=s+z((ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+k)
	      else 
	        xnw=xnw-1
	      endif
	    enddo
            if (xnw.gt.0) then
  	      a(j)=s/xnw
	    else 
	      a(j)=-9999.0
	    endif
	  enddo
          do j=na,ne               
            z((ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+j)=a(j)
	  enddo
	enddo
c
333	continue
      	end
c*****7*****************************************************************
      	subroutine do_glatt_y (ik,ip,llen)
c+
c	glaetten der kurve ik ueber ip punkte
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real	   	ay(maxarray)
	real		s,xnw
	integer		ik,ip,llen
	integer		na,ne,nd,im,ie,i,k
c            
        nd=(ip-1)/2.0+0.1
     	na=nd+1
      	ne=llen-nd
        do i=na,ne
          xnw=ip
          im=i-nd
          ie=i+nd
          s=0.0
          do k=im,ie
	    s=s+y((ik-1)*maxpkt+k)
	  enddo
  	  ay(i)=s/xnw
	enddo     
	do i=na,ne
	  y((ik-1)*maxpkt+i)=ay(i)
	enddo 
c
	end
c*****7*****************************************************************
 	subroutine get_extrema_xy (a,ik,ilen,amin,amax)
c+
c	extrema der kurve ik bestimmen
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real	   	a(maxarray)
	real		amax(maxkurvtot), amin(maxkurvtot)
	integer		ik,ip,ilen
c
	amax(ik)=a((ik-1)*maxpkt+1)
	amin(ik)=a((ik-1)*maxpkt+1)
	do ip=2,ilen
	  amax(ik)=max(amax(ik),a((ik-1)*maxpkt+ip))
	  amin(ik)=min(amin(ik),a((ik-1)*maxpkt+ip))
	enddo
c
	end
c*****7*****************************************************************
 	subroutine get_extrema_z (a,ik,nxx,nyy,amin,amax)
c+
c	extrema der kurve ik bestimmen
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real	   	a(maxarray)
	real		amax(maxkurvtot), amin(maxkurvtot)
	integer		ik,nxx,nyy,ikk,i,j
c
	amax(ik)=a((ik-1)*nx(1)*ny(ik)+1)
	amin(ik)=a((ik-1)*nx(1)*ny(ik)+1)
	if(amin(ik).eq.-9999.) amin(ik)=1e+30
	do i=1,nxx
	  do j=2,nyy
	    ikk=(ik-1)*nx(1)*ny(1)+(i-1)*ny(ik)+j
	    amax(ik)=max(amax(ik),a(ikk))
	    if (a(ikk).ne.-9999.) amin(ik)=min(amin(ik),a(ikk))
	  enddo
	enddo
c
	end
c*****7*****************************************************************
	subroutine koor_trans (npkt,xa,ya)
c+
c	transformation beim shearen
c-
	implicit	none
c
	integer		npkt,i
	real		xa(npkt),ya(npkt)
c
	include		'kuplot.inc'
	include		'wink.inc'
c
	if (shear(iframe).ne.90.0 .and. sfl(iframe)) then 
	  do i=1,npkt
	    if (ya(i).gt.ey(iframe,1)) then
	      xa(i)=xa(i)+(ya(i)-ey(iframe,1))
     &	            *yskal(iframe)/tan(rad*shear(iframe))
	    else
	      xa(i)=xa(i)
	    endif
	    ya(i)=ya(i)
	  enddo
	endif
c
	end
c*****7*******************************************************************
	subroutine do_fmax_xy (ik,wmax,ixm,maxmax,ima)
c+
c	maxima bestimmen fuer xy-files
c-
	implicit	none
c
	include		'kuplot.inc'
	include         'errlist.inc'
c
	integer		maxmax
	real		wmax(maxmax)
	integer		ixm(maxmax),ik,ima
	integer		ix,jf
	logical		max_da
c
	ima =1
	do ix=1+ifen,len(1)-ifen
	  max_da=.true.
	  do jf=-ifen,ifen
	    max_da = max_da .and. 
     &	             (y((ik-1)*maxpkt+ix).ge.y((ik-1)*maxpkt+ix+jf))	
	  enddo
	  if (max_da) then
	    wmax(ima)=y((ik-1)*maxpkt+ix)
	    ixm(ima)=ix
	    ima=ima+1
	    if (ima.gt.maxmax) then
	      ier_num=-21
	      ier_typ=ER_APPL
	      ima=maxmax
	      return
	    endif
	  endif
	enddo
	ima=ima-1
c
	end
c*****7*******************************************************************
	subroutine do_fmax_z (ik,wmax,ixm,iym,maxmax,ima)
c+
c	maxima bestimmen aus xyz files
c-
	implicit	none
c
	include		'kuplot.inc'
	include         'errlist.inc'
c
	integer		maxmax
	real		wmax(maxmax)
	integer		ik,ima,ixm(maxmax),iym(maxmax)
	integer		ikk,iix,ix,iy,jf,kf
	logical		max_da
c
	ima =1
	ikk =(ik-1)*nx(1)*ny(1)
	do ix=1+ifen,nx(1)-ifen
	  do iy=1+ifen,ny(1)-ifen
	    iix=ix-1
	    if(z(ikk+iix*ny(ik)+iy).eq.-9999.0) goto 20
	    max_da=.true.
	    do jf=-ifen,ifen
	      do kf=-ifen,ifen
	        max_da = max_da .and.
     &	        (z(ikk+iix*ny(ik)+iy)).ge.z(ikk+(iix+jf)*ny(ik)+iy+kf)
	        if (.not. max_da) goto 20
	      enddo           
	    enddo
	    if (max_da) then
	      wmax(ima)=z(ikk+iix*ny(ik)+iy)
	      ixm(ima)=ix
	      iym(ima)=iy
	      ima=ima+1
	      if (ima.gt.maxmax) then
	        ier_num=-21
	        ier_typ=ER_APPL
	        ima=maxmax
	        return
	      endif
	    endif
20	    continue
	  enddo
	enddo
	ima=ima-1
c
	end
c*****7*******************************************************************
	subroutine extract_subarray (xf,yf,zf,xmit,ymit,nsize,ik,ie)
c+
c	schneiden eines subarrays fuer interpolationsroutinen
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		nsize
	real		xf(nsize),yf(nsize),zf(nsize,nsize)
	real		xmit,ymit
	integer		ik,ie,ip,ii,jj,ixx,iyy
c
	ie =0
	ip =nsize/2+1
	ixx=nint((xmit-xmin(ik))/(xmax(ik)-xmin(ik))*float(nx(ik)-1))+1  
	iyy=nint((ymit-ymin(ik))/(ymax(ik)-ymin(ik))*float(ny(ik)-1))+1
	if(ixx.lt.ip .or. (ixx+ip).gt.nx(ik) .or.
     &	   iyy.lt.ip .or. (iyy+ip).gt.ny(ik))     then
	  ie=-1
	  return
	endif
	do ii=1,nsize
	  do jj=1,nsize
	    xf(ii)=x((ik-1)*maxpkt+ii-ip+ixx)
	    yf(jj)=y((ik-1)*maxpkt+jj-ip+iyy)
	    zf(ii,jj)=z((ik-1)*nx(1)*ny(1)+(ii-ip+ixx)*ny(ik)+jj-ip+iyy)
	    if (zf(ii,jj).eq.-9999.) then
	      ie=-1
	      return
	    endif
	  enddo
	enddo 
c
	end
c***********************************************************************
c    	ROUTINES FROM NUMERICAL RECIPES
c***********************************************************************
      subroutine polin2(x1a,x2a,ya,m,n,x1,x2,y,dy)
      parameter (nmax=50,mmax=50)
      dimension x1a(m),x2a(n),ya(m,n),yntmp(nmax),ymtmp(mmax)
      do 12 j=1,m
        do 11 k=1,n
          yntmp(k)=ya(j,k)
11      continue
        call polint(x2a,yntmp,n,x2,ymtmp(j),dy)
12    continue
      call polint(x1a,ymtmp,m,x1,y,dy)
      return
      end
      subroutine polint(xa,ya,n,x,y,dy)
      parameter (nmax=50) 
      dimension xa(n),ya(n),c(nmax),d(nmax)
      ns=1
      dif=abs(x-xa(1))
      do 11 i=1,n 
        dift=abs(x-xa(i))
        if (dift.lt.dif) then
          ns=i
          dif=dift
        endif
        c(i)=ya(i)
        d(i)=ya(i)
11    continue
      y=ya(ns)
      ns=ns-1
      do 13 m=1,n-1
        do 12 i=1,n-m
          ho=xa(i)-x
          hp=xa(i+m)-x
          w=c(i+1)-d(i)
          den=ho-hp
          if(den.eq.0.)pause
          den=w/den
          d(i)=hp*den
          c(i)=ho*den
12      continue
        if (2*ns.lt.n-m)then
          dy=c(ns+1)
        else
          dy=d(ns)
          ns=ns-1
        endif
        y=y+dy
13    continue
      return
      end
      subroutine spline(x,y,n,yp1,ypn,y2)
      parameter (nmax=1000)
      dimension x(n),y(n),y2(n),u(nmax)
      if (yp1.gt..99e30) then
        y2(1)=0.
        u(1)=0.
      else
        y2(1)=-0.5
        u(1)=(3./(x(2)-x(1)))*((y(2)-y(1))/(x(2)-x(1))-yp1)
      endif
      do 11 i=2,n-1
        sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
        p=sig*y2(i-1)+2.
        y2(i)=(sig-1.)/p
        u(i)=(6.*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1))
     *      /(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*u(i-1))/p
11    continue
      if (ypn.gt..99e30) then
        qn=0.
        un=0.
      else
        qn=0.5
        un=(3./(x(n)-x(n-1)))*(ypn-(y(n)-y(n-1))/(x(n)-x(n-1)))
      endif
      y2(n)=(un-qn*u(n-1))/(qn*y2(n-1)+1.)
      do 12 k=n-1,1,-1
        y2(k)=y2(k)*y2(k+1)+u(k)
12    continue
      return
      end
      subroutine splint(xa,ya,y2a,n,x,y)
      dimension xa(n),ya(n),y2a(n)
      klo=1
      khi=n
1     if (khi-klo.gt.1) then
        k=(khi+klo)/2
        if(xa(k).gt.x)then
          khi=k
        else
          klo=k
        endif
      goto 1
      endif
      h=xa(khi)-xa(klo)
      if (h.eq.0.) pause 'bad xa input.'
      a=(xa(khi)-x)/h
      b=(x-xa(klo))/h
      y=a*ya(klo)+b*ya(khi)+
     *      ((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.
      return
      end
