c*********************************************************************
 	subroutine do_plot (befehl,zeile,lbef,lp)
c+
c	These are the main plot routines for 2D and 3D data. 3D data
c	can be plotted as contour plots or bitmaps or both. All
c	settings are defined in 'kuplot.inc'.
c
c	Version : 2.0
c	Date    : 11 Oct 96
c
c	Author  : Th. Proffen  (proffen@rsc.anu.edu.au)
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=10)
c
	character*(*)	befehl,zeile
	character*200	cpara(maxw),prnbef
	character*80	filname
	real		werte(maxw)
	integer		lpara(maxw)
	integer		ianz,ii,ik,lbef,lp
	integer		iframe_alt
	logical		k_in_f,tfr
c
	integer		len_str
c
c------ see if there are data at all
c
	tfr = .false.
	do ii=1,iaf
	  tfr = tfr .or. (infra(ii,1).eq.-1)
	enddo
c
	if (iz.le.1 .and. .not.tfr) then
	  ier_num = -12
	  ier_typ = ER_APPL
	  return
	endif
c
	call do_cap(befehl)
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ Command plot and no further commands
c
	if (befehl(1:2).eq.'PL') then
	  filname  = ' '
	  id_dev   = id_dev_screen
c
c------ Command save
c
	elseif (befehl(1:2).eq.'SA') then
	  filname  = 'kuplot.plt'
	  id_dev   = id_dev_hardcopy
	  if (ianz.ge.1) then
	    call do_cap(cpara(1))
	    if (cpara(1)(1:2).eq.'PS') then
	      id_dev = ps
	    elseif (cpara(1)(1:2).eq.'PL') then
	      id_dev = hpgl
	    else
	      ier_num = -11
	      ier_typ = ER_APPL
	    endif
c
	    if (ianz.gt.1) then
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	      filname = cpara(1)
	    endif
	  endif
c
c------ Command prin
c
	elseif (befehl(1:2).eq.'PR') then
	  filname = 'kuplot.tmp'
	  id_dev   = id_dev_hardcopy
	  if (id_dev.eq.ps) then
	    prnbef = prnps
	  elseif (id_dev.eq.hpgl) then
	    prnbef = prnhpgl
	  endif
c
	  if (ianz.ge.1) then
	    call do_cap(cpara(1))
	    if (cpara(1)(1:2).eq.'PS') then
	      id_dev = ps
	      prnbef = prnps
	    elseif (cpara(1)(1:2).eq.'PL') then
	      id_dev = hpgl
	      prnbef = prnhpgl
	    else
	      ier_num = -11
	      ier_typ = ER_APPL
	    endif
c
	    if (ianz.gt.1) then
	      call get_params(zeile,ianz,cpara,lpara,maxw,-lp)
	      call del_params (1,ianz,cpara,lpara,maxw)
	      call do_build_name(ianz,cpara,lpara,werte,maxw,1)
	      prnbef = cpara(1)
	    endif
	  endif
	endif  
	if (ier_num.ne.0) return
c
c------ here starts the plotting
c
	call init_kupl (filname)
	if (ier_num.ne.0) return
	iframe_alt=iframe
	do ii=1,iaf
	  iframe=ii
	  if (infra(iframe,1).eq.-1) then
	    call draw_text_frame
	  else
	    call skalieren
	    call open_workstation_kupl
	    do ik=1,iz-1
              if ((hlineart(ik).ne.1) .and. k_in_f(ik) .and. lni(ik))
     &          call bitmap_kupl (ik)
	    enddo
	    call draw_rahmen_kupl
	    call draw_werte_kupl
	  endif
	enddo 
	call close_kupl
	iframe=iframe_alt
c
c------ if the command was prin we'll print
c
	if (befehl(1:2).eq.'PR') then
	  ii=len_str(prnbef)
	  prnbef = prnbef(1:ii)//' '//filname
	  ii=len_str(prnbef)
	  write (*,1000) prnbef(1:ii)
	  call do_operating (prnbef(1:ii))
	  call do_del_file (filname)
	endif
c
1000	format (' ------ > Printing using command : ',a,' ..')
	end
c*****7*****************************************************************
	subroutine open_workstation_kupl
c+
c 	init plotting window, scaling factors etc. ...
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'wink.inc'
	include		'errlist.inc'
c
	real		width,height,breit_x,breit_y
	real		plmax_x,plmax_y,plmax
	real		hubx,huby
	real		px(4),py(4)
	logical		sflag
c
c------ set paper size for A4 in cm
c
	if (orient) then
      	  width =24.70 * (frame(iframe,3)-frame(iframe,1))
      	  height=17.45 * (frame(iframe,4)-frame(iframe,2))
	else
      	  width =17.45 * (frame(iframe,3)-frame(iframe,1))
      	  height=24.70 * (frame(iframe,4)-frame(iframe,2))
	endif
c
c------ set window for actual frame
c
        wymin   = ey(iframe,1)
        wymax   = ey(iframe,2)
        wxmin   = ex(iframe,1)
        wxmax   = ex(iframe,2)
c
	if (wxmin.eq.wxmax) then
	  wxmin = wxmin - 1.0
	  wxmax = wxmax + 1.0
	endif
	if (wymin.eq.wymax) then
	  wymin = wymin - 1.0
	  wymax = wymax + 1.0
	endif
c
c------ Auto calculation of plmass and yskal
c
	if (yskal(iframe).eq.-9999. .and. 
     &	    shear(iframe).ne.90.0) yskal(iframe) = 1.0
	call koor_trans (1,wxmin,wymin)
	call koor_trans (1,wxmax,wymax)
	breit_x = wxmax-wxmin
	breit_y = wymax-wymin
c
      	if     (plmass(iframe).eq.-9999. .and. 
     &	        yskal (iframe).eq.-9999.) then
          plmass(iframe)=width/breit_x
          yskal (iframe)=height/(breit_y*plmass(iframe))
      	elseif (plmass(iframe).eq.-9999. .and. 
     &	        yskal (iframe).ne.-9999.) then
	  plmass(iframe)=
     &	        amin1(width/breit_x,(height/breit_y)/yskal(iframe))  
      	elseif (plmass(iframe).ne.-9999. .and. 
     &	        yskal (iframe).eq.-9999.) then
          yskal(iframe) =height/(breit_y*plmass(iframe))
	endif
        plmax_x=width/breit_x
        plmax_y=(height/breit_y)/yskal(iframe)
	plmax=amin1(plmax_x,plmax_y)
        if(plmass(iframe).gt.plmax) then 
	  plmass(iframe)=plmax
    	  write (*,1000) iframe,plmass(iframe)
        endif
	plmass(iframe)=abs(plmass(iframe))
	if (shear(iframe).gt.90.0) then
	  wxmin=ex(iframe,1)+(ey(iframe,2)-ey(iframe,1))*yskal(iframe)/
     &	                                         tan(rad*shear(iframe))
	endif
        wxmax=width/plmass(iframe)+wxmin
        wymin=ey(iframe,1)
        wymax=height/(plmass(iframe)*yskal(iframe))+wymin 
c
c------ we need some space for title etc.
c
      	hubx    = wxmax-wxmin
      	huby    = wymax-wymin
	wxmin   = wxmin - 0.30*hubx
	wxmax   = wxmax + 0.30*hubx
	wymin   = wymin - 0.30*huby
	wymax   = wymax + 0.30*huby
c
c------ init the plot device
c
	call open_kupl
c
c------ check for frame border and background color
c
        sflag = sfl(iframe)
        sfl(iframe) = .false.
        call ltyp_kupl(1,linewid(0))
        call col_kupl (6)
c
	px(1)=wxmin
	py(1)=wymin
	px(2)=wxmax
	py(2)=wymin
	px(3)=wxmax
	py(3)=wymax
	px(4)=wxmin
	py(4)=wymax
c
	if (frback(iframe,1).ne.1.0 .or. 
     &	    frback(iframe,2).ne.1.0 .or.
     &	    frback(iframe,3).ne.1.0     ) then
	  call colrgb_kupl(frback(iframe,1),frback(iframe,2),
     &	                   frback(iframe,3))
          call area_kupl (4,px,py,.true.)
	endif
	call col_kupl(6)
        if (tot_frame) call area_kupl (4,px,py,.false.)
        sfl(iframe)=sflag
c
1000  	format(' ****PLOT**** Frame ',i2,': PLMASS adjusted to ',
     &	       f10.2,'   **** -99 ****')
      	end
c*****7*****************************************************************
	subroutine draw_rahmen_kupl
c+
c 	Draw frame, axis and title
c-                                       
	implicit	none
c
	include		'kuplot.inc'
c
	character*80	text,fstr
      	real 	   	xp(2),yp(2),xpp(2),ypp(2)
	real		xr(5),yr(5),xh(2),yh(2)
	real		xhh(2),yhh(2)
	real		ux,uy,ox,oy,xt,yt,dxx,dyy,ht
	real		chxnum,chynum,cilmax
	integer		i,ij,il
	logical		sflag
c
	integer		len_str
c
c------ set colors etc. for frame drawing
c
	call ltyp_kupl(1,linewid(0))
	call col_kupl(6)
	call fsize_kupl (fonsize(iframe,4),fon_id(iframe,4))
c
c------ plot x ticks and x label
c
	if (ibox(iframe).ge.2) then
       	  dxx=ex(iframe,2)-ex(iframe,1)
      	  dyy=ey(iframe,2)-ey(iframe,1)
      	  ht=0.15/(plmass(iframe)*yskal(iframe))
      	  i=1
      	  xp(1)=t0(iframe,1)
      	  do 30 while (xp(1).le.ex(iframe,2))
            xp(2)=xp(1)
      	    yp (1)=ey(iframe,1)           
      	    yp (2)=ey(iframe,1)+2.0*ht
      	    yh (1)=ey(iframe,1)
      	    yh (2)=ey(iframe,1)+ht
      	    ypp(1)=ey(iframe,2)           
      	    ypp(2)=ey(iframe,2)-2.0*ht
      	    yhh(1)=ey(iframe,2)
      	    yhh(2)=ey(iframe,2)-ht
            if(xp(1).ge.ex(iframe,1)) then
              if(mod(i,2).eq.1) then
	        if(igrid(iframe)) then
	          call col_kupl(ilinecol(0))
	          call ltyp_kupl (2,linewid(0)*0.25) 
	          xr(1)= xp(1)
	          yr(1)= ey(iframe,1)
	          xr(2)= xp(1)
	          yr(2)= ey(iframe,2)
	          call pline_kupl (2,xr,yr)
	          call ltyp_kupl (1,linewid(0))
	          call col_kupl(6)
	        endif
                call pline_kupl (2,xp,yp)
	        if (ibox(iframe).eq.4) call pline_kupl(2,xp,ypp)
	        text = achse(iframe,1)
	        if (text(1:3).ne.'OFF') then
	          call real_str  (xp(1),fstr,il)
      	          yt=ey(iframe,1)-charhy
	          xt=xp(1)
	          call col_kupl(foncol(iframe,4))
	          if(il.gt.0) then
	            if(il.gt.0 ) then
                      call text_kupl (xt,yt,fstr(1:il),if_centre)
	            endif
	          endif
	          call col_kupl(6)
	        endif
              else
                call pline_kupl (2,xp,yh)
	        if (ibox(iframe).eq.4) call pline_kupl(2,xp,yhh)
              endif
            endif
            i=i+1
            xp(1)=t0(iframe,1)+float(i-1)*t(iframe,1)*0.5
30        continue
c
c------ - plot y ticks and label
c
	  cilmax=0
          ht=0.15/plmass(iframe)
      	  i=1
      	  yp(1)=t0(iframe,2)
      	  do 32 while(yp(1).le.ey(iframe,2))
            yp(2)=yp(1)
            xp (1)=ex(iframe,1)
            xp (2)=ex(iframe,1)+2.0*ht
            xh (1)=ex(iframe,1)
            xh (2)=ex(iframe,1)+ht
            xpp(1)=ex(iframe,2)
            xpp(2)=ex(iframe,2)-2.0*ht
            xhh(1)=ex(iframe,2)
            xhh(2)=ex(iframe,2)-ht
            if(yp(1).ge.ey(iframe,1)) then
              if(mod(i,2).eq.1) then
	        if(igrid(iframe)) then
	          call ltyp_kupl (2,linewid(0)*0.25)
	          call col_kupl(ilinecol(0))
	          xr(1)=ex(iframe,1)
	          yr(1)= yp(1)
	          xr(2)=ex(iframe,2)
	          yr(2)= yp(1)
	          call pline_kupl (2,xr,yr)
	          call ltyp_kupl (1,linewid(0))
	          call col_kupl(6)
	        endif
                call pline_kupl (2,xp,yp)
	        if (ibox(iframe).eq.4) call pline_kupl(2,xpp,yp)
	        text = achse(iframe,2)
	        if (text(1:3).ne.'OFF') then
                  yt=yp(1)-charhy/3
	          xt=ex(iframe,1)-charhx/2
	          call real_str (yp(1),fstr,il)
	          call col_kupl(foncol(iframe,4))
	          if(il.gt.0) then
                    call text_kupl (xt,yt,fstr(1:il),if_right)
	          endif
	          call col_kupl(6)
	          cilmax = max (cilmax,xt)
	        endif
              else
	        if (ibox(iframe).eq.4) call pline_kupl(2,xhh,yp)
                call pline_kupl (2,xh,yp)
              endif               
            endif
            i=i+1
            yp(1)=t0(iframe,2)+float(i-1)*t(iframe,2)*0.5
32        continue
c
	  sflag  = sfl(iframe)
	  sfl(iframe) = .false.
c
	  chxnum = charhx
	  chynum = charhy
	  text=achse(iframe,1)
	  if(text(1:3).ne.'OFF') then
	    xt= ex(iframe,1)+(ex(iframe,2)-ex(iframe,1))/2.0
	    yt=(ey(iframe,1)-2.5*chynum)
	    call col_kupl(foncol(iframe,3))
	    call fsize_kupl (fonsize(iframe,3),fon_id(iframe,3))
	    if(len_str(text).gt.0 ) then
              call text_kupl (xt,yt,text(1:len_str(text)),if_centre)
	    endif
	  endif
c
	  text=achse(iframe,2)
	  if(text(1:3).ne.'OFF') then
	    sfl(iframe) = .true.
	    if (shear(iframe).gt.90.0) then
	      yt=ey(iframe,2)
	    else
	      yt=ey(iframe,1)
	    endif
	    xt=  ex(iframe,1)-cilmax-1.2*chxnum
	    call koor_trans (1,xt,yt)
	    sfl(iframe) = .false.
	    yt= ey(iframe,1)+(ey(iframe,2)-ey(iframe,1))/2
	    call col_kupl(foncol(iframe,3))
	    call fsize_kupl (fonsize(iframe,3),fon_id(iframe,3))
	    if(len_str(text).gt.0 ) then
	      call text_kupl (xt,yt,text(1:len_str(text)),-if_centre)
	    endif
	  endif
	endif
c
	sfl(iframe) = sflag
c
c------ plot frame
c
	if (ibox(iframe).ge.1) then
      	  xr(1)=ex(iframe,1)
      	  xr(2)=ex(iframe,1)
      	  xr(3)=ex(iframe,2)
      	  xr(4)=ex(iframe,2)
      	  xr(5)=ex(iframe,1)
c
      	  yr(1)=ey(iframe,1)
      	  yr(2)=ey(iframe,2)
      	  yr(3)=ey(iframe,2)
      	  yr(4)=ey(iframe,1)
      	  yr(5)=ey(iframe,1)
      	  call pline_kupl (5,xr,yr)
	endif
c
c------ plot axis if necessary
c
	if (ibox(iframe).ge.3) then
       	  uy=sign(1.,ey(iframe,1))
       	  oy=sign(1.,ey(iframe,2))
          if(uy.ne.oy) then
            xp(1)=ex(iframe,1)
            xp(2)=ex(iframe,2)
            yp(1)=0.
            yp(2)=0.
            call pline_kupl (2,xp,yp)
          endif
          ux=sign(1.,ex(iframe,1))
          ox=sign(1.,ex(iframe,2))
          if(ux.ne.ox) then
            xp(1)=0.
            xp(2)=0.
            yp(1)=ey(iframe,1)
            yp(2)=ey(iframe,2)
            call pline_kupl (2,xp,yp)
          endif
	endif
c
c------ plot titels
c
	text=titel(iframe,2)
	if (frjust(iframe).eq.if_left) then
          xt=ex(iframe,1)
	  ij=if_left
	else
	  xt=ex(iframe,1)+0.5*(ex(iframe,2)-ex(iframe,1))
	  ij=if_centre
	endif
	yt=ey(iframe,2)+0.5*charhy
	sfl(iframe) = .true.
	call koor_trans (1,xt,yt)
	sfl(iframe) = .false.
	call col_kupl(foncol(iframe,2))
	call fsize_kupl (fonsize(iframe,2),fon_id(iframe,2))
	if(len_str(text).gt.0 ) then
          call text_kupl (xt,yt,text(1:len_str(text)),ij)
	endif
	text=titel(iframe,1)
	if (frjust(iframe).eq.if_left) then
          xt=ex(iframe,1)
	  ij=if_left
	else
	  xt=ex(iframe,1)+0.5*(ex(iframe,2)-ex(iframe,1))
	  ij=if_centre
	endif
	yt=ey(iframe,2)+0.5*charhy
	sfl(iframe) = .true.
	call koor_trans (1,xt,yt)
	sfl(iframe) = .false.
	yt=yt+1.0*charhy
	call col_kupl(foncol(iframe,1))
	call fsize_kupl (fonsize(iframe,1),fon_id(iframe,1))
	if(len_str(text).gt.0 ) then
          call text_kupl (xt,yt,text(1:len_str(text)),ij)
	endif
c
	sfl(iframe) = sflag
        end
c****7******************************************************************
	subroutine draw_text_frame
c+                                                       
c 	plot text frame
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	character*80	zeile,filname
	real		width,height,xoffset,yoffset
	real		px(4),py(4),xt,yt,fsize
	real		fak_pl,fak_pl_x,fak_pl_y
	integer		i
	logical		sflag
c
	integer		len_str
c
	filname=ftext(iframe)
	call do_cap (filname)
c
	if (filname.eq.'PARA' .or. filname.eq.'KUPL.PAR') then
	  call write_para
	  filname = 'kupl.par'
	elseif (filname.eq.'FIT' .or. filname.eq.'KUPL.FIT') then
	  call write_fit
	  filname = 'kupl.fit'
	else
	  filname = ftext(iframe)
	endif
c                   
	call oeffne (21,filname,'unknown',.true.)
	if (ier_num.ne.0) return
c
        if (orient) then
          width =24.70 * (frame(iframe,3)-frame(iframe,1))
          height=17.45 * (frame(iframe,4)-frame(iframe,2))
        else
          width =17.45 * (frame(iframe,3)-frame(iframe,1))
          height=24.70 * (frame(iframe,4)-frame(iframe,2))
        endif
c
	wxmin=0.0
	wxmax=1.0
	wymin=0.0
	wymax=1.0
	plmass(iframe)=width/(wxmax-wxmin)
	yskal (iframe)=height/((wymax-wymin)*plmass(iframe))
	xoffset=0.03
	yoffset=0.03
c
	call open_kupl
c
        sflag = sfl(iframe)
        sfl(iframe) = .false.
        call ltyp_kupl(1,linewid(0))
        call col_kupl (6)
c
	px(1)=wxmin
	py(1)=wymin
	px(2)=wxmax
	py(2)=wymin
	px(3)=wxmax
	py(3)=wymax
	px(4)=wxmin
	py(4)=wymax
c
	if (frback(iframe,1).ne.1.0 .or. 
     &	    frback(iframe,2).ne.1.0 .or.
     &	    frback(iframe,3).ne.1.0     ) then
	  call colrgb_kupl(frback(iframe,1),frback(iframe,2),
     &	                   frback(iframe,3))
          call area_kupl (4,px,py,.true.)
	endif
	call col_kupl(6)
        if (tot_frame) call area_kupl (4,px,py,.false.)
        sfl(iframe)=sflag
c
        fak_pl_x  = (frame(iframe,3)-frame(iframe,1))
        fak_pl_y  = (frame(iframe,4)-frame(iframe,2))
        fak_pl    = (fak_pl_x+fak_pl_y)/2.
        fsize     = fonsize(iframe,5) / fak_pl
c
	call col_kupl(foncol(iframe,5))
	call fsize_kupl (fsize,fon_id(iframe,5))
c
	i=0
10	continue
	  read (21,'(a)',end=20) zeile
	  if (frjust(iframe).eq.if_left) then
	    xt=xoffset
	    yt=1.0-yoffset-(i+1)*charhy
	    if(len_str(zeile).gt.0 ) then
	      call text_kupl(xt,yt,zeile(1:len_str(zeile)),if_left)
	    endif
	  else
	    xt=0.5
	    yt=1.0-yoffset-(i+1)*charhy
	    if(len_str(zeile).gt.0 ) then
	      call text_kupl(xt,yt,zeile(1:len_str(zeile)),if_centre)
	    endif
	  endif
	  i=i+1
	goto 10
20	continue
	close (21)
c
	end                           
c****7******************************************************************
	subroutine draw_werte_kupl
c+                                                       
c 	Main plotting routine
c-
	implicit	none
c
	integer		maxmax
	parameter	(maxmax=50)
c
	include		'kuplot.inc'
	include		'errlist.inc'
c                           
	character*40	text
	real		xpl(maxarray),ypl(maxarray),y2a(maxarray)
	real		xhe(5*maxsp),yhe(5*maxsp),eex(2),eey(2)
        real            wmax(maxmax)
	real		fam,fama,delx,dely,xst,xen,dxx,xxx,yyy
	real		xma,yma,xmark,ymark,xt,yt
	real		xfehl,yfehl,xleg,yleg
        integer         ixm(maxmax),iym(maxmax)
	integer		ikurv,ipkt,npkt,is,iii
	integer		iicol,iityp,ima,iann,il
	logical		k_in_f
c
	integer		len_str
c
	call col_kupl(foncol(iframe,6))
	call fsize_kupl (fonsize(iframe,6),fon_id(iframe,6))
c
	eex(1)=ex(iframe,1)
	eex(2)=ex(iframe,2)
	eey(1)=ey(iframe,1)
	eey(2)=ey(iframe,2)
c
	fama=max((frame(iframe,3)-frame(iframe,1)),
     &	         (frame(iframe,4)-frame(iframe,2)))
	do ikurv=1,iz-1
	  if (.not. k_in_f(ikurv)) goto 999
c
	  delx=fama*sizemark(ikurv)/(2.0*plmass(iframe))
	  dely=fama*sizemark(ikurv)/(2.0*plmass(iframe)*yskal(iframe))
c
c-------- draw lines
c
	  if(lni(ikurv)) then
	    call draw_contour_kupl (ikurv)
	  else
	    if(ilinetyp(ikurv).ne.0 .and. fform(ikurv).ne.'CR') then
	      call ltyp_kupl (ilinetyp(ikurv),linewid(ikurv)) 
	      call col_kupl (ilinecol(ikurv))
	      do ipkt=2,len(ikurv)
	        xpl(ipkt-1) = x((ikurv-1)*maxpkt+(ipkt-1))
	        ypl(ipkt-1) = y((ikurv-1)*maxpkt+(ipkt-1))
	        xpl(ipkt)   = x((ikurv-1)*maxpkt+ipkt)
	        ypl(ipkt)   = y((ikurv-1)*maxpkt+ipkt)
	      enddo
	      npkt = len(ikurv)
	      call clip_array (eex,eey,xpl,ypl,npkt)
	      if (npkt.gt.1) then
	        if     (ilineart(ikurv).eq.1) then
	          call pline_kupl (npkt,xpl,ypl)
	        elseif (ilineart(ikurv).eq.2) then
                  if (npkt.gt.maxsp) then
                    ier_num = -13
	            ier_typ = ER_APPL
                    return
                  endif
	          is=0
	          do ipkt=1,npkt-1
	            xhe(is+1)=xpl(ipkt)
	            yhe(is+1)=ypl(ipkt)
	            xhe(is+2)=xpl(ipkt)+(xpl(ipkt+1)-xpl(ipkt))/2.0
	            yhe(is+2)=ypl(ipkt)
	            xhe(is+3)=xpl(ipkt)+(xpl(ipkt+1)-xpl(ipkt))/2.0
	            yhe(is+3)=ypl(ipkt+1)
	            xhe(is+4)=xpl(ipkt+1)
	            yhe(is+4)=ypl(ipkt+1)
	            is=is+4
	          enddo
	          call pline_kupl (is-4,xhe,yhe)
	        elseif (ilineart(ikurv).eq.3) then
	          if (npkt.gt.maxsp) then
                    ier_num = -13
	            ier_typ = ER_APPL
	            return
	          endif
	          call spline (xpl,ypl,npkt,1e30,1e30,y2a)
	          xst=max(xmin(ikurv),ex(iframe,1))
	          xen=min(xmax(ikurv),ex(iframe,2))
	          dxx=(xen-xst)/(5.0*maxsp)
	          is=1
	          do xxx=xst+dxx,xen-dxx,dxx
	            call splint (xpl,ypl,y2a,npkt,xxx,yyy)
	            xhe(is)=xxx
	            yhe(is)=yyy
	            is=is+1
	          enddo
	          call pline_kupl (is-1,xhe,yhe)
	        endif
	      endif
	    endif
	  endif	
    	  call ltyp_kupl (1,linewid(ikurv)) 
c
c-------- Markers
c
	  if(fform(ikurv).eq.'CR') then
	    do ipkt=1,len(ikurv)
	      iii  =(ikurv-1)*maxpkt+ipkt
	      fam =fama*sizemark(ikurv)
	      delx=dy(iii)*fam/(2.0*plmass(iframe))
	      dely=dy(iii)*fam/(2.0*plmass(iframe)*yskal(iframe))
	      xmark=x(iii)
	      ymark=y(iii)
	      iicol=int(dx(iii)/100)
	      iityp=int(dx(iii)-100.0*iicol)
	      call col_kupl (iicol)
	      call draw_marker_kupl (xmark,ymark,iityp,delx,dely)
	    enddo
	  else
	    if(imarktyp(ikurv).ne.0 .and. .not. lni(ikurv)) then
	      call col_kupl (imarkcol(ikurv))
	      do ipkt=1,len(ikurv)
	        xmark=x((ikurv-1)*maxpkt+ipkt)
	        ymark=y((ikurv-1)*maxpkt+ipkt)
	        call draw_marker_kupl (xmark,ymark, 
     &	                               imarktyp(ikurv),delx,dely)  
	      enddo
	    endif  
	  endif
c
c-------- Marker for maxima
c
	  if(imarkmax(ikurv).ne.0) then
	    call col_kupl (imarkcol(ikurv))
	    if (lni(ikurv)) then
	      call do_fmax_z (ikurv,wmax,ixm,iym,maxmax,ima)
	    else
	      call do_fmax_xy (ikurv,wmax,ixm,maxmax,ima)
	    endif
	    do ipkt=1,ima
	      if (.not.lni(ikurv)) iym(ipkt)=ixm(ipkt)
	      xma=x(ixm(ipkt))
	      yma=y(iym(ipkt))
	      call draw_marker_kupl (xma,yma,imarkmax(ikurv),delx,dely) 
	    enddo
	  endif  
c
c-------- Error bars
c
	  if(ierr(ikurv).ne.0 .and. .not.lni(ikurv)) then
	    do ipkt=1,len(ikurv)
	      xfehl=x((ikurv-1)*maxpkt+ipkt)
	      yfehl=y((ikurv-1)*maxpkt+ipkt)
	      call draw_error_kupl  ( xfehl,yfehl, 
     &	                             dx((ikurv-1)*maxpkt+ipkt),
     &	                             dy((ikurv-1)*maxpkt+ipkt),
     &	                             ierr(ikurv),delx,dely)
	    enddo
	  endif
c
c-------- Filenames
c
	  if(ifname(iframe)) then
	    text=fname(ikurv)
	    call col_kupl (ilinecol(ikurv))
	    xt=ex(iframe,2)-charhx
	    yt=ey(iframe,2)-ikurv*charhy
	    il=len_str(text)
	    if(il.gt.0 ) then
	      call text_kupl (xt,yt,text(1:il),if_right)
	    endif
	  endif
c
c-------- Possible legend
c
	  if(ilegend(ikurv).eq.1) then
	    text=clegend(ikurv)
	    xleg=ex(iframe,2)-0.5/plmass(iframe)
	    yleg=ey(iframe,2)-ikurv*charhy
	    if(ilinetyp(ikurv).ne.0) then
	      call col_kupl (ilinecol(ikurv))
	      call ltyp_kupl (ilinetyp(ikurv),linewid(ikurv)) 
	      xpl(1)=xleg-8.00*delx
	      ypl(1)=yleg
	      xpl(2)=xleg
	      ypl(2)=yleg
	      call pline_kupl (2,xpl,ypl)
	      xpl(1)=xleg
	      ypl(1)=yleg-dely
	      xpl(2)=xleg
	      ypl(2)=yleg+dely
	      call pline_kupl (2,xpl,ypl)
	      xpl(1)=xleg-8.00*delx
	      ypl(1)=yleg-dely
	      xpl(2)=xleg-8.00*delx
	      ypl(2)=yleg+dely
	      call pline_kupl (2,xpl,ypl)
	    endif
	    call col_kupl (imarkcol(ikurv))
	    call draw_marker_kupl (xleg-4.0*delx,yleg,
     &	                           imarktyp(ikurv),delx,dely)
	    call col_kupl (6)
	    xt=xleg-8.00*delx-0.5/plmass(iframe)
	    yt=yleg-charhy/3
	    il=len_str(text)
	    if(il.gt.0) then
	      call text_kupl (xt,yt,text(1:il),if_right) 
	    endif                        
	  endif                        
999	  continue
	enddo
c
c------ plot possible annotations
c
	call col_kupl(foncol(iframe,6))
	do iann=1,maxan
	  if (antext(iframe,iann)(1:3).ne.'OFF') then
	    il=len_str(antext(iframe,iann))
	    xt=anx(iframe,iann)
	    yt=any(iframe,iann)
	    if(il.gt.0 ) then
	      call text_kupl (xt,yt,antext(iframe,iann)(1:il),
     &	                      anjust(iframe,iann)) 
	    endif                        
	  endif
	enddo
c              
	end
c****7******************************************************************
	subroutine draw_error_kupl (px,py,pdx,pdy,ityp,delx,dely)
c+
c	Draws error bar at px,py with a size of delx, dely.
c-                                             
	implicit	none
c
	include		'kuplot.inc'
c
	real		xp(2),yp(2),eex(2),eey(2)
	real		px,py,pdx,pdy,delx,dely
	integer		ityp
	logical		inrect
c
	eex(1)=ex(iframe,1)
	eex(2)=ex(iframe,2)
	eey(1)=ey(iframe,1)
	eey(2)=ey(iframe,2)
c
	call col_kupl (6)
	if     (ityp.eq.0 .or. .not.inrect(eex,eey,px,py)) then
	  return
	elseif (ityp.eq.1) then    
	  xp(1)=px-pdx
	  yp(1)=py
	  xp(2)=px+pdx
	  yp(2)=py                       
	  call pline_kupl (2,xp,yp) 
	  xp(1)=px-pdx
	  yp(1)=py-dely
	  xp(2)=px-pdx
	  yp(2)=py+dely
	  call pline_kupl (2,xp,yp) 
	  xp(1)=px+pdx
	  yp(1)=py-dely
	  xp(2)=px+pdx
	  yp(2)=py+dely
	  call pline_kupl (2,xp,yp) 
	elseif (ityp.eq.2) then
	  xp(1)=px
	  yp(1)=py-pdy
	  xp(2)=px
	  yp(2)=py+pdy
	  call pline_kupl (2,xp,yp) 
	  xp(1)=px-delx
	  yp(1)=py-pdy
	  xp(2)=px+delx
	  yp(2)=py-pdy
	  call pline_kupl (2,xp,yp) 
	  xp(1)=px-delx
	  yp(1)=py+pdy
	  xp(2)=px+delx
	  yp(2)=py+pdy
	  call pline_kupl (2,xp,yp) 
	elseif (ityp.eq.3) then
	  xp(1)=px-pdx
	  yp(1)=py
	  xp(2)=px+pdx
	  yp(2)=py
	  call pline_kupl (2,xp,yp) 
	  xp(1)=px-pdx
	  yp(1)=py-dely
	  xp(2)=px-pdx
	  yp(2)=py+dely
	  call pline_kupl (2,xp,yp) 
	  xp(1)=px+pdx
	  yp(1)=py-dely
	  xp(2)=px+pdx
	  yp(2)=py+dely
	  call pline_kupl (2,xp,yp) 
	  xp(1)=px
	  yp(1)=py-pdy
	  xp(2)=px
	  yp(2)=py+pdy
	  call pline_kupl (2,xp,yp) 
	  xp(1)=px-delx
	  yp(1)=py-pdy
	  xp(2)=px+delx
	  yp(2)=py-pdy
	  call pline_kupl (2,xp,yp) 
	  xp(1)=px-delx
	  yp(1)=py+pdy
	  xp(2)=px+delx
	  yp(2)=py+pdy
	  call pline_kupl (2,xp,yp) 
 	endif	   
c         
	end
c****7******************************************************************
	subroutine draw_marker_kupl (px,py,ityp,delx,dely)
c+
c	Draws marker of typ ityp at px,py with size delx,dely
c-                                                                
	implicit	none
c
	include		'kuplot.inc'
c
	real		px,py,delx,dely
	real		xp(72),yp(72)
	real		eex(2),eey(2)
	integer		ityp
	logical		inrect
c
	eex(1)=ex(iframe,1)
	eex(2)=ex(iframe,2)
	eey(1)=ey(iframe,1)
	eey(2)=ey(iframe,2)
c
	if     (ityp.eq. 0  .or. .not.inrect(eex,eey,px,py)) then 
	  return
	elseif (ityp.eq. 1) then
	  xp(1) = px
	  yp(1) = py
	  xp(2) = px
	  yp(2) = py
	  call pline_kupl (2,xp,yp)
	elseif (ityp.eq. 2) then                
	  call circ_kupl (px,py,delx,dely,.false.)
	elseif (ityp.eq. 3) then                
	  call circ_kupl (px,py,delx,dely,.true.)
	elseif (ityp.eq. 4) then                
	  call rect_kupl (px,py,delx,dely,.false.)
	elseif (ityp.eq. 5) then                
	  call rect_kupl (px,py,delx,dely,.true.)
	elseif (ityp.eq. 6) then                
	  xp(1)=px-delx
	  yp(1)=py-dely
	  xp(2)=px+delx
	  yp(2)=py-dely
	  xp(3)=px
	  yp(3)=py+dely
	  xp(4)=px-delx
	  yp(4)=py-dely
	  call pline_kupl (4,xp,yp)
	elseif (ityp.eq. 7) then                
	  xp(1)=px-delx
	  yp(1)=py-dely
	  xp(2)=px+delx
	  yp(2)=py+dely
	  call pline_kupl (2,xp,yp)
	  xp(1)=px-delx
	  yp(1)=py+dely
	  xp(2)=px+delx
	  yp(2)=py-dely
	  call pline_kupl (2,xp,yp)
	elseif (ityp.eq. 8) then
	  xp(1)=px-delx
	  yp(1)=py
	  xp(2)=px+delx
	  yp(2)=py		
	  call pline_kupl (2,xp,yp)
	  xp(1)=px
	  yp(1)=py-dely
	  xp(2)=px
	  yp(2)=py+dely		
	  call pline_kupl (2,xp,yp)
	elseif (ityp.eq. 9) then		
	  xp(1)=px
	  yp(1)=py-6.0*dely
	  xp(2)=px
	  yp(2)=py		
	  call pline_kupl (2,xp,yp)
	elseif (ityp.eq.10) then		
	  xp(1)=px
	  yp(1)=ey(iframe,1)
	  xp(2)=px
	  yp(2)=py 
	  call pline_kupl (2,xp,yp)
	endif
	end          
c*****7*****************************************************************
	subroutine draw_contour_kupl (ik)
c+
c	Draw contour lines
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real		zm,zi,h
	integer		ik,ihp,ihl
c
	if (hlineart(ik).ne.2) then 
	  do ihp = 1,iho(iframe)
       	    call col_kupl (hlinecol(ik,ihp))
	    zm = z_min(iframe,ihp)
	    zi = z_inc(iframe,ihp)
	    if (hlinetyp(iframe,ihp).ne.0) then
	      call ltyp_kupl (hlinetyp(ik,ihp),linewid(ik))
	      do ihl = 1,nz(iframe,ihp)
	        h = zm + (ihl-1)*zi
	        call licont (h,ik)
	      enddo
	    endif
	  enddo
	endif
c
	end	
c****7******************************************************************
	logical function k_in_f(ik)
c+
c	Check if data set ik should be plotted in actual frame
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		ik,i
c
	k_in_f = .false.
	do i=1,maxkurvtot
	  k_in_f = k_in_f .or. (infra(iframe,i).eq.ik)
	enddo
c
	end
c*****7*****************************************************************
	subroutine real_str(zahl,czahl,il)
c-
c       umwandlung einer real-zahl in einen string
c-
	implicit	none
c
	character*(*)   czahl
	real		zahl
	integer         cfeld(132),il,i
c
	call FLOATSTR (zahl,cfeld,il)
c
	do i=1,il
	  czahl(i:i)=char(cfeld(i))
	enddo
c
	end
c*********************************************************************
 	subroutine do_screen (zeile,lp)
c+
c	Sets screen device (x11,tek,kerm,..)
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c
	integer		maxw
	parameter	(maxw=2)
c
	character*(*)	zeile
	character*200	cpara(maxw)
	integer		lpara(maxw)
	integer		ianz,lp
c
	call get_params(zeile,ianz,cpara,lpara,maxw,lp)
	if (ier_num.ne.0) return
c
c------ no parameters, give current setting
c
	if (ianz.eq.0) then
	  if (id_dev_screen.eq.x11) then
	    write (*,1000) 'X11'
	  elseif (id_dev_screen.eq.tek) then
	    if (itek_typ.eq.0) then
	      write (*,1000) 'TEK4014'
	    elseif (itek_typ.eq.1) then
	      write (*,1000) 'TEK4014, MSKERMIT color extensions'
	    elseif (itek_typ.eq.2) then
	      write (*,1000) 'TEK4014, COLOR XTERM extensions'
	    endif
	  endif
c
c------ otherwise set screen device
c
	elseif (ianz.eq.1) then
	  call do_cap(cpara(1))
	  if (cpara(1)(1:2).eq.'X1') then
	    id_dev_screen = x11
	  elseif (cpara(1)(1:2).eq.'TE') then
	    id_dev_screen = tek
	    itek_typ = 0
	  elseif (cpara(1)(1:2).eq.'KE') then
	    id_dev_screen = tek
	    itek_typ = 1
	  elseif (cpara(1)(1:2).eq.'XT') then
	    id_dev_screen = tek
	    itek_typ = 2
	  else
	    ier_num = -11
	    ier_typ = ER_APPL
	  endif
c
	else
	  ier_num = -6
	  ier_typ = ER_COMM
	endif
c
1000	format (' Current screen device : ',a)
	end
c*****7*****************************************************************
c
c 	modifizierte routinen aus dem lrz graphiksystem
c
c*****7*****************************************************************
      subroutine licont (s,ik)
c
c     das unterprogramm licont dient zur bestimmung der hoehen- bzw.
c     schichtlinie f(x,y)=s einer elementweise bilinearen funktion
c     f(x,y) ueber einem regulaeren gitter. diese funktion ist gegeben
c     durch die werte an den gitterpunkten x(i),y(j), i=1,..,m,j=1,..,n
c     die parameter sind ausfuehrlich beschrieben im graphikmanual ii
c
      parameter (lv=2000,lxl=500)
c
      integer    i,il,ilh,im,io,ioh,ir,irh,iu,iuh,iv(lv),
     *           i1,i2,j,km,lm,m1,np,n1,n,m
      real       f11,f12,f21,f22,ttt,xl(lxl),yl(lxl)
      real       eex(2),eey(2)
c
      include	'kuplot.inc'
c
      eex(1)=ex(iframe,1)
      eex(2)=ex(iframe,2)
      eey(1)=ey(iframe,1)
      eey(2)=ey(iframe,2)
c
c     kontrolle der eingabeparameter
c
      kf  = nx(1)*ny(1)
      m   = nx(ik)
      n   = ny(ik)
      m1  = nx(ik) - 1
      n1  = ny(ik) - 1
c
c     berechnung der vorzeichenwechsel von f(x,y) - s auf dem
c     y-gitter, abspeichern in iv. fuer j =2,...,n-1 gilt: zu y(j)
c     gehoeren iv(im) fuer im=iv(j-1)+1,...,iv(j)
c
      i1  = n
      if  (n1.lt.2)                                goto 60
      iv(1) = i1
      do  20  j=2,n1
          do  10  i=1,m1
              if  (z((ik-1)*kf+(i-1)*n+j)-s.ge.0. .or.
     *             z((ik-1)*kf+(i  )*n+j)-s.lt.0.     ) 
     *                                             goto 10
              if  (i1.ge.lv)                       goto 9002
              i1  = i1 + 1
              iv(i1) = i
   10         continue
          iv(j) = i1
   20     continue
c
c     suche geeigneten ausgangspunkt fuer hoehenlinie zuerst auf
c     dem rand
c
   60 il  = 1
      ir  = 1
      iu  = 1
      io  = 1
  100 np  = 0
c
c     linker rand
c
      if  (il.gt.n1)                               goto 120
      ilh = il
      km  = 0
      do  110  lm=ilh,n1
          il  = lm+1
          f21 = z((ik-1)*kf+lm)-s
          f22 = z((ik-1)*kf+lm+1)-s
          if  (f21.ge.0 .and. f22.lt.0)            goto 800
  110     continue
c
c     unterer rand
c
  120 if  (iu.gt.m1)                               goto 140
      iuh = iu
      lm  = 0
      do  130  km=iuh,m1
          iu  = km+1
          f12 = z((ik-1)*kf+(km-1)*n+1)-s
          f22 = z((ik-1)*kf+(km  )*n+1)-s
          if  (f12.lt.0 .and. f22.ge.0)            goto 850
  130     continue
c
c     rechter rand
c
  140 if  (ir.gt.n1)                               goto 160
      irh = ir
      km  = m
      do  150  lm=irh,n1
          ir  = lm+1
          f11 = z((ik-1)*kf+(m-1)*n+lm  )-s
          f12 = z((ik-1)*kf+(m-1)*n+lm+1)-s
          if  (f11.lt.0 .and. f12.ge.0)            goto 700
  150     continue
c
c     oberer rand
c
  160 if  (io.gt.m1)                               goto 180
      ioh = io
      lm  = n
      do  170  km=ioh,m1
          io  = km+1
          f11 = z((ik-1)*kf+(km-1)*n+  n)-s
          f21 = z((ik-1)*kf+(km  )*n+  n)-s
          if  (f21.lt.0 .and. f11.ge.0)            goto 750
  170     continue
c
c     suche im inneren
c
  180 if  (n1.lt.2)                                goto 9000
      do  190  j=2,n1
          i1  = iv(j-1)+1
          i2  = iv(j)
          if  (i2.lt.i1)                           goto 190
          do  185  i=i1,i2
              if  (iv(i).le.0)                     goto 185
                  km  = iv(i)
                  f12 = z((ik-1)*kf+(km-1)*n  +j)-s
                  f22 = z((ik-1)*kf+(km  )*n+  j)-s
                  lm  = j-1
                  goto 850
  185         continue
  190     continue
      goto 9000
c
c     betrachtet wird das gittersegment mit suedwest-ecke km,lm
c
c     eintritt von links
c
  300 f11 = f21
      f12 = f22
      f21 = z((ik-1)*kf+(km  )*n+lm  )-s
      f22 = z((ik-1)*kf+(km  )*n+lm+1)-s
      if  (f22)                                    310,320,320
  310 if  (f21)                                    750,800,800
  320 if  (f21)                                    330,850,850
  330 if  (f11+f12+f21+f22)                        750,850,850
c
c     eintritt von unten
c
  400 f11 = f12
      f21 = f22
      f12 = z((ik-1)*kf+(km-1)*n  +lm+1)-s
      f22 = z((ik-1)*kf+(km  )*n  +lm+1)-s
      if  (f12)                                    410,420,420
  410 if  (f22)                                    800,850,850
  420 if  (f22)                                    430,700,700
  430 if  (f11+f12+f21+f22)                        800,700,700
c
c     eintritt von rechts
c
  500 f21 = f11
      f22 = f12
      f11 = z((ik-1)*kf+(km-1)*n+lm  )-s
      f12 = z((ik-1)*kf+(km-1)*n+lm+1)-s
      if  (f11)                                    510,520,520
  510 if  (f12)                                    850,700,700
  520 if  (f12)                                    530,750,750
  530 if  (f11+f12+f21+f22)                        850,750,750
c
c     eintritt von oben
c
  600 f12 = f11
      f22 = f21
      f11 = z((ik-1)*kf+(km-1)*n  +lm)-s
      f21 = z((ik-1)*kf+(km  )*n  +lm)-s
      if  (f21)                                    610,620,620
  610 if  (f11)                                    700,750,750
  620 if  (f11)                                    630,800,800
  630 if  (f11+f12+f21+f22)                        700,800,800
c
c     austritt nach links
c
  700 np       = np+1
      xl(np)   = x((ik-1)*maxpkt+km)
      ttt      = f12/(f12-f11)
      yl(np)   = y((ik-1)*maxpkt+lm)*ttt+y((ik-1)*maxpkt+lm+1)*(1.-ttt)
      km       = km-1
      if  (km.eq.0)                                goto 900
      if  (np.lt.lxl)                              goto 500
      npkt=np
      call clip_array (eex,eey,xl,yl,npkt)
      if (npkt.gt.1) call pline_kupl (npkt,xl,yl)
      xl(1)    = xl(np)
      yl(1)    = yl(np)
      np        = 1
      goto 500
c
c     austritt nach unten
c
  750 np       = np+1
      yl(np)   = y((ik-1)*maxpkt+lm)
      ttt      = f21/(f21-f11)
      xl(np)   = x((ik-1)*maxpkt+km)*ttt+x((ik-1)*maxpkt+km+1)*(1.-ttt)
      lm       = lm-1
      if  (lm.eq.0)                                goto 900
      if  (np.lt.lxl)                              goto 600
      npkt=np
      call clip_array (eex,eey,xl,yl,npkt)
      if (npkt.gt.1) call pline_kupl (npkt,xl,yl)
      xl(1)    = xl(np)
      yl(1)    = yl(np)
      np        = 1
      goto 600
c
c     austritt nach rechts
c
  800 np       = np+1
      xl(np)   = x((ik-1)*maxpkt+km+1)
      ttt      = f22/(f22-f21)
      yl(np)   = y((ik-1)*maxpkt+lm)*ttt+y((ik-1)*maxpkt+lm+1)*(1.-ttt)
      km       = km+1
      if  (km.eq.m)                                goto 900
      if  (np.lt.lxl)                              goto 300
      npkt=np
      call clip_array (eex,eey,xl,yl,npkt)
      if (npkt.gt.1) call pline_kupl (npkt,xl,yl)
      xl(1)    = xl(np)
      yl(1)    = yl(np)
      np        = 1
      goto 300
c
c     austritt nach oben
c
  850 np       = np+1
      yl(np)   = y((ik-1)*maxpkt+lm+1)
      ttt      = f22/(f22-f12)
      xl(np)   = x((ik-1)*maxpkt+km)*ttt+x((ik-1)*maxpkt+km+1)*(1.-ttt)
      lm       = lm+1
      if  (lm.eq.n)                                goto 900
      if  (np.lt.lxl)                              goto 860
      npkt=np
      call clip_array (eex,eey,xl,yl,npkt)
      if (npkt.gt.1) call pline_kupl (npkt,xl,yl)
      xl(1)    = xl(np)
      yl(1)    = yl(np)
      np        = 1
c
c     eintrag loeschen
c
  860 if  (lm.eq.1)                                goto 400
      i1       = iv(lm-1)+1
      i2       = iv(lm)
      do  880  im=i1,i2
          if  (iv(im)-km)                          880,870,900
  870         iv (im) = 0
              goto 400
  880     continue
c
c     hoehenlinie komplett
c
  900 if  (np.gt.1)  then
        npkt=np
        call clip_array (eex,eey,xl,yl,npkt)
        if (npkt.gt.1) call pline_kupl (npkt,xl,yl)
      endif
      goto 100
c
c     regulaeres ende
c
 9000 ier = 0
      goto 9999
c
c     fehlerfaelle
c
 9002 ier = 2
c
 9999 return
      e n d
