c*****7*****************************************************************
	subroutine init_ps (filname)
c+
c	This is the device driver for POSTSCRIPT
c
c	Version : 1.0
c	Date    : 11 Oct 96
c
c	Author  : Th. Proffen  (proffen@rsc.anu.edu.au)
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'errlist.inc'
c 
	character*(*)	filname
	real		ps_xmax,ps_ymax
	real		fxmin,fymin,fxmax,fymax
	integer		i,bbxmin,bbymin,bbxmax,bbymax
c
	integer		len_str
c
	if (orient) then
	  ps_xmax = 7200
	  ps_ymax = 5040
	else
	  ps_xmax = 5040
	  ps_ymax = 7200
	endif
c
	fxmin = frame(1,1)
	fymin = frame(1,2)
	fxmax = frame(1,3)
	fymax = frame(1,4)
	if (iaf.gt.1) then
	  do i=2,iaf
	    fxmin = min(fxmin,frame(i,1))
	    fymin = min(fymin,frame(i,2))
	    fxmax = max(fxmax,frame(i,3))
	    fymax = max(fymax,frame(i,4))
	  enddo
	endif
	bbxmin  = 0.1 * ps_xmax * fxmin
	bbymin  = 0.1 * ps_ymax * fymin
	bbxmax  = 0.1 * ps_xmax * fxmax
	bbymax  = 0.1 * ps_ymax * fymax
c
	call oeffne (99,filname,'unknown',.false.)
	if (ier_num.ne.0) return
c
	write (*,4000) filname(1:len_str(filname))
c
	write (99,1000) bbxmin,bbymin,bbxmax,bbymax
	write (99,1100)
	write (99,2000)
	if (orient) then
	  write (99,3000) 
	endif
c
1000	format('%!PS-Adobe-2.0',/,
     &	       '%%Creator: KUPLOT 3.0',/,
     &	       '%%BoundingBox: ' 4(1x,i5),/,
     &	       '%%Pages: (atend)',/,
     &	       '%%EndComments')
1100	format('/kupldict 80 dict def',/,
     &	       'kupldict begin',/,
     &	       '/M {moveto} bind def',/,
     &	       '/L {lineto} bind def',/,
     &	       '/R {rmoveto} bind def',/,
     &	       '/V {rlineto} bind def',/,
     &	       '/vshift 0 def',/,
     &	       '/Lshow { currentpoint stroke M',/,
     &	       '  0 vshift R show } def',/,
     &	       '/Rshow { currentpoint stroke M',/,
     &	       '  dup stringwidth pop neg vshift R show } def',/,
     &	       '/Cshow { currentpoint stroke M',/,
     &	       '  dup stringwidth pop -2 div vshift R show } def',/,
     &	       'end',/,'%%EndProlog')
2000	format('kupldict begin',/,'gsave',/,
     &	       '50 50 translate',/,'0.1 0.1 scale')
3000	format('90 rotate',/,'0 -5040 translate')
4000	format(' ------ > Writing POSTSCRIPT plot to file ',A,' ..')
	end
c*****7*****************************************************************
	subroutine open_ps 
c+
c	oeffnen von ps
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		ps_xmax,ps_ymax
c
	if (orient) then
	  ps_xmax = 7200
	  ps_ymax = 5040
	else
	  ps_xmax = 5040
	  ps_ymax = 7200
	endif
c
	fakx   = (frame(iframe,3)-frame(iframe,1))*ps_xmax/(wxmax-wxmin)
	faky   = (frame(iframe,4)-frame(iframe,2))*ps_ymax/(wymax-wymin)
	shiftx = frame(iframe,1) * ps_xmax
	shifty = frame(iframe,2) * ps_ymax
	xnull  = wxmin
	ynull  = wymin
c
	end
c*****7*****************************************************************
	subroutine close_ps
c+
c	alles zu ende
c-
	implicit	none
c
	write (99,1000)
	close (99)
c
1000	format ('grestore',/,'end',/,'showpage',/'%%Trailer',/,
     &	        '%%Pages: 1')
	end
c*****7*****************************************************************
	subroutine col_ps (icol) 
c+
c	setzen der farbe
c-
	implicit	none
c
	character*12	rgbcol(6)
	integer		icol
c
	data		rgbcol 	/'1.0 0.0 0.0',
     &	    			 '0.0 1.0 0.0',
     &				 '0.0 0.0 1.0',
     &				 '1.0 0.0 1.0',
     &				 '1.0 1.0 0.0',
     &				 '0.0 0.0 0.0'/
c
	write (99,1000) rgbcol(icol)
c
1000	format (a12,1x,'setrgbcolor')
	end
c*****7*****************************************************************
	subroutine colrgb_ps (r,g,b) 
c+
c	setzen einer bel. rgb farbe
c-
	implicit	none
c
	real		r,g,b
c
	write (99,1000) r,g,b
c
1000	format (3(f3.1,1x),'setrgbcolor')
	end
c*****7*****************************************************************
	subroutine ltyp_ps (ityp,lwidth) 
c+
c	setzen linienattribut
c-
	implicit	none
c
	include 	'kuplot.inc'
c
	real		lwidth
	integer		ityp
c
	if (ityp.eq.1) then
	  write (99,1000)
	else
	  write (99,2000) (ityp-1)*30
	endif
	write (99,3000) (frame(iframe,3)-frame(iframe,1))*lwidth*10.0 
c
1000 	format ('[] 0 setdash')
2000	format ('[',i3,'] 0 setdash')
3000	format(f5.1,' setlinewidth')
	end
c*****7*****************************************************************
	subroutine fsize_ps (fsize,fid) 
c+
c	setzen fontgroesse
c-
	implicit	none
c
	include		'kuplot.inc'
c
	character*25	fid_name
	real		fak_pl,fak_pl_x,fak_pl_y
	real		ps_ch_x,ps_ch_y
	real		fsize
	integer		fid,isizefont
c
	fak_pl_x  = (frame(iframe,3)-frame(iframe,1))
	fak_pl_y  = (frame(iframe,4)-frame(iframe,2))
	fak_pl    = (fak_pl_x+fak_pl_y)/2.
	isizefont = nint(fsize * fak_pl)
	ps_ch_x   = isizefont*(6./10.)
	ps_ch_y   = isizefont*(1.)
	charhx = ps_ch_x / fakx
	charhy = ps_ch_y / faky
c
	if     (fid.eq.fid_times) then
	  fid_name = 'Times-Roman'
	elseif (fid.eq.fid_courier) then
	  fid_name = 'Courier'
	elseif (fid.eq.fid_symbol) then
	  fid_name = 'Symbol'
	elseif (fid.eq.fid_helvetica) then
	  fid_name = 'Helvetica'
	elseif (fid.eq.fid_times_b) then
	  fid_name = 'Times-Bold'
	elseif (fid.eq.fid_courier_b) then
	  fid_name = 'Courier-Bold'
	elseif (fid.eq.fid_symbol_b) then
	  fid_name = 'Symbol'
	elseif (fid.eq.fid_helvetica_b) then
	  fid_name = 'Helvetica-Bold'
	elseif (fid.eq.fid_times_i) then
	  fid_name = 'Times-italic'
	elseif (fid.eq.fid_courier_i) then
	  fid_name = 'Courier-Oblique'
	elseif (fid.eq.fid_symbol_i) then
	  fid_name = 'Symbol'
	elseif (fid.eq.fid_helvetica_i) then
	  fid_name = 'Helvetica-Oblique'
	elseif (fid.eq.fid_times_ib) then
	  fid_name = 'Times-BoldItalic'
	elseif (fid.eq.fid_courier_ib) then
	  fid_name = 'Courier-BoldOblique'
	elseif (fid.eq.fid_symbol_ib) then
	  fid_name = 'Symbol'
	elseif (fid.eq.fid_helvetica_ib) then
	  fid_name = 'Helvetica-BoldOblique'
	else
	  fid_name = 'Courier'
	endif	

	write (99,4000) fid_name,isizefont
c
4000	format('/',a25,' findfont ',i4,' scalefont setfont',/,
     &	       'newpath')
	end
c*****7*****************************************************************
	subroutine text_ps (xp,yp,text,jmode)
c+
c	zeichnen von text
c-
	implicit	none
c
	include		'kuplot.inc'
c
	character*(*)	text
	character*132	pstext
	real		xp,yp
	integer		ix,iy,jmode,il,ips,i
c
	integer		len_str
c
	ix = nint ((xp-xnull)*fakx+shiftx)	
	iy = nint ((yp-ynull)*faky+shifty)	
	write (99,1000) ix,iy
	il=len_str(text)
	ips=1
	do i=1,il
	  if((text(i:i).eq.'(') .or. (text(i:i).eq.')') .or.
     &	     (text(i:i).eq.char(92))) then
	    pstext(ips:ips)=char(92)
	    ips=ips+1
	  endif
	  pstext(ips:ips)=text(i:i)
	  ips=ips+1
	enddo
c
	if (jmode.lt.0) then
	  write (99,1500) 
	endif
c
	if (abs(jmode).eq.if_left) then
	  write(99,2000) pstext(1:ips-1)
	elseif (abs(jmode).eq.if_right) then
	  write(99,2100) pstext(1:ips-1)
	elseif (abs(jmode).eq.if_centre) then
	  write(99,2200) pstext(1:ips-1)
	else
	  write (*,*) '*** unbekannte textausrichtung ps ***'
	  write (*,*) '*** jmode = ', jmode
	endif
c
	if (jmode.lt.0) then
	  write (99,2500) 
	endif
c
	xp = (ips-1)*charhx
	yp = charhy
c
1000	format(i5,1x,i5,' M')
1500	format('currentpoint gsave translate 90 rotate 0 0 M')
2000	format('(',a,') Lshow')
2100	format('(',a,') Rshow')
2200	format('(',a,') Cshow')
2500	format('grestore')
c
	end
c*****7*****************************************************************
	subroutine pline_ps (npkt,xa,ya)
c+
c	polyline ..
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		npkt
	real		xa(npkt),ya(npkt)
	integer		ix,iy,i
c
	ix = nint ((xa(1)-xnull)*fakx+shiftx)	
	iy = nint ((ya(1)-ynull)*faky+shifty)	
	write (99,1000) ix,iy
	do i=1,npkt
	  ix = nint ((xa(i)-xnull)*fakx+shiftx)	
	  iy = nint ((ya(i)-ynull)*faky+shifty)	
	  write (99,2000) ix,iy
	enddo
	write (99,3000) 
c
1000	format(i5,1x,i5,' M')
2000	format(i5,1x,i5,' L')
3000	format('stroke')
	end
c*****7*****************************************************************
	subroutine circ_ps (px,py,delx,dely,fill)
c+
c	kreise ..
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real		px,py,delx,dely
	integer		ix,iy,idx,idy
	logical		fill
c
	ix  = nint ((px-xnull)*fakx+shiftx)	
	iy  = nint ((py-ynull)*faky+shifty)
	idx = nint (delx*fakx)	
	idy = nint (dely*faky)
c
	if (.not. fill) then
	  write (99,1000) ix,iy,idx
	else
	  write (99,2000) ix,iy,idx
	endif
c
1000	format(i5,1x,i5,1x,i5,' 0 360 arc',/,'stroke')
2000	format(i5,1x,i5,1x,i5,' 0 360 arc',/,'fill')
	end
c*****7*****************************************************************
	subroutine rect_ps (xlu,ylu,xro,yro,fill)
c+
c	rect ..
c-
	implicit	none
c
	include		'kuplot.inc'
c
	real		xlu,ylu,xro,yro
	integer		ixlu,iylu,ixro,iyro
	logical		fill
c
	ixlu = nint ((xlu-xnull)*fakx+shiftx)	
	iylu = nint ((ylu-ynull)*faky+shifty)
	ixro = nint ((xro-xnull)*fakx+shiftx)	
	iyro = nint ((yro-ynull)*faky+shifty)
c
	if (.not. fill) then
	  write (99,1000) ixlu,iylu,ixlu,iyro,ixro,iyro,ixro,iylu,
     &	                  ixlu,iylu
	else
	  write (99,2000) ixlu,iylu,ixlu,iyro,ixro,iyro,ixro,iylu,
     &	                  ixlu,iylu
	endif
c	
1000	format (i5,1x,i5,' M',/,4(i5,1x,i5,' L',/),'stroke')
2000	format (i5,1x,i5,' M',/,4(i5,1x,i5,' L',/),'fill')
	end
c*****7*****************************************************************
	subroutine area_ps (npkt,xp,yp,fill)
c+
c	area ..
c-
	implicit	none
c
	include		'kuplot.inc'
c
	integer		npkt
	real		xp(npkt),yp(npkt)
	logical		fill
c
	integer		ix(npkt),iy(npkt),i
c
        do i=1,npkt
          ix(i) = nint ((xp(i)-xnull)*fakx+shiftx)
          iy(i) = nint ((yp(i)-ynull)*faky+shifty)
        enddo
c
        if (fill) then
          write (99,2000) (ix(i),iy(i),i=1,npkt),ix(1),iy(1)
        else
          write (99,1000) (ix(i),iy(i),i=1,npkt),ix(1),iy(1)
        endif
c	
1000	format (i5,1x,i5,' M',/,4(i5,1x,i5,' L',/),'stroke')
2000	format (i5,1x,i5,' M',/,4(i5,1x,i5,' L',/),'fill')
	end
c*****7*****************************************************************
	subroutine bitmap_ps (ik)
c+
c	zeichen nipl-bitmap
c-
	implicit	none
c
	include		'kuplot.inc'
	include		'wink.inc'
c
	character*6	cc(2000)
	character*2	 c(2000)
	real		scx,scy,rdx,rdy
	real		zzmin,zzmax
	integer		ik,ix,iy,isy,izw,izwe,ikk,ii,kk
	integer		nx_min,nx_max,ny_min,ny_max
	integer		nx_out,ny_out,nx_inc,ny_inc
	integer		maxc
	logical		col
c
	col  = (abs(col_typ).eq.2)
	maxc = maxcol-1
c
	ix  = nint ((max(ex(iframe,1),xmin(ik))-xnull)*fakx+shiftx)	
	iy  = nint ((max(ey(iframe,1),ymin(ik))-ynull)*faky+shifty)
	if (ey(iframe,1).lt.ymin(ik)) then
	  isy = nint ((ey(iframe,1)-ynull)*faky)
	else
	  isy = nint ((ymin(ik)-ynull)*faky)
	endif
	scx=(min(ex(iframe,2),xmax(ik))-max(ex(iframe,1),xmin(ik)))*fakx
	scy=(min(ey(iframe,2),ymax(ik))-max(ey(iframe,1),ymin(ik)))*faky
        rdx=(xmax(ik)-xmin(ik))/float(nx(ik)-1)
        rdy=(ymax(ik)-ymin(ik))/float(ny(ik)-1)
        nx_min=nint(((max(xmin(ik),ex(iframe,1))-xmin(ik))/rdx))+1
        nx_max=nint(((min(xmax(ik),ex(iframe,2))-xmin(ik))/rdx))+1
        ny_min=nint(((max(ymin(ik),ey(iframe,1))-ymin(ik))/rdy))+1
        ny_max=nint(((min(ymax(ik),ey(iframe,2))-ymin(ik))/rdy))+1
	nx_out=nx_max-nx_min+1
	ny_out=ny_max-ny_min+1
	nx_inc=1
	ny_inc=1
c	
        if (x((ik-1)*maxpkt+1).gt.x((ik-1)*maxpkt+2)) then
          izw=nx_min
          nx_min=nx_max
          nx_max=izw
          nx_inc=-nx_inc
        endif
        if (y((ik-1)*maxpkt+1).gt.y((ik-1)*maxpkt+2)) then
          izw=ny_min
          ny_min=ny_max
          ny_max=izw
          ny_inc=-ny_inc
        endif
c
	if (nx_out.lt.1 .or. ny_out.lt.1) return
c
	write (99, 400)
c
	if (shear(iframe).ne.90.0) then
	  write (99,300) 1.0/tan(rad*shear(iframe)),
     &	                 -isy*1.0/tan(rad*shear(iframe))
	endif
	write (99, 500)  ix,iy,scx,scy
	write (99,1000)  nx_out,nx_out,ny_out,8,nx_out,0,0,ny_out,0,0
	if (col) then
	  write (99,1510)
	else
	  write (99,1500)
	endif
c
	zzmin=z_min(iframe,1)
	zzmax=nz(iframe,1)*z_inc(iframe,1)+z_min(iframe,1)
	do iy=ny_min,ny_max,ny_inc
	  do ix=nx_min,nx_max,nx_inc
	    ikk=(ik-1)*nx(1)*ny(1)+(ix-1)*ny(ik)+iy
	    if(z(ikk).eq.-9999. .or. z(ikk).lt.zzmin) then
	      izwe=maxc
	    elseif(z(ikk).ge.zzmax) then
	      izwe=0
	    else	
	      izwe=maxc-nint((z(ikk)-zzmin)*
     &	                    (float(maxc)/(zzmax-zzmin)))
	    endif
	    if (col) then
	      write(cc(ix),2000) 
     &	           (nint(float(maxc)*col_map((izwe+1),kk)),kk=1,3)
	      if (cc(ix)(1:1).eq.' ') cc(ix)(1:1)='0'
	      if (cc(ix)(3:3).eq.' ') cc(ix)(3:3)='0'
	      if (cc(ix)(5:5).eq.' ') cc(ix)(5:5)='0'
	    else
	      write(c(ix),2100) izwe
	      if (c(ix)(1:1).eq.' ')   c(ix)(1:1)='0'
	    endif
	  enddo
	  if (col) then
	    write(99,3100) (cc(ii),ii=nx_min,nx_max,nx_inc)
	  else
	    write(99,3000) (c(ii),ii=nx_min,nx_max,nx_inc)
	  endif
	enddo
	write(99,4000)
c
 400	format ('gsave')
 300	format ('[ 1 0 ',f12.6,' 1 ',f12.6,' 0 ] concat')
 500	format (i5,1x,i5,' translate',/,f10.3,1x,f10.3,' scale')
1000	format ('/DataString ',i5,' string def'/3(i3,1x),
     &          ' [ ',6(i3,1x),']'/'{'/
     &          '  currentfile DataString readhexstring pop } ')
1500	format ('image ')
1510	format ('false 3 ',/,'colorimage ')
2000	format (3z2)
2100	format (z2)
3000	format (30a2)
3100	format (10a6)
4000	format ('grestore')
	end
